/* gitg-convert.c generated by valac 0.56.18, the Vala compiler
 * generated from gitg-convert.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2015 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

VALA_EXTERN void gitg_convert_utf8_validate_fallback (gchar** text,
                                          gssize size);
VALA_EXTERN gchar* gitg_convert_convert_fallback (const gchar* text,
                                      gssize size,
                                      const gchar* fallback);
VALA_EXTERN gboolean gitg_convert_convert_and_check (const gchar* text,
                                         gssize size,
                                         const gchar* from_charset,
                                         gchar** ret);
VALA_EXTERN gchar* gitg_convert_utf8 (const gchar* str,
                          gssize size,
                          const gchar* from_charset);

void
gitg_convert_utf8_validate_fallback (gchar** text,
                                     gssize size)
{
	gchar* end = NULL;
#line 22 "../gitg/gitg-convert.vala"
	g_return_if_fail (*text != NULL);
#line 26 "../gitg/gitg-convert.vala"
	while (TRUE) {
#line 71 "gitg-convert.c"
		gchar* _tmp0_ = NULL;
		gboolean _tmp1_;
		gchar* _tmp2_;
#line 26 "../gitg/gitg-convert.vala"
		_tmp1_ = g_utf8_validate (*text, size, &_tmp0_);
#line 26 "../gitg/gitg-convert.vala"
		end = _tmp0_;
#line 26 "../gitg/gitg-convert.vala"
		if (!(!_tmp1_)) {
#line 26 "../gitg/gitg-convert.vala"
			break;
#line 83 "gitg-convert.c"
		}
#line 28 "../gitg/gitg-convert.vala"
		_tmp2_ = end;
#line 28 "../gitg/gitg-convert.vala"
		*_tmp2_ = '?';
#line 89 "gitg-convert.c"
	}
}

gchar*
gitg_convert_convert_fallback (const gchar* text,
                               gssize size,
                               const gchar* fallback)
{
	gchar* res = NULL;
	gchar* _tmp0_;
	gsize read = 0UL;
	GString* str = NULL;
	GString* _tmp1_;
	GString* _tmp10_;
	const gchar* _tmp11_;
	gchar* retval = NULL;
	GString* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	GString* _tmp15_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 32 "../gitg/gitg-convert.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 32 "../gitg/gitg-convert.vala"
	g_return_val_if_fail (fallback != NULL, NULL);
#line 34 "../gitg/gitg-convert.vala"
	_tmp0_ = g_strdup ("");
#line 34 "../gitg/gitg-convert.vala"
	res = _tmp0_;
#line 37 "../gitg/gitg-convert.vala"
	_tmp1_ = g_string_new ("");
#line 37 "../gitg/gitg-convert.vala"
	str = _tmp1_;
#line 39 "../gitg/gitg-convert.vala"
	while (TRUE) {
#line 126 "gitg-convert.c"
		{
			gchar* _tmp2_ = NULL;
			gsize _tmp3_ = 0UL;
			gchar* _tmp4_;
			gchar* _tmp5_;
#line 43 "../gitg/gitg-convert.vala"
			_tmp4_ = g_convert (text, size, "UTF-8", "ASCII", &_tmp3_, NULL, &_inner_error0_);
#line 43 "../gitg/gitg-convert.vala"
			read = _tmp3_;
#line 43 "../gitg/gitg-convert.vala"
			_tmp2_ = _tmp4_;
#line 43 "../gitg/gitg-convert.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 140 "gitg-convert.c"
				goto __catch0_g_error;
			}
#line 43 "../gitg/gitg-convert.vala"
			_tmp5_ = _tmp2_;
#line 43 "../gitg/gitg-convert.vala"
			_tmp2_ = NULL;
#line 43 "../gitg/gitg-convert.vala"
			_g_free0 (res);
#line 43 "../gitg/gitg-convert.vala"
			res = _tmp5_;
#line 44 "../gitg/gitg-convert.vala"
			_g_free0 (_tmp2_);
#line 44 "../gitg/gitg-convert.vala"
			break;
#line 155 "gitg-convert.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GString* _tmp9_;
#line 41 "../gitg/gitg-convert.vala"
			g_clear_error (&_inner_error0_);
#line 163 "gitg-convert.c"
			{
				gchar* _tmp6_ = NULL;
				gchar* _tmp7_;
				GString* _tmp8_;
#line 50 "../gitg/gitg-convert.vala"
				_tmp7_ = g_convert (text, (gssize) read, "UTF-8", "ASCII", NULL, NULL, &_inner_error0_);
#line 50 "../gitg/gitg-convert.vala"
				_tmp6_ = _tmp7_;
#line 50 "../gitg/gitg-convert.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "gitg-convert.c"
					goto __catch1_g_error;
				}
#line 50 "../gitg/gitg-convert.vala"
				_tmp8_ = str;
#line 50 "../gitg/gitg-convert.vala"
				g_string_append (_tmp8_, _tmp6_);
#line 48 "../gitg/gitg-convert.vala"
				_g_free0 (_tmp6_);
#line 183 "gitg-convert.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
#line 48 "../gitg/gitg-convert.vala"
				g_clear_error (&_inner_error0_);
#line 190 "gitg-convert.c"
			}
			__finally1:
#line 48 "../gitg/gitg-convert.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../gitg/gitg-convert.vala"
				_g_string_free0 (str);
#line 48 "../gitg/gitg-convert.vala"
				_g_free0 (res);
#line 48 "../gitg/gitg-convert.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../gitg/gitg-convert.vala"
				g_clear_error (&_inner_error0_);
#line 48 "../gitg/gitg-convert.vala"
				return NULL;
#line 205 "gitg-convert.c"
			}
#line 53 "../gitg/gitg-convert.vala"
			_tmp9_ = str;
#line 53 "../gitg/gitg-convert.vala"
			g_string_append (_tmp9_, fallback);
#line 55 "../gitg/gitg-convert.vala"
			text = (const gchar*) (((guint8*) text) + ((gint) (read + 1)));
#line 56 "../gitg/gitg-convert.vala"
			size = size - ((gssize) read);
#line 215 "gitg-convert.c"
		}
		__finally0:
#line 41 "../gitg/gitg-convert.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 41 "../gitg/gitg-convert.vala"
			_g_string_free0 (str);
#line 41 "../gitg/gitg-convert.vala"
			_g_free0 (res);
#line 41 "../gitg/gitg-convert.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 41 "../gitg/gitg-convert.vala"
			g_clear_error (&_inner_error0_);
#line 41 "../gitg/gitg-convert.vala"
			return NULL;
#line 230 "gitg-convert.c"
		}
	}
#line 60 "../gitg/gitg-convert.vala"
	_tmp10_ = str;
#line 60 "../gitg/gitg-convert.vala"
	_tmp11_ = res;
#line 60 "../gitg/gitg-convert.vala"
	g_string_append (_tmp10_, _tmp11_);
#line 62 "../gitg/gitg-convert.vala"
	_tmp12_ = str;
#line 62 "../gitg/gitg-convert.vala"
	_tmp13_ = _tmp12_->str;
#line 62 "../gitg/gitg-convert.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 62 "../gitg/gitg-convert.vala"
	retval = _tmp14_;
#line 63 "../gitg/gitg-convert.vala"
	_tmp15_ = str;
#line 63 "../gitg/gitg-convert.vala"
	gitg_convert_utf8_validate_fallback (&retval, _tmp15_->len);
#line 65 "../gitg/gitg-convert.vala"
	result = retval;
#line 65 "../gitg/gitg-convert.vala"
	_g_string_free0 (str);
#line 65 "../gitg/gitg-convert.vala"
	_g_free0 (res);
#line 65 "../gitg/gitg-convert.vala"
	return result;
#line 259 "gitg-convert.c"
}

gboolean
gitg_convert_convert_and_check (const gchar* text,
                                gssize size,
                                const gchar* from_charset,
                                gchar** ret)
{
	gchar* _vala_ret = NULL;
	gsize read = 0UL;
	gsize written = 0UL;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 68 "../gitg/gitg-convert.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 68 "../gitg/gitg-convert.vala"
	g_return_val_if_fail (from_charset != NULL, FALSE);
#line 72 "../gitg/gitg-convert.vala"
	_g_free0 (_vala_ret);
#line 72 "../gitg/gitg-convert.vala"
	_vala_ret = NULL;
#line 281 "gitg-convert.c"
	{
		gchar* _tmp0_ = NULL;
		gsize _tmp1_ = 0UL;
		gsize _tmp2_ = 0UL;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 76 "../gitg/gitg-convert.vala"
		_tmp3_ = g_convert (text, size, "UTF-8", from_charset, &_tmp1_, &_tmp2_, &_inner_error0_);
#line 76 "../gitg/gitg-convert.vala"
		read = _tmp1_;
#line 76 "../gitg/gitg-convert.vala"
		written = _tmp2_;
#line 76 "../gitg/gitg-convert.vala"
		_tmp0_ = _tmp3_;
#line 76 "../gitg/gitg-convert.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 298 "gitg-convert.c"
			goto __catch0_g_error;
		}
#line 76 "../gitg/gitg-convert.vala"
		_tmp4_ = _tmp0_;
#line 76 "../gitg/gitg-convert.vala"
		_tmp0_ = NULL;
#line 76 "../gitg/gitg-convert.vala"
		_g_free0 (_vala_ret);
#line 76 "../gitg/gitg-convert.vala"
		_vala_ret = _tmp4_;
#line 78 "../gitg/gitg-convert.vala"
		if (read == ((gsize) size)) {
#line 80 "../gitg/gitg-convert.vala"
			gitg_convert_utf8_validate_fallback (&_vala_ret, (gssize) written);
#line 81 "../gitg/gitg-convert.vala"
			result = TRUE;
#line 81 "../gitg/gitg-convert.vala"
			_g_free0 (_tmp0_);
#line 81 "../gitg/gitg-convert.vala"
			if (ret) {
#line 81 "../gitg/gitg-convert.vala"
				*ret = _vala_ret;
#line 321 "gitg-convert.c"
			} else {
#line 81 "../gitg/gitg-convert.vala"
				_g_free0 (_vala_ret);
#line 325 "gitg-convert.c"
			}
#line 81 "../gitg/gitg-convert.vala"
			return result;
#line 329 "gitg-convert.c"
		}
#line 74 "../gitg/gitg-convert.vala"
		_g_free0 (_tmp0_);
#line 333 "gitg-convert.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 74 "../gitg/gitg-convert.vala"
		g_clear_error (&_inner_error0_);
#line 340 "gitg-convert.c"
	}
	__finally0:
#line 74 "../gitg/gitg-convert.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 345 "gitg-convert.c"
		gboolean _tmp5_ = FALSE;
#line 74 "../gitg/gitg-convert.vala"
		_g_free0 (_vala_ret);
#line 74 "../gitg/gitg-convert.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 74 "../gitg/gitg-convert.vala"
		g_clear_error (&_inner_error0_);
#line 74 "../gitg/gitg-convert.vala"
		return _tmp5_;
#line 355 "gitg-convert.c"
	}
#line 86 "../gitg/gitg-convert.vala"
	result = FALSE;
#line 86 "../gitg/gitg-convert.vala"
	if (ret) {
#line 86 "../gitg/gitg-convert.vala"
		*ret = _vala_ret;
#line 363 "gitg-convert.c"
	} else {
#line 86 "../gitg/gitg-convert.vala"
		_g_free0 (_vala_ret);
#line 367 "gitg-convert.c"
	}
#line 86 "../gitg/gitg-convert.vala"
	return result;
#line 371 "gitg-convert.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 398 "gitg-convert.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 404 "gitg-convert.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 410 "gitg-convert.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 414 "gitg-convert.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 422 "gitg-convert.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 426 "gitg-convert.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 438 "gitg-convert.c"
}

gchar*
gitg_convert_utf8 (const gchar* str,
                   gssize size,
                   const gchar* from_charset)
{
	gchar* locale_charset = NULL;
	const gchar* _tmp6_ = NULL;
	gboolean _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp12_;
	gchar* result;
#line 90 "../gitg/gitg-convert.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 92 "../gitg/gitg-convert.vala"
	if (size == ((gssize) -1)) {
#line 456 "gitg-convert.c"
		gint _tmp0_;
		gint _tmp1_;
#line 94 "../gitg/gitg-convert.vala"
		_tmp0_ = strlen (str);
#line 94 "../gitg/gitg-convert.vala"
		_tmp1_ = _tmp0_;
#line 94 "../gitg/gitg-convert.vala"
		size = (gssize) _tmp1_;
#line 465 "gitg-convert.c"
	}
#line 97 "../gitg/gitg-convert.vala"
	if (from_charset == NULL) {
#line 99 "../gitg/gitg-convert.vala"
		if (g_utf8_validate (str, size, NULL)) {
#line 471 "gitg-convert.c"
			gchar* _tmp2_;
#line 101 "../gitg/gitg-convert.vala"
			_tmp2_ = string_slice (str, (glong) 0, (glong) size);
#line 101 "../gitg/gitg-convert.vala"
			result = _tmp2_;
#line 101 "../gitg/gitg-convert.vala"
			return result;
#line 479 "gitg-convert.c"
		}
	} else {
		gchar* ret = NULL;
		gchar* _tmp4_ = NULL;
		gboolean _tmp5_;
#line 108 "../gitg/gitg-convert.vala"
		if (g_ascii_strcasecmp (from_charset, "UTF-8") == 0) {
#line 487 "gitg-convert.c"
			gchar* _tmp3_;
#line 110 "../gitg/gitg-convert.vala"
			_tmp3_ = string_slice (str, (glong) 0, (glong) size);
#line 110 "../gitg/gitg-convert.vala"
			_g_free0 (ret);
#line 110 "../gitg/gitg-convert.vala"
			ret = _tmp3_;
#line 111 "../gitg/gitg-convert.vala"
			gitg_convert_utf8_validate_fallback (&ret, size);
#line 113 "../gitg/gitg-convert.vala"
			result = ret;
#line 113 "../gitg/gitg-convert.vala"
			return result;
#line 501 "gitg-convert.c"
		}
#line 116 "../gitg/gitg-convert.vala"
		_tmp5_ = gitg_convert_convert_and_check (str, size, from_charset, &_tmp4_);
#line 116 "../gitg/gitg-convert.vala"
		_g_free0 (ret);
#line 116 "../gitg/gitg-convert.vala"
		ret = _tmp4_;
#line 116 "../gitg/gitg-convert.vala"
		if (_tmp5_) {
#line 118 "../gitg/gitg-convert.vala"
			result = ret;
#line 118 "../gitg/gitg-convert.vala"
			return result;
#line 515 "gitg-convert.c"
		}
#line 97 "../gitg/gitg-convert.vala"
		_g_free0 (ret);
#line 519 "gitg-convert.c"
	}
#line 124 "../gitg/gitg-convert.vala"
	_tmp7_ = g_get_charset (&_tmp6_);
#line 124 "../gitg/gitg-convert.vala"
	_g_free0 (locale_charset);
#line 124 "../gitg/gitg-convert.vala"
	_tmp8_ = g_strdup (_tmp6_);
#line 124 "../gitg/gitg-convert.vala"
	locale_charset = _tmp8_;
#line 124 "../gitg/gitg-convert.vala"
	if (!_tmp7_) {
#line 531 "gitg-convert.c"
		gchar* ret = NULL;
		const gchar* _tmp9_;
		gchar* _tmp10_ = NULL;
		gboolean _tmp11_;
#line 128 "../gitg/gitg-convert.vala"
		_tmp9_ = locale_charset;
#line 128 "../gitg/gitg-convert.vala"
		_tmp11_ = gitg_convert_convert_and_check (str, size, _tmp9_, &_tmp10_);
#line 128 "../gitg/gitg-convert.vala"
		_g_free0 (ret);
#line 128 "../gitg/gitg-convert.vala"
		ret = _tmp10_;
#line 128 "../gitg/gitg-convert.vala"
		if (_tmp11_) {
#line 130 "../gitg/gitg-convert.vala"
			result = ret;
#line 130 "../gitg/gitg-convert.vala"
			_g_free0 (locale_charset);
#line 130 "../gitg/gitg-convert.vala"
			return result;
#line 552 "gitg-convert.c"
		}
#line 124 "../gitg/gitg-convert.vala"
		_g_free0 (ret);
#line 556 "gitg-convert.c"
	}
#line 134 "../gitg/gitg-convert.vala"
	_tmp12_ = gitg_convert_convert_fallback (str, size, "?");
#line 134 "../gitg/gitg-convert.vala"
	result = _tmp12_;
#line 134 "../gitg/gitg-convert.vala"
	_g_free0 (locale_charset);
#line 134 "../gitg/gitg-convert.vala"
	return result;
#line 566 "gitg-convert.c"
}

