/* gitg-ext-message-id.c generated by valac 0.56.18, the Vala compiler
 * generated from gitg-ext-message-id.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2012 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgitg-ext.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GITG_EXT_MESSAGE_ID_0_PROPERTY,
	GITG_EXT_MESSAGE_ID_OBJECT_PATH_PROPERTY,
	GITG_EXT_MESSAGE_ID_METHOD_PROPERTY,
	GITG_EXT_MESSAGE_ID_ID_PROPERTY,
	GITG_EXT_MESSAGE_ID_NUM_PROPERTIES
};
static GParamSpec* gitg_ext_message_id_properties[GITG_EXT_MESSAGE_ID_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GitgExtMessageIdPrivate {
	gchar* _object_path;
	gchar* _method;
};

static gint GitgExtMessageId_private_offset;
static gpointer gitg_ext_message_id_parent_class = NULL;

static void gitg_ext_message_id_finalize (GObject * obj);
static GType gitg_ext_message_id_get_type_once (void);
static void _vala_gitg_ext_message_id_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_gitg_ext_message_id_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
gitg_ext_message_id_get_instance_private (GitgExtMessageId* self)
{
	return G_STRUCT_MEMBER_P (self, GitgExtMessageId_private_offset);
}

/**
 * Message hash.
 *
 * Get a hash for the message identifier suitable for use in a hash table.
 * The hash is simply a string hash of the full id of the message identifier.
 *
 * @return the message identifier hash.
 *
 */
guint
gitg_ext_message_id_hash (GitgExtMessageId* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint _tmp3_;
	guint result;
#line 74 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 76 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp0_ = gitg_ext_message_id_get_id (self);
#line 76 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp1_ = _tmp0_;
#line 76 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp2_ = _tmp1_;
#line 76 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp3_ = g_str_hash (_tmp2_);
#line 76 "../libgitg-ext/gitg-ext-message-id.vala"
	_g_free0 (_tmp2_);
#line 76 "../libgitg-ext/gitg-ext-message-id.vala"
	result = _tmp3_;
#line 76 "../libgitg-ext/gitg-ext-message-id.vala"
	return result;
#line 107 "gitg-ext-message-id.c"
}

/**
 * Compare two messages for equality.
 *
 * Compare two messages. Two message identifiers are equal when they have
 * the same object path and the same method name.
 *
 * @param other the message identifier to compare to.
 *
 * @return true if the message identifiers are equal, false otherwise.
 *
 */
gboolean
gitg_ext_message_id_equal (GitgExtMessageId* self,
                           GitgExtMessageId* other)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
	gboolean result;
#line 90 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 90 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 92 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp0_ = gitg_ext_message_id_get_id (self);
#line 92 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp1_ = _tmp0_;
#line 92 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp2_ = _tmp1_;
#line 92 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp3_ = gitg_ext_message_id_get_id (other);
#line 92 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp4_ = _tmp3_;
#line 92 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp5_ = _tmp4_;
#line 92 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp6_ = g_strcmp0 (_tmp2_, _tmp5_) == 0;
#line 92 "../libgitg-ext/gitg-ext-message-id.vala"
	_g_free0 (_tmp5_);
#line 92 "../libgitg-ext/gitg-ext-message-id.vala"
	_g_free0 (_tmp2_);
#line 92 "../libgitg-ext/gitg-ext-message-id.vala"
	result = _tmp6_;
#line 92 "../libgitg-ext/gitg-ext-message-id.vala"
	return result;
#line 159 "gitg-ext-message-id.c"
}

/**
 * Construct message identifier with object path and method.
 *
 * Create a new message identifier object with the given object path and
 * method name.
 *
 * @param object_path the object path
 * @param method the method name
 *
 * @return a new message identifier.
 *
 */
GitgExtMessageId*
gitg_ext_message_id_construct (GType object_type,
                               const gchar* object_path,
                               const gchar* method)
{
	GitgExtMessageId * self = NULL;
#line 107 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_val_if_fail (object_path != NULL, NULL);
#line 107 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_val_if_fail (method != NULL, NULL);
#line 109 "../libgitg-ext/gitg-ext-message-id.vala"
	self = (GitgExtMessageId*) g_object_new (object_type, "object-path", object_path, "method", method, NULL);
#line 107 "../libgitg-ext/gitg-ext-message-id.vala"
	return self;
#line 188 "gitg-ext-message-id.c"
}

GitgExtMessageId*
gitg_ext_message_id_new (const gchar* object_path,
                         const gchar* method)
{
#line 107 "../libgitg-ext/gitg-ext-message-id.vala"
	return gitg_ext_message_id_construct (GITG_EXT_TYPE_MESSAGE_ID, object_path, method);
#line 197 "gitg-ext-message-id.c"
}

/**
 * Create a copy of the message identifier.
 *
 * Create an exact copy of the message identifier.
 *
 * @return a new message identifier.
 *
 */
GitgExtMessageId*
gitg_ext_message_id_copy (GitgExtMessageId* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GitgExtMessageId* _tmp2_;
	GitgExtMessageId* result;
#line 120 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 122 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp0_ = self->priv->_object_path;
#line 122 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp1_ = self->priv->_method;
#line 122 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp2_ = gitg_ext_message_id_new (_tmp0_, _tmp1_);
#line 122 "../libgitg-ext/gitg-ext-message-id.vala"
	result = _tmp2_;
#line 122 "../libgitg-ext/gitg-ext-message-id.vala"
	return result;
#line 227 "gitg-ext-message-id.c"
}

/**
 * Check whether an object path is a valid path.
 *
 * Check whether the given path is a valid object path. A valid object path
 * starts with a forward slash, followed by at least one alpha character,
 * or underscore. Further valid characters include alphanumeric characters,
 * underscores or path separators (forward slash).
 *
 * Example: /path/to/object
 *
 * @return true if the specified path is valid, false otherwise
 *
 */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 257 "gitg-ext-message-id.c"
}

gboolean
gitg_ext_message_id_valid_object_path (const gchar* path)
{
	gint i = 0;
	gboolean result;
#line 138 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 140 "../libgitg-ext/gitg-ext-message-id.vala"
	if (path == NULL) {
#line 142 "../libgitg-ext/gitg-ext-message-id.vala"
		result = FALSE;
#line 142 "../libgitg-ext/gitg-ext-message-id.vala"
		return result;
#line 273 "gitg-ext-message-id.c"
	}
#line 145 "../libgitg-ext/gitg-ext-message-id.vala"
	if (string_get (path, (glong) 0) != '/') {
#line 147 "../libgitg-ext/gitg-ext-message-id.vala"
		result = FALSE;
#line 147 "../libgitg-ext/gitg-ext-message-id.vala"
		return result;
#line 281 "gitg-ext-message-id.c"
	}
#line 150 "../libgitg-ext/gitg-ext-message-id.vala"
	i = 0;
#line 152 "../libgitg-ext/gitg-ext-message-id.vala"
	while (TRUE) {
#line 287 "gitg-ext-message-id.c"
		gint _tmp0_;
		gint _tmp1_;
		gchar c = '\0';
		gint _tmp8_;
#line 152 "../libgitg-ext/gitg-ext-message-id.vala"
		_tmp0_ = strlen (path);
#line 152 "../libgitg-ext/gitg-ext-message-id.vala"
		_tmp1_ = _tmp0_;
#line 152 "../libgitg-ext/gitg-ext-message-id.vala"
		if (!(i < _tmp1_)) {
#line 152 "../libgitg-ext/gitg-ext-message-id.vala"
			break;
#line 300 "gitg-ext-message-id.c"
		}
#line 154 "../libgitg-ext/gitg-ext-message-id.vala"
		c = string_get (path, (glong) i);
#line 156 "../libgitg-ext/gitg-ext-message-id.vala"
		if (c == '/') {
#line 306 "gitg-ext-message-id.c"
			gint _tmp2_;
			gboolean _tmp3_ = FALSE;
			gint _tmp4_;
			gint _tmp5_;
#line 158 "../libgitg-ext/gitg-ext-message-id.vala"
			i = i + 1;
#line 158 "../libgitg-ext/gitg-ext-message-id.vala"
			_tmp2_ = i;
#line 160 "../libgitg-ext/gitg-ext-message-id.vala"
			_tmp4_ = strlen (path);
#line 160 "../libgitg-ext/gitg-ext-message-id.vala"
			_tmp5_ = _tmp4_;
#line 160 "../libgitg-ext/gitg-ext-message-id.vala"
			if (i == _tmp5_) {
#line 160 "../libgitg-ext/gitg-ext-message-id.vala"
				_tmp3_ = TRUE;
#line 323 "gitg-ext-message-id.c"
			} else {
				gboolean _tmp6_ = FALSE;
#line 160 "../libgitg-ext/gitg-ext-message-id.vala"
				if (g_ascii_isalpha (c)) {
#line 160 "../libgitg-ext/gitg-ext-message-id.vala"
					_tmp6_ = TRUE;
#line 330 "gitg-ext-message-id.c"
				} else {
#line 160 "../libgitg-ext/gitg-ext-message-id.vala"
					_tmp6_ = c == '_';
#line 334 "gitg-ext-message-id.c"
				}
#line 160 "../libgitg-ext/gitg-ext-message-id.vala"
				_tmp3_ = !_tmp6_;
#line 338 "gitg-ext-message-id.c"
			}
#line 160 "../libgitg-ext/gitg-ext-message-id.vala"
			if (_tmp3_) {
#line 162 "../libgitg-ext/gitg-ext-message-id.vala"
				result = FALSE;
#line 162 "../libgitg-ext/gitg-ext-message-id.vala"
				return result;
#line 346 "gitg-ext-message-id.c"
			}
		} else {
			gboolean _tmp7_ = FALSE;
#line 165 "../libgitg-ext/gitg-ext-message-id.vala"
			if (g_ascii_isalnum (c)) {
#line 165 "../libgitg-ext/gitg-ext-message-id.vala"
				_tmp7_ = TRUE;
#line 354 "gitg-ext-message-id.c"
			} else {
#line 165 "../libgitg-ext/gitg-ext-message-id.vala"
				_tmp7_ = c == '_';
#line 358 "gitg-ext-message-id.c"
			}
#line 165 "../libgitg-ext/gitg-ext-message-id.vala"
			if (!_tmp7_) {
#line 167 "../libgitg-ext/gitg-ext-message-id.vala"
				result = FALSE;
#line 167 "../libgitg-ext/gitg-ext-message-id.vala"
				return result;
#line 366 "gitg-ext-message-id.c"
			}
		}
#line 170 "../libgitg-ext/gitg-ext-message-id.vala"
		i = i + 1;
#line 170 "../libgitg-ext/gitg-ext-message-id.vala"
		_tmp8_ = i;
#line 373 "gitg-ext-message-id.c"
	}
#line 173 "../libgitg-ext/gitg-ext-message-id.vala"
	result = TRUE;
#line 173 "../libgitg-ext/gitg-ext-message-id.vala"
	return result;
#line 379 "gitg-ext-message-id.c"
}

const gchar*
gitg_ext_message_id_get_object_path (GitgExtMessageId* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp0_ = self->priv->_object_path;
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
	result = _tmp0_;
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
	return result;
#line 395 "gitg-ext-message-id.c"
}

void
gitg_ext_message_id_set_object_path (GitgExtMessageId* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_if_fail (self != NULL);
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
	old_value = gitg_ext_message_id_get_object_path (self);
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 409 "gitg-ext-message-id.c"
		gchar* _tmp0_;
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
		_tmp0_ = g_strdup (value);
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
		_g_free0 (self->priv->_object_path);
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
		self->priv->_object_path = _tmp0_;
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_ext_message_id_properties[GITG_EXT_MESSAGE_ID_OBJECT_PATH_PROPERTY]);
#line 419 "gitg-ext-message-id.c"
	}
}

const gchar*
gitg_ext_message_id_get_method (GitgExtMessageId* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp0_ = self->priv->_method;
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
	result = _tmp0_;
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
	return result;
#line 436 "gitg-ext-message-id.c"
}

void
gitg_ext_message_id_set_method (GitgExtMessageId* self,
                                const gchar* value)
{
	gchar* old_value;
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_if_fail (self != NULL);
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
	old_value = gitg_ext_message_id_get_method (self);
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 450 "gitg-ext-message-id.c"
		gchar* _tmp0_;
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
		_tmp0_ = g_strdup (value);
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
		_g_free0 (self->priv->_method);
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
		self->priv->_method = _tmp0_;
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_ext_message_id_properties[GITG_EXT_MESSAGE_ID_METHOD_PROPERTY]);
#line 460 "gitg-ext-message-id.c"
	}
}

gchar*
gitg_ext_message_id_get_id (GitgExtMessageId* self)
{
	gchar* result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 62 "../libgitg-ext/gitg-ext-message-id.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp0_ = self->priv->_object_path;
#line 62 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp1_ = g_strconcat (_tmp0_, ".", NULL);
#line 62 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp2_ = _tmp1_;
#line 62 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp3_ = self->priv->_method;
#line 62 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
#line 62 "../libgitg-ext/gitg-ext-message-id.vala"
	_tmp5_ = _tmp4_;
#line 62 "../libgitg-ext/gitg-ext-message-id.vala"
	_g_free0 (_tmp2_);
#line 62 "../libgitg-ext/gitg-ext-message-id.vala"
	result = _tmp5_;
#line 62 "../libgitg-ext/gitg-ext-message-id.vala"
	return result;
#line 494 "gitg-ext-message-id.c"
}

static void
gitg_ext_message_id_class_init (GitgExtMessageIdClass * klass,
                                gpointer klass_data)
{
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	gitg_ext_message_id_parent_class = g_type_class_peek_parent (klass);
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	g_type_class_adjust_private_offset (klass, &GitgExtMessageId_private_offset);
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_ext_message_id_get_property;
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_ext_message_id_set_property;
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_ext_message_id_finalize;
#line 511 "gitg-ext-message-id.c"
	/**
	 * Message object path.
	 */
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_EXT_MESSAGE_ID_OBJECT_PATH_PROPERTY, gitg_ext_message_id_properties[GITG_EXT_MESSAGE_ID_OBJECT_PATH_PROPERTY] = g_param_spec_string ("object-path", "object-path", "object-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 517 "gitg-ext-message-id.c"
	/**
	 * Message method.
	 */
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_EXT_MESSAGE_ID_METHOD_PROPERTY, gitg_ext_message_id_properties[GITG_EXT_MESSAGE_ID_METHOD_PROPERTY] = g_param_spec_string ("method", "method", "method", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 523 "gitg-ext-message-id.c"
	/**
	 * Full id of the message.
	 *
	 * Get the full id of the message identifier. The full id is simply
	 * <path>.<method>
	 *
	 */
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_EXT_MESSAGE_ID_ID_PROPERTY, gitg_ext_message_id_properties[GITG_EXT_MESSAGE_ID_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 533 "gitg-ext-message-id.c"
}

static void
gitg_ext_message_id_instance_init (GitgExtMessageId * self,
                                   gpointer klass)
{
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	self->priv = gitg_ext_message_id_get_instance_private (self);
#line 542 "gitg-ext-message-id.c"
}

static void
gitg_ext_message_id_finalize (GObject * obj)
{
	GitgExtMessageId * self;
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_EXT_TYPE_MESSAGE_ID, GitgExtMessageId);
#line 46 "../libgitg-ext/gitg-ext-message-id.vala"
	_g_free0 (self->priv->_object_path);
#line 51 "../libgitg-ext/gitg-ext-message-id.vala"
	_g_free0 (self->priv->_method);
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	G_OBJECT_CLASS (gitg_ext_message_id_parent_class)->finalize (obj);
#line 557 "gitg-ext-message-id.c"
}

/**
 * Message identifier object.
 *
 * The message identifier object is used to identify messages sent over the
 * MessageBus. The message identifier contains an object path and a method.
 * Both are simple strings and combined describe the location of a message as
 * a kind of method on an object.
 *
 * Valid object paths start with a forward slash and further path elements are
 * seperated by more forward slashes. The first element needs to start with
 * an alpha character (or underscore) while further characters can be
 * alpha numeric or underscores. An example of a valid path is:
 *
 * /path/to/object
 *
 * Method names on the other hand do not have any restrictions.
 *
 */
 G_GNUC_NO_INLINE static GType
gitg_ext_message_id_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GitgExtMessageIdClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_ext_message_id_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgExtMessageId), 0, (GInstanceInitFunc) gitg_ext_message_id_instance_init, NULL };
	GType gitg_ext_message_id_type_id;
	gitg_ext_message_id_type_id = g_type_register_static (G_TYPE_OBJECT, "GitgExtMessageId", &g_define_type_info, 0);
	GitgExtMessageId_private_offset = g_type_add_instance_private (gitg_ext_message_id_type_id, sizeof (GitgExtMessageIdPrivate));
	return gitg_ext_message_id_type_id;
}

GType
gitg_ext_message_id_get_type (void)
{
	static gsize gitg_ext_message_id_type_id__once = 0;
	if (g_once_init_enter (&gitg_ext_message_id_type_id__once)) {
		GType gitg_ext_message_id_type_id;
		gitg_ext_message_id_type_id = gitg_ext_message_id_get_type_once ();
		g_once_init_leave (&gitg_ext_message_id_type_id__once, gitg_ext_message_id_type_id);
	}
	return gitg_ext_message_id_type_id__once;
}

static void
_vala_gitg_ext_message_id_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	GitgExtMessageId * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_EXT_TYPE_MESSAGE_ID, GitgExtMessageId);
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	switch (property_id) {
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		case GITG_EXT_MESSAGE_ID_OBJECT_PATH_PROPERTY:
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		g_value_set_string (value, gitg_ext_message_id_get_object_path (self));
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		break;
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		case GITG_EXT_MESSAGE_ID_METHOD_PROPERTY:
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		g_value_set_string (value, gitg_ext_message_id_get_method (self));
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		break;
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		case GITG_EXT_MESSAGE_ID_ID_PROPERTY:
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		g_value_take_string (value, gitg_ext_message_id_get_id (self));
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		break;
#line 628 "gitg-ext-message-id.c"
		default:
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		break;
#line 634 "gitg-ext-message-id.c"
	}
}

static void
_vala_gitg_ext_message_id_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	GitgExtMessageId * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_EXT_TYPE_MESSAGE_ID, GitgExtMessageId);
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
	switch (property_id) {
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		case GITG_EXT_MESSAGE_ID_OBJECT_PATH_PROPERTY:
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		gitg_ext_message_id_set_object_path (self, g_value_get_string (value));
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		break;
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		case GITG_EXT_MESSAGE_ID_METHOD_PROPERTY:
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		gitg_ext_message_id_set_method (self, g_value_get_string (value));
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		break;
#line 660 "gitg-ext-message-id.c"
		default:
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../libgitg-ext/gitg-ext-message-id.vala"
		break;
#line 666 "gitg-ext-message-id.c"
	}
}

