/* gitg-authentication-dialog.c generated by valac 0.56.18, the Vala compiler
 * generated from gitg-authentication-dialog.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2014 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgitg.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GITG_AUTHENTICATION_DIALOG_0_PROPERTY,
	GITG_AUTHENTICATION_DIALOG_USERNAME_PROPERTY,
	GITG_AUTHENTICATION_DIALOG_PASSWORD_PROPERTY,
	GITG_AUTHENTICATION_DIALOG_LIFE_TIME_PROPERTY,
	GITG_AUTHENTICATION_DIALOG_NUM_PROPERTIES
};
static GParamSpec* gitg_authentication_dialog_properties[GITG_AUTHENTICATION_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GitgAuthenticationDialogPrivate {
	GtkLabel* d_label_title;
	GtkLabel* d_label_failed;
	GtkEntry* d_entry_username;
	GtkEntry* d_entry_password;
	GtkRadioButton* d_radio_button_forget;
	GtkRadioButton* d_radio_button_session;
	GtkRadioButton* d_radio_button_forever;
};

static gint GitgAuthenticationDialog_private_offset;
static gpointer gitg_authentication_dialog_parent_class = NULL;
static GitgAuthenticationLifeTime gitg_authentication_dialog_s_last_lifetime;
static GitgAuthenticationLifeTime gitg_authentication_dialog_s_last_lifetime = 0;

static void gitg_authentication_dialog_finalize (GObject * obj);
static GType gitg_authentication_dialog_get_type_once (void);
static void _vala_gitg_authentication_dialog_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);

 G_GNUC_NO_INLINE static GType
gitg_authentication_life_time_get_type_once (void)
{
	static const GEnumValue values[] = {{GITG_AUTHENTICATION_LIFE_TIME_FORGET, "GITG_AUTHENTICATION_LIFE_TIME_FORGET", "forget"}, {GITG_AUTHENTICATION_LIFE_TIME_SESSION, "GITG_AUTHENTICATION_LIFE_TIME_SESSION", "session"}, {GITG_AUTHENTICATION_LIFE_TIME_FOREVER, "GITG_AUTHENTICATION_LIFE_TIME_FOREVER", "forever"}, {0, NULL, NULL}};
	GType gitg_authentication_life_time_type_id;
	gitg_authentication_life_time_type_id = g_enum_register_static ("GitgAuthenticationLifeTime", values);
	return gitg_authentication_life_time_type_id;
}

GType
gitg_authentication_life_time_get_type (void)
{
	static gsize gitg_authentication_life_time_type_id__once = 0;
	if (g_once_init_enter (&gitg_authentication_life_time_type_id__once)) {
		GType gitg_authentication_life_time_type_id;
		gitg_authentication_life_time_type_id = gitg_authentication_life_time_get_type_once ();
		g_once_init_leave (&gitg_authentication_life_time_type_id__once, gitg_authentication_life_time_type_id);
	}
	return gitg_authentication_life_time_type_id__once;
}

static inline gpointer
gitg_authentication_dialog_get_instance_private (GitgAuthenticationDialog* self)
{
	return G_STRUCT_MEMBER_P (self, GitgAuthenticationDialog_private_offset);
}

GitgAuthenticationDialog*
gitg_authentication_dialog_construct (GType object_type,
                                      const gchar* url,
                                      const gchar* username,
                                      gboolean failed)
{
	GitgAuthenticationDialog * self = NULL;
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
#line 61 "../libgitg/gitg-authentication-dialog.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 63 "../libgitg/gitg-authentication-dialog.vala"
	self = (GitgAuthenticationDialog*) g_object_new (object_type, "use-header-bar", 1, NULL);
#line 65 "../libgitg/gitg-authentication-dialog.vala"
	gtk_dialog_set_default_response ((GtkDialog*) self, (gint) GTK_RESPONSE_OK);
#line 69 "../libgitg/gitg-authentication-dialog.vala"
	_tmp0_ = self->priv->d_label_title;
#line 69 "../libgitg/gitg-authentication-dialog.vala"
	_tmp1_ = g_strdup_printf (_ ("Password required for %s"), url);
#line 69 "../libgitg/gitg-authentication-dialog.vala"
	_tmp2_ = _tmp1_;
#line 69 "../libgitg/gitg-authentication-dialog.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 69 "../libgitg/gitg-authentication-dialog.vala"
	_g_free0 (_tmp2_);
#line 70 "../libgitg/gitg-authentication-dialog.vala"
	_tmp3_ = self->priv->d_label_failed;
#line 70 "../libgitg/gitg-authentication-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, failed);
#line 72 "../libgitg/gitg-authentication-dialog.vala"
	if (username != NULL) {
#line 133 "gitg-authentication-dialog.c"
		GtkEntry* _tmp4_;
		GtkEntry* _tmp5_;
#line 74 "../libgitg/gitg-authentication-dialog.vala"
		_tmp4_ = self->priv->d_entry_username;
#line 74 "../libgitg/gitg-authentication-dialog.vala"
		gtk_entry_set_text (_tmp4_, username);
#line 75 "../libgitg/gitg-authentication-dialog.vala"
		_tmp5_ = self->priv->d_entry_password;
#line 75 "../libgitg/gitg-authentication-dialog.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
#line 144 "gitg-authentication-dialog.c"
	}
#line 78 "../libgitg/gitg-authentication-dialog.vala"
	switch (gitg_authentication_dialog_s_last_lifetime) {
#line 78 "../libgitg/gitg-authentication-dialog.vala"
		case GITG_AUTHENTICATION_LIFE_TIME_FORGET:
#line 150 "gitg-authentication-dialog.c"
		{
			GtkRadioButton* _tmp6_;
#line 81 "../libgitg/gitg-authentication-dialog.vala"
			_tmp6_ = self->priv->d_radio_button_forget;
#line 81 "../libgitg/gitg-authentication-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp6_, TRUE);
#line 82 "../libgitg/gitg-authentication-dialog.vala"
			break;
#line 159 "gitg-authentication-dialog.c"
		}
#line 78 "../libgitg/gitg-authentication-dialog.vala"
		case GITG_AUTHENTICATION_LIFE_TIME_SESSION:
#line 163 "gitg-authentication-dialog.c"
		{
			GtkRadioButton* _tmp7_;
#line 84 "../libgitg/gitg-authentication-dialog.vala"
			_tmp7_ = self->priv->d_radio_button_session;
#line 84 "../libgitg/gitg-authentication-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp7_, TRUE);
#line 85 "../libgitg/gitg-authentication-dialog.vala"
			break;
#line 172 "gitg-authentication-dialog.c"
		}
#line 78 "../libgitg/gitg-authentication-dialog.vala"
		case GITG_AUTHENTICATION_LIFE_TIME_FOREVER:
#line 176 "gitg-authentication-dialog.c"
		{
			GtkRadioButton* _tmp8_;
#line 87 "../libgitg/gitg-authentication-dialog.vala"
			_tmp8_ = self->priv->d_radio_button_forever;
#line 87 "../libgitg/gitg-authentication-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp8_, TRUE);
#line 88 "../libgitg/gitg-authentication-dialog.vala"
			break;
#line 185 "gitg-authentication-dialog.c"
		}
		default:
#line 78 "../libgitg/gitg-authentication-dialog.vala"
		break;
#line 190 "gitg-authentication-dialog.c"
	}
#line 61 "../libgitg/gitg-authentication-dialog.vala"
	return self;
#line 194 "gitg-authentication-dialog.c"
}

GitgAuthenticationDialog*
gitg_authentication_dialog_new (const gchar* url,
                                const gchar* username,
                                gboolean failed)
{
#line 61 "../libgitg/gitg-authentication-dialog.vala"
	return gitg_authentication_dialog_construct (GITG_TYPE_AUTHENTICATION_DIALOG, url, username, failed);
#line 204 "gitg-authentication-dialog.c"
}

const gchar*
gitg_authentication_dialog_get_username (GitgAuthenticationDialog* self)
{
	const gchar* result;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 94 "../libgitg/gitg-authentication-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../libgitg/gitg-authentication-dialog.vala"
	_tmp0_ = self->priv->d_entry_username;
#line 94 "../libgitg/gitg-authentication-dialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 94 "../libgitg/gitg-authentication-dialog.vala"
	_tmp2_ = _tmp1_;
#line 94 "../libgitg/gitg-authentication-dialog.vala"
	result = _tmp2_;
#line 94 "../libgitg/gitg-authentication-dialog.vala"
	return result;
#line 226 "gitg-authentication-dialog.c"
}

const gchar*
gitg_authentication_dialog_get_password (GitgAuthenticationDialog* self)
{
	const gchar* result;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 99 "../libgitg/gitg-authentication-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../libgitg/gitg-authentication-dialog.vala"
	_tmp0_ = self->priv->d_entry_password;
#line 99 "../libgitg/gitg-authentication-dialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 99 "../libgitg/gitg-authentication-dialog.vala"
	_tmp2_ = _tmp1_;
#line 99 "../libgitg/gitg-authentication-dialog.vala"
	result = _tmp2_;
#line 99 "../libgitg/gitg-authentication-dialog.vala"
	return result;
#line 248 "gitg-authentication-dialog.c"
}

GitgAuthenticationLifeTime
gitg_authentication_dialog_get_life_time (GitgAuthenticationDialog* self)
{
	GitgAuthenticationLifeTime result;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 104 "../libgitg/gitg-authentication-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 106 "../libgitg/gitg-authentication-dialog.vala"
	_tmp0_ = self->priv->d_radio_button_forget;
#line 106 "../libgitg/gitg-authentication-dialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 106 "../libgitg/gitg-authentication-dialog.vala"
	_tmp2_ = _tmp1_;
#line 106 "../libgitg/gitg-authentication-dialog.vala"
	if (_tmp2_) {
#line 108 "../libgitg/gitg-authentication-dialog.vala"
		result = GITG_AUTHENTICATION_LIFE_TIME_FORGET;
#line 108 "../libgitg/gitg-authentication-dialog.vala"
		return result;
#line 272 "gitg-authentication-dialog.c"
	} else {
		GtkRadioButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 110 "../libgitg/gitg-authentication-dialog.vala"
		_tmp3_ = self->priv->d_radio_button_session;
#line 110 "../libgitg/gitg-authentication-dialog.vala"
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
#line 110 "../libgitg/gitg-authentication-dialog.vala"
		_tmp5_ = _tmp4_;
#line 110 "../libgitg/gitg-authentication-dialog.vala"
		if (_tmp5_) {
#line 112 "../libgitg/gitg-authentication-dialog.vala"
			result = GITG_AUTHENTICATION_LIFE_TIME_SESSION;
#line 112 "../libgitg/gitg-authentication-dialog.vala"
			return result;
#line 289 "gitg-authentication-dialog.c"
		} else {
#line 116 "../libgitg/gitg-authentication-dialog.vala"
			result = GITG_AUTHENTICATION_LIFE_TIME_FOREVER;
#line 116 "../libgitg/gitg-authentication-dialog.vala"
			return result;
#line 295 "gitg-authentication-dialog.c"
		}
	}
}

static void
gitg_authentication_dialog_class_init (GitgAuthenticationDialogClass * klass,
                                       gpointer klass_data)
{
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	gitg_authentication_dialog_parent_class = g_type_class_peek_parent (klass);
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	g_type_class_adjust_private_offset (klass, &GitgAuthenticationDialog_private_offset);
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_authentication_dialog_get_property;
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_authentication_dialog_finalize;
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_AUTHENTICATION_DIALOG_USERNAME_PROPERTY, gitg_authentication_dialog_properties[GITG_AUTHENTICATION_DIALOG_USERNAME_PROPERTY] = g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_AUTHENTICATION_DIALOG_PASSWORD_PROPERTY, gitg_authentication_dialog_properties[GITG_AUTHENTICATION_DIALOG_PASSWORD_PROPERTY] = g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_AUTHENTICATION_DIALOG_LIFE_TIME_PROPERTY, gitg_authentication_dialog_properties[GITG_AUTHENTICATION_DIALOG_LIFE_TIME_PROPERTY] = g_param_spec_enum ("life-time", "life-time", "life-time", GITG_TYPE_AUTHENTICATION_LIFE_TIME, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/gitg/ui/gitg-authentication-dialog.ui");
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "label_title", FALSE, GitgAuthenticationDialog_private_offset + G_STRUCT_OFFSET (GitgAuthenticationDialogPrivate, d_label_title));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "label_failed", FALSE, GitgAuthenticationDialog_private_offset + G_STRUCT_OFFSET (GitgAuthenticationDialogPrivate, d_label_failed));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "entry_username", FALSE, GitgAuthenticationDialog_private_offset + G_STRUCT_OFFSET (GitgAuthenticationDialogPrivate, d_entry_username));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "entry_password", FALSE, GitgAuthenticationDialog_private_offset + G_STRUCT_OFFSET (GitgAuthenticationDialogPrivate, d_entry_password));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "radio_button_forget", FALSE, GitgAuthenticationDialog_private_offset + G_STRUCT_OFFSET (GitgAuthenticationDialogPrivate, d_radio_button_forget));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "radio_button_session", FALSE, GitgAuthenticationDialog_private_offset + G_STRUCT_OFFSET (GitgAuthenticationDialogPrivate, d_radio_button_session));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "radio_button_forever", FALSE, GitgAuthenticationDialog_private_offset + G_STRUCT_OFFSET (GitgAuthenticationDialogPrivate, d_radio_button_forever));
#line 58 "../libgitg/gitg-authentication-dialog.vala"
	gitg_authentication_dialog_s_last_lifetime = GITG_AUTHENTICATION_LIFE_TIME_SESSION;
#line 336 "gitg-authentication-dialog.c"
}

static void
gitg_authentication_dialog_instance_init (GitgAuthenticationDialog * self,
                                          gpointer klass)
{
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	self->priv = gitg_authentication_dialog_get_instance_private (self);
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 347 "gitg-authentication-dialog.c"
}

static void
gitg_authentication_dialog_finalize (GObject * obj)
{
	GitgAuthenticationDialog * self;
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_AUTHENTICATION_DIALOG, GitgAuthenticationDialog);
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	G_OBJECT_CLASS (gitg_authentication_dialog_parent_class)->finalize (obj);
#line 358 "gitg-authentication-dialog.c"
}

 G_GNUC_NO_INLINE static GType
gitg_authentication_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GitgAuthenticationDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_authentication_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgAuthenticationDialog), 0, (GInstanceInitFunc) gitg_authentication_dialog_instance_init, NULL };
	GType gitg_authentication_dialog_type_id;
	gitg_authentication_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "GitgAuthenticationDialog", &g_define_type_info, 0);
	GitgAuthenticationDialog_private_offset = g_type_add_instance_private (gitg_authentication_dialog_type_id, sizeof (GitgAuthenticationDialogPrivate));
	return gitg_authentication_dialog_type_id;
}

GType
gitg_authentication_dialog_get_type (void)
{
	static gsize gitg_authentication_dialog_type_id__once = 0;
	if (g_once_init_enter (&gitg_authentication_dialog_type_id__once)) {
		GType gitg_authentication_dialog_type_id;
		gitg_authentication_dialog_type_id = gitg_authentication_dialog_get_type_once ();
		g_once_init_leave (&gitg_authentication_dialog_type_id__once, gitg_authentication_dialog_type_id);
	}
	return gitg_authentication_dialog_type_id__once;
}

static void
_vala_gitg_authentication_dialog_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	GitgAuthenticationDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_AUTHENTICATION_DIALOG, GitgAuthenticationDialog);
#line 31 "../libgitg/gitg-authentication-dialog.vala"
	switch (property_id) {
#line 31 "../libgitg/gitg-authentication-dialog.vala"
		case GITG_AUTHENTICATION_DIALOG_USERNAME_PROPERTY:
#line 31 "../libgitg/gitg-authentication-dialog.vala"
		g_value_set_string (value, gitg_authentication_dialog_get_username (self));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
		break;
#line 31 "../libgitg/gitg-authentication-dialog.vala"
		case GITG_AUTHENTICATION_DIALOG_PASSWORD_PROPERTY:
#line 31 "../libgitg/gitg-authentication-dialog.vala"
		g_value_set_string (value, gitg_authentication_dialog_get_password (self));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
		break;
#line 31 "../libgitg/gitg-authentication-dialog.vala"
		case GITG_AUTHENTICATION_DIALOG_LIFE_TIME_PROPERTY:
#line 31 "../libgitg/gitg-authentication-dialog.vala"
		g_value_set_enum (value, gitg_authentication_dialog_get_life_time (self));
#line 31 "../libgitg/gitg-authentication-dialog.vala"
		break;
#line 411 "gitg-authentication-dialog.c"
		default:
#line 31 "../libgitg/gitg-authentication-dialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../libgitg/gitg-authentication-dialog.vala"
		break;
#line 417 "gitg-authentication-dialog.c"
	}
}

