/* gitg-cell-renderer-lanes.c generated by valac 0.56.18, the Vala compiler
 * generated from gitg-cell-renderer-lanes.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2012 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgitg.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GITG_CELL_RENDERER_LANES_0_PROPERTY,
	GITG_CELL_RENDERER_LANES_COMMIT_PROPERTY,
	GITG_CELL_RENDERER_LANES_NEXT_COMMIT_PROPERTY,
	GITG_CELL_RENDERER_LANES_LANE_WIDTH_PROPERTY,
	GITG_CELL_RENDERER_LANES_DOT_WIDTH_PROPERTY,
	GITG_CELL_RENDERER_LANES_LABELS_PROPERTY,
	GITG_CELL_RENDERER_LANES_NUM_PROPERTIES
};
static GParamSpec* gitg_cell_renderer_lanes_properties[GITG_CELL_RENDERER_LANES_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef gdouble (*GitgCellRendererLanesDirectionFunc) (gdouble i, gpointer user_data);
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GitgCellRendererLanesPrivate {
	GitgCommit* _commit;
	GitgCommit* _next_commit;
	guint _lane_width;
	guint _dot_width;
	GSList* _labels;
	gint d_last_height;
};

static gint GitgCellRendererLanes_private_offset;
static gpointer gitg_cell_renderer_lanes_parent_class = NULL;

static guint gitg_cell_renderer_lanes_total_width (GitgCellRendererLanes* self,
                                            GtkWidget* widget);
static guint gitg_cell_renderer_lanes_get_num_visible_lanes (GitgCellRendererLanes* self);
static void gitg_cell_renderer_lanes_real_get_preferred_width (GtkCellRenderer* base,
                                                        GtkWidget* widget,
                                                        gint* minimum_width,
                                                        gint* natural_width);
static void gitg_cell_renderer_lanes_draw_arrow (GitgCellRendererLanes* self,
                                          cairo_t* context,
                                          GdkRectangle* area,
                                          guint laneidx,
                                          gboolean top);
static void gitg_cell_renderer_lanes_draw_arrows (GitgCellRendererLanes* self,
                                           cairo_t* context,
                                           GdkRectangle* area);
static void gitg_cell_renderer_lanes_draw_paths_real (GitgCellRendererLanes* self,
                                               cairo_t* context,
                                               GdkRectangle* area,
                                               GitgCommit* commit,
                                               GitgCellRendererLanesDirectionFunc f,
                                               gpointer f_target,
                                               gdouble yoffset);
static void gitg_cell_renderer_lanes_draw_top_paths (GitgCellRendererLanes* self,
                                              cairo_t* context,
                                              GdkRectangle* area,
                                              GitgCellRendererLanesDirectionFunc f,
                                              gpointer f_target);
static void gitg_cell_renderer_lanes_draw_bottom_paths (GitgCellRendererLanes* self,
                                                 cairo_t* context,
                                                 GdkRectangle* area,
                                                 GitgCellRendererLanesDirectionFunc f,
                                                 gpointer f_target);
static void gitg_cell_renderer_lanes_draw_paths (GitgCellRendererLanes* self,
                                          cairo_t* context,
                                          GdkRectangle* area,
                                          GitgCellRendererLanesDirectionFunc f,
                                          gpointer f_target);
static void gitg_cell_renderer_lanes_draw_indicator (GitgCellRendererLanes* self,
                                              cairo_t* context,
                                              GdkRectangle* area,
                                              GitgCellRendererLanesDirectionFunc f,
                                              gpointer f_target);
static void gitg_cell_renderer_lanes_draw_labels (GitgCellRendererLanes* self,
                                           cairo_t* context,
                                           GtkWidget* widget,
                                           GdkRectangle* area);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void gitg_cell_renderer_lanes_draw_lane (GitgCellRendererLanes* self,
                                         cairo_t* context,
                                         GtkWidget* widget,
                                         GdkRectangle* area);
static gdouble ___lambda33_ (GitgCellRendererLanes* self,
                      gdouble a);
static gdouble ____lambda33__gitg_cell_renderer_lanes_direction_func (gdouble i,
                                                               gpointer self);
static gdouble ___lambda34_ (GitgCellRendererLanes* self,
                      gdouble a);
static gdouble ____lambda34__gitg_cell_renderer_lanes_direction_func (gdouble i,
                                                               gpointer self);
static void gitg_cell_renderer_lanes_real_render (GtkCellRenderer* base,
                                           cairo_t* context,
                                           GtkWidget* widget,
                                           GdkRectangle* area,
                                           GdkRectangle* cell_area,
                                           GtkCellRendererState flags);
static void gitg_cell_renderer_lanes_finalize (GObject * obj);
static GType gitg_cell_renderer_lanes_get_type_once (void);
static void _vala_gitg_cell_renderer_lanes_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_gitg_cell_renderer_lanes_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
gitg_cell_renderer_lanes_get_instance_private (GitgCellRendererLanes* self)
{
	return G_STRUCT_MEMBER_P (self, GitgCellRendererLanes_private_offset);
}

static guint
gitg_cell_renderer_lanes_total_width (GitgCellRendererLanes* self,
                                      GtkWidget* widget)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	PangoFontDescription* _tmp3_;
	PangoFontDescription* _tmp4_;
	GSList* _tmp5_;
	guint result;
#line 59 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 59 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_val_if_fail (widget != NULL, 0U);
#line 61 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = gitg_cell_renderer_lanes_get_num_visible_lanes (self);
#line 61 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = _tmp0_;
#line 61 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp2_ = self->priv->_lane_width;
#line 61 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_object_get ((GtkCellRendererText*) self, "font-desc", &_tmp3_, NULL);
#line 61 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp4_ = _tmp3_;
#line 61 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp5_ = self->priv->_labels;
#line 61 "../libgitg/gitg-cell-renderer-lanes.vala"
	result = (_tmp1_ * _tmp2_) + gitg_label_renderer_width (widget, _tmp4_, _tmp5_);
#line 61 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 185 "gitg-cell-renderer-lanes.c"
}

static void
gitg_cell_renderer_lanes_real_get_preferred_width (GtkCellRenderer* base,
                                                   GtkWidget* widget,
                                                   gint* minimum_width,
                                                   gint* natural_width)
{
	GitgCellRendererLanes * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint w = 0;
#line 65 "../libgitg/gitg-cell-renderer-lanes.vala"
	self = (GitgCellRendererLanes*) base;
#line 65 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (widget != NULL);
#line 69 "../libgitg/gitg-cell-renderer-lanes.vala"
	GTK_CELL_RENDERER_CLASS (gitg_cell_renderer_lanes_parent_class)->get_preferred_width ((GtkCellRenderer*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_cell_renderer_text_get_type (), GtkCellRendererText), widget, &_tmp0_, &_tmp1_);
#line 69 "../libgitg/gitg-cell-renderer-lanes.vala"
	_vala_minimum_width = _tmp0_;
#line 69 "../libgitg/gitg-cell-renderer-lanes.vala"
	_vala_natural_width = _tmp1_;
#line 71 "../libgitg/gitg-cell-renderer-lanes.vala"
	w = (gint) gitg_cell_renderer_lanes_total_width (self, widget);
#line 73 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (w > _vala_minimum_width) {
#line 75 "../libgitg/gitg-cell-renderer-lanes.vala"
		_vala_minimum_width = w;
#line 216 "gitg-cell-renderer-lanes.c"
	}
#line 65 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (minimum_width) {
#line 65 "../libgitg/gitg-cell-renderer-lanes.vala"
		*minimum_width = _vala_minimum_width;
#line 222 "gitg-cell-renderer-lanes.c"
	}
#line 65 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (natural_width) {
#line 65 "../libgitg/gitg-cell-renderer-lanes.vala"
		*natural_width = _vala_natural_width;
#line 228 "gitg-cell-renderer-lanes.c"
	}
}

static void
gitg_cell_renderer_lanes_draw_arrow (GitgCellRendererLanes* self,
                                     cairo_t* context,
                                     GdkRectangle* area,
                                     guint laneidx,
                                     gboolean top)
{
	gdouble cw = 0.0;
	guint _tmp0_;
	gdouble xpos = 0.0;
	GdkRectangle _tmp1_;
	gint _tmp2_ = 0;
	gdouble df = 0.0;
	GdkRectangle _tmp3_;
	gdouble ypos = 0.0;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	gdouble q = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
#line 79 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 79 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (context != NULL);
#line 79 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (area != NULL);
#line 84 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = self->priv->_lane_width;
#line 84 "../libgitg/gitg-cell-renderer-lanes.vala"
	cw = (gdouble) _tmp0_;
#line 85 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = *area;
#line 85 "../libgitg/gitg-cell-renderer-lanes.vala"
	xpos = (_tmp1_.x + (laneidx * cw)) + (cw / 2.0);
#line 86 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (top) {
#line 86 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp2_ = -1;
#line 270 "gitg-cell-renderer-lanes.c"
	} else {
#line 86 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp2_ = 1;
#line 274 "gitg-cell-renderer-lanes.c"
	}
#line 86 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp3_ = *area;
#line 86 "../libgitg/gitg-cell-renderer-lanes.vala"
	df = (_tmp2_ * 0.25) * _tmp3_.height;
#line 87 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp4_ = *area;
#line 87 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp5_ = *area;
#line 87 "../libgitg/gitg-cell-renderer-lanes.vala"
	ypos = (_tmp4_.y + (_tmp5_.height / 2.0)) + df;
#line 88 "../libgitg/gitg-cell-renderer-lanes.vala"
	q = cw / 4.0;
#line 90 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (top) {
#line 90 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp6_ = q;
#line 292 "gitg-cell-renderer-lanes.c"
	} else {
#line 90 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp6_ = -q;
#line 296 "gitg-cell-renderer-lanes.c"
	}
#line 90 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_move_to (context, xpos - q, ypos + _tmp6_);
#line 91 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_line_to (context, xpos, ypos);
#line 92 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (top) {
#line 92 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp7_ = q;
#line 306 "gitg-cell-renderer-lanes.c"
	} else {
#line 92 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp7_ = -q;
#line 310 "gitg-cell-renderer-lanes.c"
	}
#line 92 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_line_to (context, xpos + q, ypos + _tmp7_);
#line 93 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_stroke (context);
#line 95 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_move_to (context, xpos, ypos);
#line 96 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_line_to (context, xpos, ypos - df);
#line 97 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_stroke (context);
#line 322 "gitg-cell-renderer-lanes.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 105 "../libgitg/gitg-cell-renderer-lanes.vala"
	return self ? g_object_ref (self) : NULL;
#line 330 "gitg-cell-renderer-lanes.c"
}

static void
gitg_cell_renderer_lanes_draw_arrows (GitgCellRendererLanes* self,
                                      cairo_t* context,
                                      GdkRectangle* area)
{
	guint to = 0U;
	GitgCommit* _tmp0_;
	GSList* _tmp1_;
#line 100 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 100 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (context != NULL);
#line 100 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (area != NULL);
#line 103 "../libgitg/gitg-cell-renderer-lanes.vala"
	to = (guint) 0;
#line 105 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = self->priv->_commit;
#line 105 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = gitg_commit_get_lanes (_tmp0_);
#line 353 "gitg-cell-renderer-lanes.c"
	{
		GSList* lane_collection = NULL;
		GSList* lane_it = NULL;
#line 105 "../libgitg/gitg-cell-renderer-lanes.vala"
		lane_collection = _tmp1_;
#line 105 "../libgitg/gitg-cell-renderer-lanes.vala"
		for (lane_it = lane_collection; lane_it != NULL; lane_it = lane_it->next) {
#line 361 "gitg-cell-renderer-lanes.c"
			GitgLane* _tmp2_;
			GitgLane* lane = NULL;
#line 105 "../libgitg/gitg-cell-renderer-lanes.vala"
			_tmp2_ = _g_object_ref0 ((GitgLane*) lane_it->data);
#line 105 "../libgitg/gitg-cell-renderer-lanes.vala"
			lane = _tmp2_;
#line 368 "gitg-cell-renderer-lanes.c"
			{
				GitgColor* color = NULL;
				GitgLane* _tmp3_;
				GitgColor* _tmp4_;
				GitgColor* _tmp5_;
				GitgColor* _tmp6_;
				gdouble _tmp7_;
				gdouble _tmp8_;
				GitgColor* _tmp9_;
				gdouble _tmp10_;
				gdouble _tmp11_;
				GitgColor* _tmp12_;
				gdouble _tmp13_;
				gdouble _tmp14_;
				GitgLane* _tmp15_;
				guint _tmp19_;
#line 107 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp3_ = lane;
#line 107 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp4_ = _tmp3_->color;
#line 107 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp5_ = _g_object_ref0 (_tmp4_);
#line 107 "../libgitg/gitg-cell-renderer-lanes.vala"
				color = _tmp5_;
#line 108 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp6_ = color;
#line 108 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp7_ = gitg_color_get_r (_tmp6_);
#line 108 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp8_ = _tmp7_;
#line 108 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp9_ = color;
#line 108 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp10_ = gitg_color_get_g (_tmp9_);
#line 108 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp11_ = _tmp10_;
#line 108 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp12_ = color;
#line 108 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp13_ = gitg_color_get_b (_tmp12_);
#line 108 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp14_ = _tmp13_;
#line 108 "../libgitg/gitg-cell-renderer-lanes.vala"
				cairo_set_source_rgb (context, _tmp8_, _tmp11_, _tmp14_);
#line 110 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp15_ = lane;
#line 110 "../libgitg/gitg-cell-renderer-lanes.vala"
				if (_tmp15_->tag == GITG_LANE_TAG_START) {
#line 417 "gitg-cell-renderer-lanes.c"
					GdkRectangle _tmp16_;
#line 112 "../libgitg/gitg-cell-renderer-lanes.vala"
					_tmp16_ = *area;
#line 112 "../libgitg/gitg-cell-renderer-lanes.vala"
					gitg_cell_renderer_lanes_draw_arrow (self, context, &_tmp16_, to, TRUE);
#line 423 "gitg-cell-renderer-lanes.c"
				} else {
					GitgLane* _tmp17_;
#line 114 "../libgitg/gitg-cell-renderer-lanes.vala"
					_tmp17_ = lane;
#line 114 "../libgitg/gitg-cell-renderer-lanes.vala"
					if (_tmp17_->tag == GITG_LANE_TAG_END) {
#line 430 "gitg-cell-renderer-lanes.c"
						GdkRectangle _tmp18_;
#line 116 "../libgitg/gitg-cell-renderer-lanes.vala"
						_tmp18_ = *area;
#line 116 "../libgitg/gitg-cell-renderer-lanes.vala"
						gitg_cell_renderer_lanes_draw_arrow (self, context, &_tmp18_, to, FALSE);
#line 436 "gitg-cell-renderer-lanes.c"
					}
				}
#line 119 "../libgitg/gitg-cell-renderer-lanes.vala"
				to = to + 1;
#line 119 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp19_ = to;
#line 105 "../libgitg/gitg-cell-renderer-lanes.vala"
				_g_object_unref0 (color);
#line 105 "../libgitg/gitg-cell-renderer-lanes.vala"
				_g_object_unref0 (lane);
#line 447 "gitg-cell-renderer-lanes.c"
			}
		}
	}
}

static void
gitg_cell_renderer_lanes_draw_paths_real (GitgCellRendererLanes* self,
                                          cairo_t* context,
                                          GdkRectangle* area,
                                          GitgCommit* commit,
                                          GitgCellRendererLanesDirectionFunc f,
                                          gpointer f_target,
                                          gdouble yoffset)
{
	gint to = 0;
	gdouble cw = 0.0;
	guint _tmp0_;
	gdouble ch = 0.0;
	GdkRectangle _tmp1_;
	GSList* _tmp2_;
#line 123 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 123 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (context != NULL);
#line 123 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (area != NULL);
#line 129 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (commit == NULL) {
#line 131 "../libgitg/gitg-cell-renderer-lanes.vala"
		return;
#line 478 "gitg-cell-renderer-lanes.c"
	}
#line 134 "../libgitg/gitg-cell-renderer-lanes.vala"
	to = 0;
#line 135 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = self->priv->_lane_width;
#line 135 "../libgitg/gitg-cell-renderer-lanes.vala"
	cw = (gdouble) _tmp0_;
#line 136 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = *area;
#line 136 "../libgitg/gitg-cell-renderer-lanes.vala"
	ch = _tmp1_.height / 2.0;
#line 138 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp2_ = gitg_commit_get_lanes (commit);
#line 492 "gitg-cell-renderer-lanes.c"
	{
		GSList* lane_collection = NULL;
		GSList* lane_it = NULL;
#line 138 "../libgitg/gitg-cell-renderer-lanes.vala"
		lane_collection = _tmp2_;
#line 138 "../libgitg/gitg-cell-renderer-lanes.vala"
		for (lane_it = lane_collection; lane_it != NULL; lane_it = lane_it->next) {
#line 500 "gitg-cell-renderer-lanes.c"
			GitgLane* _tmp3_;
			GitgLane* lane = NULL;
#line 138 "../libgitg/gitg-cell-renderer-lanes.vala"
			_tmp3_ = _g_object_ref0 ((GitgLane*) lane_it->data);
#line 138 "../libgitg/gitg-cell-renderer-lanes.vala"
			lane = _tmp3_;
#line 507 "gitg-cell-renderer-lanes.c"
			{
				GitgLane* _tmp4_;
				GitgColor* color = NULL;
				GitgLane* _tmp6_;
				GitgColor* _tmp7_;
				GitgColor* _tmp8_;
				GitgColor* _tmp9_;
				gdouble _tmp10_;
				gdouble _tmp11_;
				GitgColor* _tmp12_;
				gdouble _tmp13_;
				gdouble _tmp14_;
				GitgColor* _tmp15_;
				gdouble _tmp16_;
				gdouble _tmp17_;
				GitgLane* _tmp18_;
				GSList* _tmp19_;
				gint _tmp25_;
#line 140 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp4_ = lane;
#line 140 "../libgitg/gitg-cell-renderer-lanes.vala"
				if ((_tmp4_->tag & GITG_LANE_TAG_HIDDEN) != 0) {
#line 530 "gitg-cell-renderer-lanes.c"
					gint _tmp5_;
#line 142 "../libgitg/gitg-cell-renderer-lanes.vala"
					to = to + 1;
#line 142 "../libgitg/gitg-cell-renderer-lanes.vala"
					_tmp5_ = to;
#line 143 "../libgitg/gitg-cell-renderer-lanes.vala"
					_g_object_unref0 (lane);
#line 143 "../libgitg/gitg-cell-renderer-lanes.vala"
					continue;
#line 540 "gitg-cell-renderer-lanes.c"
				}
#line 146 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp6_ = lane;
#line 146 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp7_ = _tmp6_->color;
#line 146 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp8_ = _g_object_ref0 (_tmp7_);
#line 146 "../libgitg/gitg-cell-renderer-lanes.vala"
				color = _tmp8_;
#line 147 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp9_ = color;
#line 147 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp10_ = gitg_color_get_r (_tmp9_);
#line 147 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp11_ = _tmp10_;
#line 147 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp12_ = color;
#line 147 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp13_ = gitg_color_get_g (_tmp12_);
#line 147 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp14_ = _tmp13_;
#line 147 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp15_ = color;
#line 147 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp16_ = gitg_color_get_b (_tmp15_);
#line 147 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp17_ = _tmp16_;
#line 147 "../libgitg/gitg-cell-renderer-lanes.vala"
				cairo_set_source_rgb (context, _tmp11_, _tmp14_, _tmp17_);
#line 149 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp18_ = lane;
#line 149 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp19_ = _tmp18_->from;
#line 574 "gitg-cell-renderer-lanes.c"
				{
					GSList* from_collection = NULL;
					GSList* from_it = NULL;
#line 149 "../libgitg/gitg-cell-renderer-lanes.vala"
					from_collection = _tmp19_;
#line 149 "../libgitg/gitg-cell-renderer-lanes.vala"
					for (from_it = from_collection; from_it != NULL; from_it = from_it->next) {
#line 582 "gitg-cell-renderer-lanes.c"
						gint from = 0;
#line 149 "../libgitg/gitg-cell-renderer-lanes.vala"
						from = (gint) ((gintptr) from_it->data);
#line 586 "gitg-cell-renderer-lanes.c"
						{
							gdouble x1 = 0.0;
							GdkRectangle _tmp20_;
							gdouble x2 = 0.0;
							GdkRectangle _tmp21_;
							gdouble y1 = 0.0;
							GdkRectangle _tmp22_;
							gdouble y2 = 0.0;
							GdkRectangle _tmp23_;
							gdouble y3 = 0.0;
							GdkRectangle _tmp24_;
#line 151 "../libgitg/gitg-cell-renderer-lanes.vala"
							_tmp20_ = *area;
#line 151 "../libgitg/gitg-cell-renderer-lanes.vala"
							x1 = _tmp20_.x + f ((from * cw) + (cw / 2.0), f_target);
#line 152 "../libgitg/gitg-cell-renderer-lanes.vala"
							_tmp21_ = *area;
#line 152 "../libgitg/gitg-cell-renderer-lanes.vala"
							x2 = _tmp21_.x + f ((to * cw) + (cw / 2.0), f_target);
#line 153 "../libgitg/gitg-cell-renderer-lanes.vala"
							_tmp22_ = *area;
#line 153 "../libgitg/gitg-cell-renderer-lanes.vala"
							y1 = _tmp22_.y + (yoffset * ch);
#line 154 "../libgitg/gitg-cell-renderer-lanes.vala"
							_tmp23_ = *area;
#line 154 "../libgitg/gitg-cell-renderer-lanes.vala"
							y2 = _tmp23_.y + ((yoffset + 1) * ch);
#line 155 "../libgitg/gitg-cell-renderer-lanes.vala"
							_tmp24_ = *area;
#line 155 "../libgitg/gitg-cell-renderer-lanes.vala"
							y3 = _tmp24_.y + ((yoffset + 2) * ch);
#line 157 "../libgitg/gitg-cell-renderer-lanes.vala"
							cairo_move_to (context, x1, y1);
#line 158 "../libgitg/gitg-cell-renderer-lanes.vala"
							cairo_curve_to (context, x1, y2, x2, y2, x2, y3);
#line 159 "../libgitg/gitg-cell-renderer-lanes.vala"
							cairo_stroke (context);
#line 624 "gitg-cell-renderer-lanes.c"
						}
					}
				}
#line 162 "../libgitg/gitg-cell-renderer-lanes.vala"
				to = to + 1;
#line 162 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp25_ = to;
#line 138 "../libgitg/gitg-cell-renderer-lanes.vala"
				_g_object_unref0 (color);
#line 138 "../libgitg/gitg-cell-renderer-lanes.vala"
				_g_object_unref0 (lane);
#line 636 "gitg-cell-renderer-lanes.c"
			}
		}
	}
}

static void
gitg_cell_renderer_lanes_draw_top_paths (GitgCellRendererLanes* self,
                                         cairo_t* context,
                                         GdkRectangle* area,
                                         GitgCellRendererLanesDirectionFunc f,
                                         gpointer f_target)
{
	GdkRectangle _tmp0_;
	GitgCommit* _tmp1_;
#line 166 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 166 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (context != NULL);
#line 166 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (area != NULL);
#line 170 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = *area;
#line 170 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = self->priv->_commit;
#line 170 "../libgitg/gitg-cell-renderer-lanes.vala"
	gitg_cell_renderer_lanes_draw_paths_real (self, context, &_tmp0_, _tmp1_, f, f_target, (gdouble) -1);
#line 663 "gitg-cell-renderer-lanes.c"
}

static void
gitg_cell_renderer_lanes_draw_bottom_paths (GitgCellRendererLanes* self,
                                            cairo_t* context,
                                            GdkRectangle* area,
                                            GitgCellRendererLanesDirectionFunc f,
                                            gpointer f_target)
{
	GdkRectangle _tmp0_;
	GitgCommit* _tmp1_;
#line 173 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 173 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (context != NULL);
#line 173 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (area != NULL);
#line 177 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = *area;
#line 177 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = self->priv->_next_commit;
#line 177 "../libgitg/gitg-cell-renderer-lanes.vala"
	gitg_cell_renderer_lanes_draw_paths_real (self, context, &_tmp0_, _tmp1_, f, f_target, (gdouble) 1);
#line 687 "gitg-cell-renderer-lanes.c"
}

static void
gitg_cell_renderer_lanes_draw_paths (GitgCellRendererLanes* self,
                                     cairo_t* context,
                                     GdkRectangle* area,
                                     GitgCellRendererLanesDirectionFunc f,
                                     gpointer f_target)
{
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
#line 180 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 180 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (context != NULL);
#line 180 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (area != NULL);
#line 184 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_set_line_width (context, 2.0);
#line 185 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_set_line_cap (context, CAIRO_LINE_CAP_ROUND);
#line 187 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_save (context);
#line 189 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = *area;
#line 189 "../libgitg/gitg-cell-renderer-lanes.vala"
	gitg_cell_renderer_lanes_draw_top_paths (self, context, &_tmp0_, f, f_target);
#line 190 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = *area;
#line 190 "../libgitg/gitg-cell-renderer-lanes.vala"
	gitg_cell_renderer_lanes_draw_bottom_paths (self, context, &_tmp1_, f, f_target);
#line 191 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp2_ = *area;
#line 191 "../libgitg/gitg-cell-renderer-lanes.vala"
	gitg_cell_renderer_lanes_draw_arrows (self, context, &_tmp2_);
#line 193 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_restore (context);
#line 726 "gitg-cell-renderer-lanes.c"
}

static void
gitg_cell_renderer_lanes_draw_indicator (GitgCellRendererLanes* self,
                                         cairo_t* context,
                                         GdkRectangle* area,
                                         GitgCellRendererLanesDirectionFunc f,
                                         gpointer f_target)
{
	gdouble offset = 0.0;
	gdouble radius = 0.0;
	GitgCommit* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	guint _tmp5_;
	guint _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	GdkRectangle _tmp9_;
	GitgCommit* _tmp10_;
	GitgLane* _tmp11_;
	GitgLane* _tmp12_;
#line 196 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 196 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (context != NULL);
#line 196 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (area != NULL);
#line 203 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = self->priv->_commit;
#line 203 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = gitg_commit_get_mylane (_tmp0_);
#line 203 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp2_ = _tmp1_;
#line 203 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp3_ = self->priv->_lane_width;
#line 203 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp4_ = self->priv->_lane_width;
#line 203 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp5_ = self->priv->_dot_width;
#line 203 "../libgitg/gitg-cell-renderer-lanes.vala"
	offset = (_tmp2_ * _tmp3_) + ((_tmp4_ - _tmp5_) / 2.0);
#line 204 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp6_ = self->priv->_dot_width;
#line 204 "../libgitg/gitg-cell-renderer-lanes.vala"
	radius = _tmp6_ / 2.0;
#line 206 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_set_line_width (context, 0.0);
#line 208 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp7_ = *area;
#line 208 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp8_ = *area;
#line 208 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp9_ = *area;
#line 208 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_arc (context, _tmp7_.x + f (offset + radius, f_target), _tmp8_.y + (_tmp9_.height / 2.0), radius, (gdouble) 0, 2 * G_PI);
#line 214 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_set_source_rgb (context, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 215 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_stroke_preserve (context);
#line 217 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp10_ = self->priv->_commit;
#line 217 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp11_ = gitg_commit_get_lane (_tmp10_);
#line 217 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp12_ = _tmp11_;
#line 217 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (_tmp12_ != NULL) {
#line 797 "gitg-cell-renderer-lanes.c"
		GitgColor* color = NULL;
		GitgCommit* _tmp13_;
		GitgLane* _tmp14_;
		GitgLane* _tmp15_;
		GitgColor* _tmp16_;
		GitgColor* _tmp17_;
		GitgColor* _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp20_;
		GitgColor* _tmp21_;
		gdouble _tmp22_;
		gdouble _tmp23_;
		GitgColor* _tmp24_;
		gdouble _tmp25_;
		gdouble _tmp26_;
#line 219 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp13_ = self->priv->_commit;
#line 219 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp14_ = gitg_commit_get_lane (_tmp13_);
#line 219 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp15_ = _tmp14_;
#line 219 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp16_ = _tmp15_->color;
#line 219 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp17_ = _g_object_ref0 (_tmp16_);
#line 219 "../libgitg/gitg-cell-renderer-lanes.vala"
		color = _tmp17_;
#line 220 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp18_ = color;
#line 220 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp19_ = gitg_color_get_r (_tmp18_);
#line 220 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp20_ = _tmp19_;
#line 220 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp21_ = color;
#line 220 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp22_ = gitg_color_get_g (_tmp21_);
#line 220 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp23_ = _tmp22_;
#line 220 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp24_ = color;
#line 220 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp25_ = gitg_color_get_b (_tmp24_);
#line 220 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp26_ = _tmp25_;
#line 220 "../libgitg/gitg-cell-renderer-lanes.vala"
		cairo_set_source_rgb (context, _tmp20_, _tmp23_, _tmp26_);
#line 217 "../libgitg/gitg-cell-renderer-lanes.vala"
		_g_object_unref0 (color);
#line 847 "gitg-cell-renderer-lanes.c"
	}
#line 223 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_fill (context);
#line 851 "gitg-cell-renderer-lanes.c"
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 243 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 859 "gitg-cell-renderer-lanes.c"
}

static void
gitg_cell_renderer_lanes_draw_labels (GitgCellRendererLanes* self,
                                      cairo_t* context,
                                      GtkWidget* widget,
                                      GdkRectangle* area)
{
	gint offset = 0;
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	gboolean rtl = FALSE;
	GtkStyleContext* _tmp3_;
	PangoFontDescription* _tmp4_;
	PangoFontDescription* _tmp5_;
	PangoFontDescription* _tmp6_;
	GSList* _tmp7_;
	GdkRectangle _tmp8_;
#line 226 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 226 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (context != NULL);
#line 226 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (widget != NULL);
#line 226 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (area != NULL);
#line 232 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = gitg_cell_renderer_lanes_get_num_visible_lanes (self);
#line 232 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = _tmp0_;
#line 232 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp2_ = self->priv->_lane_width;
#line 232 "../libgitg/gitg-cell-renderer-lanes.vala"
	offset = (gint) (_tmp1_ * _tmp2_);
#line 234 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp3_ = gtk_widget_get_style_context (widget);
#line 234 "../libgitg/gitg-cell-renderer-lanes.vala"
	rtl = (gtk_style_context_get_state (_tmp3_) & GTK_STATE_FLAG_DIR_RTL) != 0;
#line 236 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (rtl) {
#line 238 "../libgitg/gitg-cell-renderer-lanes.vala"
		offset = -offset;
#line 903 "gitg-cell-renderer-lanes.c"
	}
#line 241 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_save (context);
#line 242 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_translate (context, (gdouble) offset, (gdouble) 0);
#line 243 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_object_get ((GtkCellRendererText*) self, "font-desc", &_tmp4_, NULL);
#line 243 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp5_ = _tmp4_;
#line 243 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp6_ = _tmp5_;
#line 243 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp7_ = self->priv->_labels;
#line 243 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp8_ = *area;
#line 243 "../libgitg/gitg-cell-renderer-lanes.vala"
	gitg_label_renderer_draw (widget, _tmp6_, context, _tmp7_, &_tmp8_);
#line 243 "../libgitg/gitg-cell-renderer-lanes.vala"
	__vala_PangoFontDescription_free0 (_tmp6_);
#line 244 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_restore (context);
#line 925 "gitg-cell-renderer-lanes.c"
}

static gdouble
___lambda33_ (GitgCellRendererLanes* self,
              gdouble a)
{
	gdouble result;
#line 260 "../libgitg/gitg-cell-renderer-lanes.vala"
	result = -a;
#line 260 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 937 "gitg-cell-renderer-lanes.c"
}

static gdouble
____lambda33__gitg_cell_renderer_lanes_direction_func (gdouble i,
                                                       gpointer self)
{
	gdouble result;
	result = ___lambda33_ ((GitgCellRendererLanes*) self, i);
#line 260 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 948 "gitg-cell-renderer-lanes.c"
}

static gdouble
___lambda34_ (GitgCellRendererLanes* self,
              gdouble a)
{
	gdouble result;
#line 264 "../libgitg/gitg-cell-renderer-lanes.vala"
	result = a;
#line 264 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 960 "gitg-cell-renderer-lanes.c"
}

static gdouble
____lambda34__gitg_cell_renderer_lanes_direction_func (gdouble i,
                                                       gpointer self)
{
	gdouble result;
	result = ___lambda34_ ((GitgCellRendererLanes*) self, i);
#line 264 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 971 "gitg-cell-renderer-lanes.c"
}

static void
gitg_cell_renderer_lanes_draw_lane (GitgCellRendererLanes* self,
                                    cairo_t* context,
                                    GtkWidget* widget,
                                    GdkRectangle* area)
{
	GitgCellRendererLanesDirectionFunc f = NULL;
	gpointer f_target = NULL;
	GDestroyNotify f_target_destroy_notify = NULL;
	gboolean rtl = FALSE;
	GtkStyleContext* _tmp0_;
	GdkRectangle _tmp2_;
	GitgCellRendererLanesDirectionFunc _tmp3_;
	gpointer _tmp3__target;
	GdkRectangle _tmp4_;
	GitgCellRendererLanesDirectionFunc _tmp5_;
	gpointer _tmp5__target;
#line 247 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 247 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (context != NULL);
#line 247 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (widget != NULL);
#line 247 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (area != NULL);
#line 253 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = gtk_widget_get_style_context (widget);
#line 253 "../libgitg/gitg-cell-renderer-lanes.vala"
	rtl = (gtk_style_context_get_state (_tmp0_) & GTK_STATE_FLAG_DIR_RTL) != 0;
#line 255 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_save (context);
#line 257 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (rtl) {
#line 1007 "gitg-cell-renderer-lanes.c"
		GdkRectangle _tmp1_;
#line 259 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp1_ = *area;
#line 259 "../libgitg/gitg-cell-renderer-lanes.vala"
		cairo_translate (context, (gdouble) _tmp1_.width, (gdouble) 0);
#line 260 "../libgitg/gitg-cell-renderer-lanes.vala"
		(f_target_destroy_notify == NULL) ? NULL : (f_target_destroy_notify (f_target), NULL);
#line 260 "../libgitg/gitg-cell-renderer-lanes.vala"
		f = NULL;
#line 260 "../libgitg/gitg-cell-renderer-lanes.vala"
		f_target = NULL;
#line 260 "../libgitg/gitg-cell-renderer-lanes.vala"
		f_target_destroy_notify = NULL;
#line 260 "../libgitg/gitg-cell-renderer-lanes.vala"
		f = ____lambda33__gitg_cell_renderer_lanes_direction_func;
#line 260 "../libgitg/gitg-cell-renderer-lanes.vala"
		f_target = g_object_ref (self);
#line 260 "../libgitg/gitg-cell-renderer-lanes.vala"
		f_target_destroy_notify = g_object_unref;
#line 1027 "gitg-cell-renderer-lanes.c"
	} else {
#line 264 "../libgitg/gitg-cell-renderer-lanes.vala"
		(f_target_destroy_notify == NULL) ? NULL : (f_target_destroy_notify (f_target), NULL);
#line 264 "../libgitg/gitg-cell-renderer-lanes.vala"
		f = NULL;
#line 264 "../libgitg/gitg-cell-renderer-lanes.vala"
		f_target = NULL;
#line 264 "../libgitg/gitg-cell-renderer-lanes.vala"
		f_target_destroy_notify = NULL;
#line 264 "../libgitg/gitg-cell-renderer-lanes.vala"
		f = ____lambda34__gitg_cell_renderer_lanes_direction_func;
#line 264 "../libgitg/gitg-cell-renderer-lanes.vala"
		f_target = g_object_ref (self);
#line 264 "../libgitg/gitg-cell-renderer-lanes.vala"
		f_target_destroy_notify = g_object_unref;
#line 1043 "gitg-cell-renderer-lanes.c"
	}
#line 267 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp2_ = *area;
#line 267 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp3_ = f;
#line 267 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp3__target = f_target;
#line 267 "../libgitg/gitg-cell-renderer-lanes.vala"
	gitg_cell_renderer_lanes_draw_paths (self, context, &_tmp2_, _tmp3_, _tmp3__target);
#line 268 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp4_ = *area;
#line 268 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp5_ = f;
#line 268 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp5__target = f_target;
#line 268 "../libgitg/gitg-cell-renderer-lanes.vala"
	gitg_cell_renderer_lanes_draw_indicator (self, context, &_tmp4_, _tmp5_, _tmp5__target);
#line 270 "../libgitg/gitg-cell-renderer-lanes.vala"
	cairo_restore (context);
#line 247 "../libgitg/gitg-cell-renderer-lanes.vala"
	(f_target_destroy_notify == NULL) ? NULL : (f_target_destroy_notify (f_target), NULL);
#line 247 "../libgitg/gitg-cell-renderer-lanes.vala"
	f = NULL;
#line 247 "../libgitg/gitg-cell-renderer-lanes.vala"
	f_target = NULL;
#line 247 "../libgitg/gitg-cell-renderer-lanes.vala"
	f_target_destroy_notify = NULL;
#line 1071 "gitg-cell-renderer-lanes.c"
}

static void
gitg_cell_renderer_lanes_real_render (GtkCellRenderer* base,
                                      cairo_t* context,
                                      GtkWidget* widget,
                                      GdkRectangle* area,
                                      GdkRectangle* cell_area,
                                      GtkCellRendererState flags)
{
	GitgCellRendererLanes * self;
	GdkRectangle ncell_area = {0};
	GdkRectangle _tmp0_;
	GdkRectangle narea = {0};
	GdkRectangle _tmp1_;
	gboolean rtl = FALSE;
	GtkStyleContext* _tmp2_;
	GdkRectangle _tmp3_;
	GitgCommit* _tmp4_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_;
	GdkRectangle _tmp12_;
	GdkRectangle _tmp13_;
#line 273 "../libgitg/gitg-cell-renderer-lanes.vala"
	self = (GitgCellRendererLanes*) base;
#line 273 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (context != NULL);
#line 273 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (widget != NULL);
#line 273 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (area != NULL);
#line 273 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (cell_area != NULL);
#line 279 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = *cell_area;
#line 279 "../libgitg/gitg-cell-renderer-lanes.vala"
	ncell_area = _tmp0_;
#line 280 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = *area;
#line 280 "../libgitg/gitg-cell-renderer-lanes.vala"
	narea = _tmp1_;
#line 282 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp2_ = gtk_widget_get_style_context (widget);
#line 282 "../libgitg/gitg-cell-renderer-lanes.vala"
	rtl = (gtk_style_context_get_state (_tmp2_) & GTK_STATE_FLAG_DIR_RTL) != 0;
#line 284 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp3_ = *area;
#line 284 "../libgitg/gitg-cell-renderer-lanes.vala"
	self->priv->d_last_height = _tmp3_.height;
#line 286 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp4_ = self->priv->_commit;
#line 286 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (_tmp4_ != NULL) {
#line 1127 "gitg-cell-renderer-lanes.c"
		GdkRectangle _tmp5_;
		GdkRectangle _tmp6_;
		GdkRectangle _tmp7_;
		guint tw = 0U;
#line 288 "../libgitg/gitg-cell-renderer-lanes.vala"
		cairo_save (context);
#line 290 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp5_ = *area;
#line 290 "../libgitg/gitg-cell-renderer-lanes.vala"
		gdk_cairo_rectangle (context, &_tmp5_);
#line 291 "../libgitg/gitg-cell-renderer-lanes.vala"
		cairo_clip (context);
#line 293 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp6_ = *area;
#line 293 "../libgitg/gitg-cell-renderer-lanes.vala"
		gitg_cell_renderer_lanes_draw_lane (self, context, widget, &_tmp6_);
#line 294 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp7_ = *area;
#line 294 "../libgitg/gitg-cell-renderer-lanes.vala"
		gitg_cell_renderer_lanes_draw_labels (self, context, widget, &_tmp7_);
#line 296 "../libgitg/gitg-cell-renderer-lanes.vala"
		tw = gitg_cell_renderer_lanes_total_width (self, widget);
#line 298 "../libgitg/gitg-cell-renderer-lanes.vala"
		if (!rtl) {
#line 300 "../libgitg/gitg-cell-renderer-lanes.vala"
			narea.x = narea.x + ((gint) tw);
#line 301 "../libgitg/gitg-cell-renderer-lanes.vala"
			ncell_area.x = ncell_area.x + ((gint) tw);
#line 1156 "gitg-cell-renderer-lanes.c"
		} else {
#line 305 "../libgitg/gitg-cell-renderer-lanes.vala"
			narea.width = narea.width - ((gint) tw);
#line 306 "../libgitg/gitg-cell-renderer-lanes.vala"
			ncell_area.width = ncell_area.width - ((gint) tw);
#line 1162 "gitg-cell-renderer-lanes.c"
		}
#line 309 "../libgitg/gitg-cell-renderer-lanes.vala"
		cairo_restore (context);
#line 1166 "gitg-cell-renderer-lanes.c"
	}
#line 312 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_object_get ((GtkCellRendererText*) self, "text", &_tmp8_, NULL);
#line 312 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp9_ = _tmp8_;
#line 312 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp10_ = _tmp9_;
#line 312 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp11_ = rtl == (pango_find_base_dir (_tmp10_, -1) != PANGO_DIRECTION_RTL);
#line 312 "../libgitg/gitg-cell-renderer-lanes.vala"
	_g_free0 (_tmp10_);
#line 312 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (_tmp11_) {
#line 314 "../libgitg/gitg-cell-renderer-lanes.vala"
		g_object_set ((GtkCellRenderer*) self, "xalign", 1.0f, NULL);
#line 1182 "gitg-cell-renderer-lanes.c"
	}
#line 317 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp12_ = narea;
#line 317 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp13_ = ncell_area;
#line 317 "../libgitg/gitg-cell-renderer-lanes.vala"
	GTK_CELL_RENDERER_CLASS (gitg_cell_renderer_lanes_parent_class)->render ((GtkCellRenderer*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_cell_renderer_text_get_type (), GtkCellRendererText), context, widget, &_tmp12_, &_tmp13_, flags);
#line 1190 "gitg-cell-renderer-lanes.c"
}

GitgRef*
gitg_cell_renderer_lanes_get_ref_at_pos (GitgCellRendererLanes* self,
                                         GtkWidget* widget,
                                         gint x,
                                         gint cell_w,
                                         gint* hot_x)
{
	gint _vala_hot_x = 0;
	gboolean rtl = FALSE;
	GtkStyleContext* _tmp0_;
	gint offset = 0;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	PangoFontDescription* _tmp4_;
	PangoFontDescription* _tmp5_;
	PangoFontDescription* _tmp6_;
	GSList* _tmp7_;
	gint _tmp8_ = 0;
	GitgRef* _tmp9_;
	GitgRef* _tmp10_;
	GitgRef* result;
#line 320 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 320 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 325 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = gtk_widget_get_style_context (widget);
#line 325 "../libgitg/gitg-cell-renderer-lanes.vala"
	rtl = (gtk_style_context_get_state (_tmp0_) & GTK_STATE_FLAG_DIR_RTL) != 0;
#line 326 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = gitg_cell_renderer_lanes_get_num_visible_lanes (self);
#line 326 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp2_ = _tmp1_;
#line 326 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp3_ = self->priv->_lane_width;
#line 326 "../libgitg/gitg-cell-renderer-lanes.vala"
	offset = (gint) (_tmp2_ * _tmp3_);
#line 328 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (rtl) {
#line 330 "../libgitg/gitg-cell-renderer-lanes.vala"
		x = cell_w - x;
#line 1235 "gitg-cell-renderer-lanes.c"
	}
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_object_get ((GtkCellRendererText*) self, "font-desc", &_tmp4_, NULL);
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp5_ = _tmp4_;
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp6_ = _tmp5_;
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp7_ = self->priv->_labels;
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp9_ = gitg_label_renderer_get_ref_at_pos (widget, _tmp6_, _tmp7_, x - offset, &_tmp8_);
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
	_vala_hot_x = _tmp8_;
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp10_ = _tmp9_;
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
	__vala_PangoFontDescription_free0 (_tmp6_);
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
	result = _tmp10_;
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (hot_x) {
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
		*hot_x = _vala_hot_x;
#line 1259 "gitg-cell-renderer-lanes.c"
	}
#line 333 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 1263 "gitg-cell-renderer-lanes.c"
}

GitgCellRendererLanes*
gitg_cell_renderer_lanes_construct (GType object_type)
{
	GitgCellRendererLanes * self = NULL;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	self = (GitgCellRendererLanes*) g_object_new (object_type, NULL);
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	return self;
#line 1274 "gitg-cell-renderer-lanes.c"
}

GitgCellRendererLanes*
gitg_cell_renderer_lanes_new (void)
{
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	return gitg_cell_renderer_lanes_construct (GITG_TYPE_CELL_RENDERER_LANES);
#line 1282 "gitg-cell-renderer-lanes.c"
}

GitgCommit*
gitg_cell_renderer_lanes_get_commit (GitgCellRendererLanes* self)
{
	GitgCommit* result;
	GitgCommit* _tmp0_;
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = self->priv->_commit;
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
	result = _tmp0_;
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 1298 "gitg-cell-renderer-lanes.c"
}

void
gitg_cell_renderer_lanes_set_commit (GitgCellRendererLanes* self,
                                     GitgCommit* value)
{
	GitgCommit* old_value;
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
	old_value = gitg_cell_renderer_lanes_get_commit (self);
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (old_value != value) {
#line 1312 "gitg-cell-renderer-lanes.c"
		GitgCommit* _tmp0_;
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
		_g_object_unref0 (self->priv->_commit);
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
		self->priv->_commit = _tmp0_;
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_cell_renderer_lanes_properties[GITG_CELL_RENDERER_LANES_COMMIT_PROPERTY]);
#line 1322 "gitg-cell-renderer-lanes.c"
	}
}

GitgCommit*
gitg_cell_renderer_lanes_get_next_commit (GitgCellRendererLanes* self)
{
	GitgCommit* result;
	GitgCommit* _tmp0_;
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = self->priv->_next_commit;
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
	result = _tmp0_;
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 1339 "gitg-cell-renderer-lanes.c"
}

void
gitg_cell_renderer_lanes_set_next_commit (GitgCellRendererLanes* self,
                                          GitgCommit* value)
{
	GitgCommit* old_value;
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
	old_value = gitg_cell_renderer_lanes_get_next_commit (self);
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (old_value != value) {
#line 1353 "gitg-cell-renderer-lanes.c"
		GitgCommit* _tmp0_;
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
		_g_object_unref0 (self->priv->_next_commit);
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
		self->priv->_next_commit = _tmp0_;
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_cell_renderer_lanes_properties[GITG_CELL_RENDERER_LANES_NEXT_COMMIT_PROPERTY]);
#line 1363 "gitg-cell-renderer-lanes.c"
	}
}

guint
gitg_cell_renderer_lanes_get_lane_width (GitgCellRendererLanes* self)
{
	guint result;
#line 26 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 26 "../libgitg/gitg-cell-renderer-lanes.vala"
	result = self->priv->_lane_width;
#line 26 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 1377 "gitg-cell-renderer-lanes.c"
}

void
gitg_cell_renderer_lanes_set_lane_width (GitgCellRendererLanes* self,
                                         guint value)
{
	guint old_value;
#line 26 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 26 "../libgitg/gitg-cell-renderer-lanes.vala"
	old_value = gitg_cell_renderer_lanes_get_lane_width (self);
#line 26 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (old_value != value) {
#line 26 "../libgitg/gitg-cell-renderer-lanes.vala"
		self->priv->_lane_width = value;
#line 26 "../libgitg/gitg-cell-renderer-lanes.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_cell_renderer_lanes_properties[GITG_CELL_RENDERER_LANES_LANE_WIDTH_PROPERTY]);
#line 1395 "gitg-cell-renderer-lanes.c"
	}
}

guint
gitg_cell_renderer_lanes_get_dot_width (GitgCellRendererLanes* self)
{
	guint result;
#line 27 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 27 "../libgitg/gitg-cell-renderer-lanes.vala"
	result = self->priv->_dot_width;
#line 27 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 1409 "gitg-cell-renderer-lanes.c"
}

void
gitg_cell_renderer_lanes_set_dot_width (GitgCellRendererLanes* self,
                                        guint value)
{
	guint old_value;
#line 27 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 27 "../libgitg/gitg-cell-renderer-lanes.vala"
	old_value = gitg_cell_renderer_lanes_get_dot_width (self);
#line 27 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (old_value != value) {
#line 27 "../libgitg/gitg-cell-renderer-lanes.vala"
		self->priv->_dot_width = value;
#line 27 "../libgitg/gitg-cell-renderer-lanes.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_cell_renderer_lanes_properties[GITG_CELL_RENDERER_LANES_DOT_WIDTH_PROPERTY]);
#line 1427 "gitg-cell-renderer-lanes.c"
	}
}

GSList*
gitg_cell_renderer_lanes_get_labels (GitgCellRendererLanes* self)
{
	GSList* result;
	GSList* _tmp0_;
#line 28 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = self->priv->_labels;
#line 28 "../libgitg/gitg-cell-renderer-lanes.vala"
	result = _tmp0_;
#line 28 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 1444 "gitg-cell-renderer-lanes.c"
}

void
gitg_cell_renderer_lanes_set_labels (GitgCellRendererLanes* self,
                                     GSList* value)
{
	GSList* old_value;
#line 28 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_if_fail (self != NULL);
#line 28 "../libgitg/gitg-cell-renderer-lanes.vala"
	old_value = gitg_cell_renderer_lanes_get_labels (self);
#line 28 "../libgitg/gitg-cell-renderer-lanes.vala"
	if (old_value != value) {
#line 28 "../libgitg/gitg-cell-renderer-lanes.vala"
		self->priv->_labels = value;
#line 28 "../libgitg/gitg-cell-renderer-lanes.vala"
		g_object_notify_by_pspec ((GObject *) self, gitg_cell_renderer_lanes_properties[GITG_CELL_RENDERER_LANES_LABELS_PROPERTY]);
#line 1462 "gitg-cell-renderer-lanes.c"
	}
}

static guint
gitg_cell_renderer_lanes_get_num_visible_lanes (GitgCellRendererLanes* self)
{
	guint result;
	gint ret = 0;
	gint trailing_hidden = 0;
	GitgCommit* _tmp0_;
	GSList* _tmp1_;
#line 36 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 38 "../libgitg/gitg-cell-renderer-lanes.vala"
	ret = 0;
#line 39 "../libgitg/gitg-cell-renderer-lanes.vala"
	trailing_hidden = 0;
#line 41 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp0_ = self->priv->_commit;
#line 41 "../libgitg/gitg-cell-renderer-lanes.vala"
	_tmp1_ = gitg_commit_get_lanes (_tmp0_);
#line 1484 "gitg-cell-renderer-lanes.c"
	{
		GSList* lane_collection = NULL;
		GSList* lane_it = NULL;
#line 41 "../libgitg/gitg-cell-renderer-lanes.vala"
		lane_collection = _tmp1_;
#line 41 "../libgitg/gitg-cell-renderer-lanes.vala"
		for (lane_it = lane_collection; lane_it != NULL; lane_it = lane_it->next) {
#line 1492 "gitg-cell-renderer-lanes.c"
			GitgLane* _tmp2_;
			GitgLane* lane = NULL;
#line 41 "../libgitg/gitg-cell-renderer-lanes.vala"
			_tmp2_ = _g_object_ref0 ((GitgLane*) lane_it->data);
#line 41 "../libgitg/gitg-cell-renderer-lanes.vala"
			lane = _tmp2_;
#line 1499 "gitg-cell-renderer-lanes.c"
			{
				gint _tmp3_;
				GitgLane* _tmp4_;
#line 43 "../libgitg/gitg-cell-renderer-lanes.vala"
				ret = ret + 1;
#line 43 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp3_ = ret;
#line 45 "../libgitg/gitg-cell-renderer-lanes.vala"
				_tmp4_ = lane;
#line 45 "../libgitg/gitg-cell-renderer-lanes.vala"
				if ((_tmp4_->tag & GITG_LANE_TAG_HIDDEN) != 0) {
#line 1511 "gitg-cell-renderer-lanes.c"
					gint _tmp5_;
#line 47 "../libgitg/gitg-cell-renderer-lanes.vala"
					_tmp5_ = trailing_hidden;
#line 47 "../libgitg/gitg-cell-renderer-lanes.vala"
					trailing_hidden = _tmp5_ + 1;
#line 1517 "gitg-cell-renderer-lanes.c"
				} else {
#line 51 "../libgitg/gitg-cell-renderer-lanes.vala"
					trailing_hidden = 0;
#line 1521 "gitg-cell-renderer-lanes.c"
				}
#line 41 "../libgitg/gitg-cell-renderer-lanes.vala"
				_g_object_unref0 (lane);
#line 1525 "gitg-cell-renderer-lanes.c"
			}
		}
	}
#line 55 "../libgitg/gitg-cell-renderer-lanes.vala"
	result = (guint) (ret - trailing_hidden);
#line 55 "../libgitg/gitg-cell-renderer-lanes.vala"
	return result;
#line 1533 "gitg-cell-renderer-lanes.c"
}

static void
gitg_cell_renderer_lanes_class_init (GitgCellRendererLanesClass * klass,
                                     gpointer klass_data)
{
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	gitg_cell_renderer_lanes_parent_class = g_type_class_peek_parent (klass);
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_type_class_adjust_private_offset (klass, &GitgCellRendererLanes_private_offset);
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	((GtkCellRendererClass *) klass)->get_preferred_width = (void (*) (GtkCellRenderer*, GtkWidget*, gint*, gint*)) gitg_cell_renderer_lanes_real_get_preferred_width;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	((GtkCellRendererClass *) klass)->render = (void (*) (GtkCellRenderer*, cairo_t*, GtkWidget*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) gitg_cell_renderer_lanes_real_render;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gitg_cell_renderer_lanes_get_property;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gitg_cell_renderer_lanes_set_property;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	G_OBJECT_CLASS (klass)->finalize = gitg_cell_renderer_lanes_finalize;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_CELL_RENDERER_LANES_COMMIT_PROPERTY, gitg_cell_renderer_lanes_properties[GITG_CELL_RENDERER_LANES_COMMIT_PROPERTY] = g_param_spec_object ("commit", "commit", "commit", GITG_TYPE_COMMIT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_CELL_RENDERER_LANES_NEXT_COMMIT_PROPERTY, gitg_cell_renderer_lanes_properties[GITG_CELL_RENDERER_LANES_NEXT_COMMIT_PROPERTY] = g_param_spec_object ("next-commit", "next-commit", "next-commit", GITG_TYPE_COMMIT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_CELL_RENDERER_LANES_LANE_WIDTH_PROPERTY, gitg_cell_renderer_lanes_properties[GITG_CELL_RENDERER_LANES_LANE_WIDTH_PROPERTY] = g_param_spec_uint ("lane-width", "lane-width", "lane-width", 0, G_MAXUINT, (guint) 16, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_CELL_RENDERER_LANES_DOT_WIDTH_PROPERTY, gitg_cell_renderer_lanes_properties[GITG_CELL_RENDERER_LANES_DOT_WIDTH_PROPERTY] = g_param_spec_uint ("dot-width", "dot-width", "dot-width", 0, G_MAXUINT, (guint) 10, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GITG_CELL_RENDERER_LANES_LABELS_PROPERTY, gitg_cell_renderer_lanes_properties[GITG_CELL_RENDERER_LANES_LABELS_PROPERTY] = g_param_spec_pointer ("labels", "labels", "labels", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1564 "gitg-cell-renderer-lanes.c"
}

static void
gitg_cell_renderer_lanes_instance_init (GitgCellRendererLanes * self,
                                        gpointer klass)
{
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	self->priv = gitg_cell_renderer_lanes_get_instance_private (self);
#line 26 "../libgitg/gitg-cell-renderer-lanes.vala"
	self->priv->_lane_width = (guint) 16;
#line 27 "../libgitg/gitg-cell-renderer-lanes.vala"
	self->priv->_dot_width = (guint) 10;
#line 1577 "gitg-cell-renderer-lanes.c"
}

static void
gitg_cell_renderer_lanes_finalize (GObject * obj)
{
	GitgCellRendererLanes * self;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_CELL_RENDERER_LANES, GitgCellRendererLanes);
#line 24 "../libgitg/gitg-cell-renderer-lanes.vala"
	_g_object_unref0 (self->priv->_commit);
#line 25 "../libgitg/gitg-cell-renderer-lanes.vala"
	_g_object_unref0 (self->priv->_next_commit);
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	G_OBJECT_CLASS (gitg_cell_renderer_lanes_parent_class)->finalize (obj);
#line 1592 "gitg-cell-renderer-lanes.c"
}

 G_GNUC_NO_INLINE static GType
gitg_cell_renderer_lanes_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GitgCellRendererLanesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_cell_renderer_lanes_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgCellRendererLanes), 0, (GInstanceInitFunc) gitg_cell_renderer_lanes_instance_init, NULL };
	GType gitg_cell_renderer_lanes_type_id;
	gitg_cell_renderer_lanes_type_id = g_type_register_static (gtk_cell_renderer_text_get_type (), "GitgCellRendererLanes", &g_define_type_info, 0);
	GitgCellRendererLanes_private_offset = g_type_add_instance_private (gitg_cell_renderer_lanes_type_id, sizeof (GitgCellRendererLanesPrivate));
	return gitg_cell_renderer_lanes_type_id;
}

GType
gitg_cell_renderer_lanes_get_type (void)
{
	static gsize gitg_cell_renderer_lanes_type_id__once = 0;
	if (g_once_init_enter (&gitg_cell_renderer_lanes_type_id__once)) {
		GType gitg_cell_renderer_lanes_type_id;
		gitg_cell_renderer_lanes_type_id = gitg_cell_renderer_lanes_get_type_once ();
		g_once_init_leave (&gitg_cell_renderer_lanes_type_id__once, gitg_cell_renderer_lanes_type_id);
	}
	return gitg_cell_renderer_lanes_type_id__once;
}

static void
_vala_gitg_cell_renderer_lanes_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	GitgCellRendererLanes * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_CELL_RENDERER_LANES, GitgCellRendererLanes);
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	switch (property_id) {
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		case GITG_CELL_RENDERER_LANES_COMMIT_PROPERTY:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		g_value_set_object (value, gitg_cell_renderer_lanes_get_commit (self));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		case GITG_CELL_RENDERER_LANES_NEXT_COMMIT_PROPERTY:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		g_value_set_object (value, gitg_cell_renderer_lanes_get_next_commit (self));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		case GITG_CELL_RENDERER_LANES_LANE_WIDTH_PROPERTY:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		g_value_set_uint (value, gitg_cell_renderer_lanes_get_lane_width (self));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		case GITG_CELL_RENDERER_LANES_DOT_WIDTH_PROPERTY:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		g_value_set_uint (value, gitg_cell_renderer_lanes_get_dot_width (self));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		case GITG_CELL_RENDERER_LANES_LABELS_PROPERTY:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		g_value_set_pointer (value, gitg_cell_renderer_lanes_get_labels (self));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 1657 "gitg-cell-renderer-lanes.c"
		default:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 1663 "gitg-cell-renderer-lanes.c"
	}
}

static void
_vala_gitg_cell_renderer_lanes_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	GitgCellRendererLanes * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GITG_TYPE_CELL_RENDERER_LANES, GitgCellRendererLanes);
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
	switch (property_id) {
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		case GITG_CELL_RENDERER_LANES_COMMIT_PROPERTY:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		gitg_cell_renderer_lanes_set_commit (self, g_value_get_object (value));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		case GITG_CELL_RENDERER_LANES_NEXT_COMMIT_PROPERTY:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		gitg_cell_renderer_lanes_set_next_commit (self, g_value_get_object (value));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		case GITG_CELL_RENDERER_LANES_LANE_WIDTH_PROPERTY:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		gitg_cell_renderer_lanes_set_lane_width (self, g_value_get_uint (value));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		case GITG_CELL_RENDERER_LANES_DOT_WIDTH_PROPERTY:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		gitg_cell_renderer_lanes_set_dot_width (self, g_value_get_uint (value));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		case GITG_CELL_RENDERER_LANES_LABELS_PROPERTY:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		gitg_cell_renderer_lanes_set_labels (self, g_value_get_pointer (value));
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 1707 "gitg-cell-renderer-lanes.c"
		default:
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../libgitg/gitg-cell-renderer-lanes.vala"
		break;
#line 1713 "gitg-cell-renderer-lanes.c"
	}
}

