/* gitg-credentials-manager.c generated by valac 0.56.18, the Vala compiler
 * generated from gitg-credentials-manager.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2014 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgitg.h"
#include <libgit2-glib/ggit.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <libsecret/secret.h>
#include <stdio.h>
#include <gio/gio.h>
#include "config.h"
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _gitg_credentials_manager_unref0(var) ((var == NULL) ? NULL : (var = (gitg_credentials_manager_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
typedef struct _GitgParamSpecCredentialsManager GitgParamSpecCredentialsManager;

struct _GitgCredentialsManagerPrivate {
	GgitConfig* d_config;
	GtkWindow* d_window;
	GeeHashMap* d_usermap;
	gboolean d_save_user_in_config;
	gchar* d_last_user;
	GeeHashMap* d_auth_tried;
};

struct _Block5Data {
	int _ref_count_;
	GitgCredentialsManager* self;
	GMutex mutex;
	GCond cond;
	GtkResponseType response;
	gchar* password;
	gchar* newusername;
	GitgAuthenticationLifeTime lifetime;
	gchar* url;
	gchar* username;
};

struct _GitgParamSpecCredentialsManager {
	GParamSpec parent_instance;
};

static gint GitgCredentialsManager_private_offset;
static gpointer gitg_credentials_manager_parent_class = NULL;
static SecretSchema* gitg_credentials_manager_s_secret_schema;
static SecretSchema* gitg_credentials_manager_s_secret_schema = NULL;
static GRegex* gitg_credentials_manager_s_ssh_short_form;
static GRegex* gitg_credentials_manager_s_ssh_short_form = NULL;

static gchar* gitg_credentials_manager_lookup_user (GitgCredentialsManager* self,
                                             const gchar* host);
static gint _____lambda40_ (GitgCredentialsManager* self,
                     GMatchInfo* info,
                     const gchar* value);
static gint ______lambda40__ggit_config_match_callback (GMatchInfo* match_info,
                                                 const gchar* value,
                                                 gpointer self);
static GgitCred* gitg_credentials_manager_user_pass_dialog (GitgCredentialsManager* self,
                                                     const gchar* url,
                                                     const gchar* scheme,
                                                     const gchar* host,
                                                     const gchar* username,
                                                     GError** error);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean __lambda41_ (Block5Data* _data5_);
static gboolean ___lambda41__gsource_func (gpointer self);
static void _g_free0_ (gpointer var);
static void ___lambda42_ (GitgCredentialsManager* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda42__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void ___lambda43_ (GitgCredentialsManager* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda43__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static GgitCred* gitg_credentials_manager_query_user_pass (GitgCredentialsManager* self,
                                                    const gchar* url,
                                                    const gchar* username,
                                                    GError** error);
static void gitg_credentials_manager_finalize (GitgCredentialsManager * obj);
static GType gitg_credentials_manager_get_type_once (void);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);

GQuark
gitg_credentials_error_quark (void)
{
	return g_quark_from_static_string ("gitg-credentials-error-quark");
}

 G_GNUC_NO_INLINE static GType
gitg_credentials_error_get_type_once (void)
{
	static const GEnumValue values[] = {{GITG_CREDENTIALS_ERROR_CANCELLED, "GITG_CREDENTIALS_ERROR_CANCELLED", "cancelled"}, {0, NULL, NULL}};
	GType gitg_credentials_error_type_id;
	gitg_credentials_error_type_id = g_enum_register_static ("GitgCredentialsError", values);
	return gitg_credentials_error_type_id;
}

GType
gitg_credentials_error_get_type (void)
{
	static gsize gitg_credentials_error_type_id__once = 0;
	if (g_once_init_enter (&gitg_credentials_error_type_id__once)) {
		GType gitg_credentials_error_type_id;
		gitg_credentials_error_type_id = gitg_credentials_error_get_type_once ();
		g_once_init_leave (&gitg_credentials_error_type_id__once, gitg_credentials_error_type_id);
	}
	return gitg_credentials_error_type_id__once;
}

static inline gpointer
gitg_credentials_manager_get_instance_private (GitgCredentialsManager* self)
{
	return G_STRUCT_MEMBER_P (self, GitgCredentialsManager_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 56 "../libgitg/gitg-credentials-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 172 "gitg-credentials-manager.c"
}

GitgCredentialsManager*
gitg_credentials_manager_construct (GType object_type,
                                    GgitConfig* config,
                                    GtkWindow* window,
                                    gboolean save_user_in_config)
{
	GitgCredentialsManager* self = NULL;
	GgitConfig* _tmp0_;
	GeeHashMap* _tmp1_;
	GtkWindow* _tmp2_;
#line 54 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 54 "../libgitg/gitg-credentials-manager.vala"
	self = (GitgCredentialsManager*) g_type_create_instance (object_type);
#line 56 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = _g_object_ref0 (config);
#line 56 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_config);
#line 56 "../libgitg/gitg-credentials-manager.vala"
	self->priv->d_config = _tmp0_;
#line 57 "../libgitg/gitg-credentials-manager.vala"
	self->priv->d_save_user_in_config = save_user_in_config;
#line 58 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ggit_credtype_get_type (), NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 58 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_auth_tried);
#line 58 "../libgitg/gitg-credentials-manager.vala"
	self->priv->d_auth_tried = _tmp1_;
#line 59 "../libgitg/gitg-credentials-manager.vala"
	_tmp2_ = _g_object_ref0 (window);
#line 59 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_window);
#line 59 "../libgitg/gitg-credentials-manager.vala"
	self->priv->d_window = _tmp2_;
#line 54 "../libgitg/gitg-credentials-manager.vala"
	return self;
#line 211 "gitg-credentials-manager.c"
}

GitgCredentialsManager*
gitg_credentials_manager_new (GgitConfig* config,
                              GtkWindow* window,
                              gboolean save_user_in_config)
{
#line 54 "../libgitg/gitg-credentials-manager.vala"
	return gitg_credentials_manager_construct (GITG_TYPE_CREDENTIALS_MANAGER, config, window, save_user_in_config);
#line 221 "gitg-credentials-manager.c"
}

static gint
_____lambda40_ (GitgCredentialsManager* self,
                GMatchInfo* info,
                const gchar* value)
{
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint result;
#line 74 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (info != NULL, 0);
#line 74 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 75 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = self->priv->d_usermap;
#line 75 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = g_match_info_fetch (info, 1);
#line 75 "../libgitg/gitg-credentials-manager.vala"
	_tmp2_ = _tmp1_;
#line 75 "../libgitg/gitg-credentials-manager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp0_, _tmp2_, value);
#line 75 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (_tmp2_);
#line 76 "../libgitg/gitg-credentials-manager.vala"
	result = 0;
#line 76 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 251 "gitg-credentials-manager.c"
}

static gint
______lambda40__ggit_config_match_callback (GMatchInfo* match_info,
                                            const gchar* value,
                                            gpointer self)
{
	gint result;
	result = _____lambda40_ ((GitgCredentialsManager*) self, match_info, value);
#line 74 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 263 "gitg-credentials-manager.c"
}

static gchar*
gitg_credentials_manager_lookup_user (GitgCredentialsManager* self,
                                      const gchar* host)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp11_;
	gpointer _tmp12_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 62 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (host != NULL, NULL);
#line 64 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = self->priv->d_usermap;
#line 64 "../libgitg/gitg-credentials-manager.vala"
	if (_tmp0_ == NULL) {
#line 283 "gitg-credentials-manager.c"
		GeeHashMap* _tmp1_;
		GgitConfig* _tmp2_;
#line 66 "../libgitg/gitg-credentials-manager.vala"
		_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 66 "../libgitg/gitg-credentials-manager.vala"
		_g_object_unref0 (self->priv->d_usermap);
#line 66 "../libgitg/gitg-credentials-manager.vala"
		self->priv->d_usermap = _tmp1_;
#line 68 "../libgitg/gitg-credentials-manager.vala"
		_tmp2_ = self->priv->d_config;
#line 68 "../libgitg/gitg-credentials-manager.vala"
		if (_tmp2_ != NULL) {
#line 296 "gitg-credentials-manager.c"
			{
				GRegex* r = NULL;
				GRegex* _tmp3_;
				GgitConfig* _tmp4_ = NULL;
				GgitConfig* _tmp5_;
				GgitConfig* _tmp6_;
				GRegex* _tmp7_;
#line 72 "../libgitg/gitg-credentials-manager.vala"
				_tmp3_ = g_regex_new ("credential\\.(.*)\\.username", 0, 0, &_inner_error0_);
#line 72 "../libgitg/gitg-credentials-manager.vala"
				r = _tmp3_;
#line 72 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 310 "gitg-credentials-manager.c"
					goto __catch0_g_error;
				}
#line 74 "../libgitg/gitg-credentials-manager.vala"
				_tmp5_ = self->priv->d_config;
#line 74 "../libgitg/gitg-credentials-manager.vala"
				_tmp6_ = ggit_config_snapshot (_tmp5_, &_inner_error0_);
#line 74 "../libgitg/gitg-credentials-manager.vala"
				_tmp4_ = _tmp6_;
#line 74 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../libgitg/gitg-credentials-manager.vala"
					_g_regex_unref0 (r);
#line 323 "gitg-credentials-manager.c"
					goto __catch0_g_error;
				}
#line 74 "../libgitg/gitg-credentials-manager.vala"
				_tmp7_ = r;
#line 74 "../libgitg/gitg-credentials-manager.vala"
				ggit_config_match_foreach (_tmp4_, _tmp7_, ______lambda40__ggit_config_match_callback, self, &_inner_error0_);
#line 74 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../libgitg/gitg-credentials-manager.vala"
					_g_object_unref0 (_tmp4_);
#line 74 "../libgitg/gitg-credentials-manager.vala"
					_g_regex_unref0 (r);
#line 336 "gitg-credentials-manager.c"
					goto __catch0_g_error;
				}
#line 70 "../libgitg/gitg-credentials-manager.vala"
				_g_object_unref0 (_tmp4_);
#line 70 "../libgitg/gitg-credentials-manager.vala"
				_g_regex_unref0 (r);
#line 343 "gitg-credentials-manager.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				FILE* _tmp8_;
				GError* _tmp9_;
				const gchar* _tmp10_;
#line 70 "../libgitg/gitg-credentials-manager.vala"
				e = _inner_error0_;
#line 70 "../libgitg/gitg-credentials-manager.vala"
				_inner_error0_ = NULL;
#line 81 "../libgitg/gitg-credentials-manager.vala"
				_tmp8_ = stderr;
#line 81 "../libgitg/gitg-credentials-manager.vala"
				_tmp9_ = e;
#line 81 "../libgitg/gitg-credentials-manager.vala"
				_tmp10_ = _tmp9_->message;
#line 81 "../libgitg/gitg-credentials-manager.vala"
				fprintf (_tmp8_, "Could not get username from git config: %s\n", _tmp10_);
#line 70 "../libgitg/gitg-credentials-manager.vala"
				_g_error_free0 (e);
#line 366 "gitg-credentials-manager.c"
			}
			__finally0:
#line 70 "../libgitg/gitg-credentials-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../libgitg/gitg-credentials-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../libgitg/gitg-credentials-manager.vala"
				g_clear_error (&_inner_error0_);
#line 70 "../libgitg/gitg-credentials-manager.vala"
				return NULL;
#line 377 "gitg-credentials-manager.c"
			}
		}
	}
#line 86 "../libgitg/gitg-credentials-manager.vala"
	_tmp11_ = self->priv->d_usermap;
#line 86 "../libgitg/gitg-credentials-manager.vala"
	_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp11_, host);
#line 86 "../libgitg/gitg-credentials-manager.vala"
	result = (gchar*) _tmp12_;
#line 86 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 389 "gitg-credentials-manager.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 89 "../libgitg/gitg-credentials-manager.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	return _data5_;
#line 399 "gitg-credentials-manager.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 89 "../libgitg/gitg-credentials-manager.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 409 "gitg-credentials-manager.c"
		GitgCredentialsManager* self;
#line 89 "../libgitg/gitg-credentials-manager.vala"
		self = _data5_->self;
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->newusername);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->password);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_vala_clear_GCond (&_data5_->cond);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_vala_clear_GMutex (&_data5_->mutex);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->url);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->username);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		_gitg_credentials_manager_unref0 (self);
#line 89 "../libgitg/gitg-credentials-manager.vala"
		g_slice_free (Block5Data, _data5_);
#line 429 "gitg-credentials-manager.c"
	}
}

static gboolean
__lambda41_ (Block5Data* _data5_)
{
	GitgCredentialsManager* self;
	GgitCredtype tried = 0U;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GitgAuthenticationDialog* d = NULL;
	GitgAuthenticationDialog* _tmp2_;
	GitgAuthenticationDialog* _tmp3_;
	GtkWindow* _tmp4_;
	GitgAuthenticationDialog* _tmp5_;
	GitgAuthenticationDialog* _tmp17_;
	gboolean result;
#line 102 "../libgitg/gitg-credentials-manager.vala"
	self = _data5_->self;
#line 105 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = self->priv->d_auth_tried;
#line 105 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _data5_->username);
#line 105 "../libgitg/gitg-credentials-manager.vala"
	tried = ((GgitCredtype) ((gintptr) _tmp1_)) & (~GGIT_CREDTYPE_SSH_KEY);
#line 107 "../libgitg/gitg-credentials-manager.vala"
	_tmp2_ = gitg_authentication_dialog_new (_data5_->url, _data5_->username, tried != 0);
#line 107 "../libgitg/gitg-credentials-manager.vala"
	g_object_ref_sink (_tmp2_);
#line 107 "../libgitg/gitg-credentials-manager.vala"
	d = _tmp2_;
#line 108 "../libgitg/gitg-credentials-manager.vala"
	_tmp3_ = d;
#line 108 "../libgitg/gitg-credentials-manager.vala"
	_tmp4_ = self->priv->d_window;
#line 108 "../libgitg/gitg-credentials-manager.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp3_, _tmp4_);
#line 110 "../libgitg/gitg-credentials-manager.vala"
	_tmp5_ = d;
#line 110 "../libgitg/gitg-credentials-manager.vala"
	_data5_->response = (GtkResponseType) gtk_dialog_run ((GtkDialog*) _tmp5_);
#line 112 "../libgitg/gitg-credentials-manager.vala"
	if (_data5_->response == GTK_RESPONSE_OK) {
#line 473 "gitg-credentials-manager.c"
		GitgAuthenticationDialog* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		GitgAuthenticationDialog* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		GitgAuthenticationDialog* _tmp14_;
		GitgAuthenticationLifeTime _tmp15_;
		GitgAuthenticationLifeTime _tmp16_;
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_tmp6_ = d;
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_tmp7_ = gitg_authentication_dialog_get_username (_tmp6_);
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_tmp8_ = _tmp7_;
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->newusername);
#line 114 "../libgitg/gitg-credentials-manager.vala"
		_data5_->newusername = _tmp9_;
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_tmp10_ = d;
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_tmp11_ = gitg_authentication_dialog_get_password (_tmp10_);
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_tmp12_ = _tmp11_;
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_tmp13_ = g_strdup (_tmp12_);
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_data5_->password);
#line 115 "../libgitg/gitg-credentials-manager.vala"
		_data5_->password = _tmp13_;
#line 116 "../libgitg/gitg-credentials-manager.vala"
		_tmp14_ = d;
#line 116 "../libgitg/gitg-credentials-manager.vala"
		_tmp15_ = gitg_authentication_dialog_get_life_time (_tmp14_);
#line 116 "../libgitg/gitg-credentials-manager.vala"
		_tmp16_ = _tmp15_;
#line 116 "../libgitg/gitg-credentials-manager.vala"
		_data5_->lifetime = _tmp16_;
#line 517 "gitg-credentials-manager.c"
	}
#line 119 "../libgitg/gitg-credentials-manager.vala"
	_tmp17_ = d;
#line 119 "../libgitg/gitg-credentials-manager.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp17_);
#line 121 "../libgitg/gitg-credentials-manager.vala"
	g_mutex_lock (&_data5_->mutex);
#line 122 "../libgitg/gitg-credentials-manager.vala"
	g_cond_signal (&_data5_->cond);
#line 123 "../libgitg/gitg-credentials-manager.vala"
	g_mutex_unlock (&_data5_->mutex);
#line 125 "../libgitg/gitg-credentials-manager.vala"
	result = FALSE;
#line 125 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (d);
#line 125 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 535 "gitg-credentials-manager.c"
}

static gboolean
___lambda41__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda41_ (self);
#line 102 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 545 "gitg-credentials-manager.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 558 "gitg-credentials-manager.c"
}

static void
_g_free0_ (gpointer var)
{
#line 159 "../libgitg/gitg-credentials-manager.vala"
	var = (g_free (var), NULL);
#line 566 "gitg-credentials-manager.c"
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 174 "../libgitg/gitg-credentials-manager.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 574 "gitg-credentials-manager.c"
}

static void
___lambda42_ (GitgCredentialsManager* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 180 "../libgitg/gitg-credentials-manager.vala"
	g_return_if_fail (res != NULL);
#line 585 "gitg-credentials-manager.c"
	{
#line 183 "../libgitg/gitg-credentials-manager.vala"
		secret_password_store_finish (res, &_inner_error0_);
#line 183 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 591 "gitg-credentials-manager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 181 "../libgitg/gitg-credentials-manager.vala"
		e = _inner_error0_;
#line 181 "../libgitg/gitg-credentials-manager.vala"
		_inner_error0_ = NULL;
#line 187 "../libgitg/gitg-credentials-manager.vala"
		_tmp0_ = stderr;
#line 187 "../libgitg/gitg-credentials-manager.vala"
		_tmp1_ = e;
#line 187 "../libgitg/gitg-credentials-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 187 "../libgitg/gitg-credentials-manager.vala"
		fprintf (_tmp0_, "Failed to store secret in keyring: %s\n", _tmp2_);
#line 181 "../libgitg/gitg-credentials-manager.vala"
		_g_error_free0 (e);
#line 616 "gitg-credentials-manager.c"
	}
	__finally0:
#line 181 "../libgitg/gitg-credentials-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 181 "../libgitg/gitg-credentials-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 181 "../libgitg/gitg-credentials-manager.vala"
		g_clear_error (&_inner_error0_);
#line 181 "../libgitg/gitg-credentials-manager.vala"
		return;
#line 627 "gitg-credentials-manager.c"
	}
}

static void
____lambda42__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 174 "../libgitg/gitg-credentials-manager.vala"
	___lambda42_ ((GitgCredentialsManager*) self, source_object, res);
#line 174 "../libgitg/gitg-credentials-manager.vala"
	gitg_credentials_manager_unref (self);
#line 640 "gitg-credentials-manager.c"
}

static void
___lambda43_ (GitgCredentialsManager* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 193 "../libgitg/gitg-credentials-manager.vala"
	g_return_if_fail (res != NULL);
#line 651 "gitg-credentials-manager.c"
	{
#line 196 "../libgitg/gitg-credentials-manager.vala"
		secret_password_clear_finish (res, &_inner_error0_);
#line 196 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 657 "gitg-credentials-manager.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp0_;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 194 "../libgitg/gitg-credentials-manager.vala"
		e = _inner_error0_;
#line 194 "../libgitg/gitg-credentials-manager.vala"
		_inner_error0_ = NULL;
#line 200 "../libgitg/gitg-credentials-manager.vala"
		_tmp0_ = stderr;
#line 200 "../libgitg/gitg-credentials-manager.vala"
		_tmp1_ = e;
#line 200 "../libgitg/gitg-credentials-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 200 "../libgitg/gitg-credentials-manager.vala"
		fprintf (_tmp0_, "Failed to clear secret from keyring: %s\n", _tmp2_);
#line 194 "../libgitg/gitg-credentials-manager.vala"
		_g_error_free0 (e);
#line 682 "gitg-credentials-manager.c"
	}
	__finally0:
#line 194 "../libgitg/gitg-credentials-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 194 "../libgitg/gitg-credentials-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 194 "../libgitg/gitg-credentials-manager.vala"
		g_clear_error (&_inner_error0_);
#line 194 "../libgitg/gitg-credentials-manager.vala"
		return;
#line 693 "gitg-credentials-manager.c"
	}
}

static void
____lambda43__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 193 "../libgitg/gitg-credentials-manager.vala"
	___lambda43_ ((GitgCredentialsManager*) self, source_object, res);
#line 193 "../libgitg/gitg-credentials-manager.vala"
	gitg_credentials_manager_unref (self);
#line 706 "gitg-credentials-manager.c"
}

static GgitCred*
gitg_credentials_manager_user_pass_dialog (GitgCredentialsManager* self,
                                           const gchar* url,
                                           const gchar* scheme,
                                           const gchar* host,
                                           const gchar* username,
                                           GError** error)
{
	Block5Data* _data5_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GHashTable* attributes = NULL;
	GHashFunc _tmp29_;
	GEqualFunc _tmp30_;
	GHashTable* _tmp31_;
	GHashTable* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	GHashTable* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	GHashTable* _tmp38_;
	gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	GeeHashMap* _tmp55_;
	const gchar* _tmp56_;
	GgitCredPlaintext* _tmp57_ = NULL;
	const gchar* _tmp58_;
	const gchar* _tmp59_;
	GgitCredPlaintext* _tmp60_;
	GgitCredPlaintext* _tmp61_;
	GError* _inner_error0_ = NULL;
	GgitCred* result;
#line 89 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (scheme != NULL, NULL);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (host != NULL, NULL);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_data5_->_ref_count_ = 1;
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_data5_->self = gitg_credentials_manager_ref (self);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = g_strdup (url);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (_data5_->url);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_data5_->url = _tmp0_;
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = g_strdup (username);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (_data5_->username);
#line 89 "../libgitg/gitg-credentials-manager.vala"
	_data5_->username = _tmp1_;
#line 91 "../libgitg/gitg-credentials-manager.vala"
	g_mutex_init (&_data5_->mutex);
#line 92 "../libgitg/gitg-credentials-manager.vala"
	g_mutex_lock (&_data5_->mutex);
#line 94 "../libgitg/gitg-credentials-manager.vala"
	g_cond_init (&_data5_->cond);
#line 96 "../libgitg/gitg-credentials-manager.vala"
	_data5_->response = GTK_RESPONSE_CANCEL;
#line 98 "../libgitg/gitg-credentials-manager.vala"
	_tmp2_ = g_strdup ("");
#line 98 "../libgitg/gitg-credentials-manager.vala"
	_data5_->password = _tmp2_;
#line 99 "../libgitg/gitg-credentials-manager.vala"
	_tmp3_ = g_strdup ("");
#line 99 "../libgitg/gitg-credentials-manager.vala"
	_data5_->newusername = _tmp3_;
#line 100 "../libgitg/gitg-credentials-manager.vala"
	_data5_->lifetime = GITG_AUTHENTICATION_LIFE_TIME_FORGET;
#line 102 "../libgitg/gitg-credentials-manager.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda41__gsource_func, block5_data_ref (_data5_), block5_data_unref);
#line 128 "../libgitg/gitg-credentials-manager.vala"
	g_cond_wait (&_data5_->cond, &_data5_->mutex);
#line 129 "../libgitg/gitg-credentials-manager.vala"
	g_mutex_unlock (&_data5_->mutex);
#line 131 "../libgitg/gitg-credentials-manager.vala"
	if (_data5_->response != GTK_RESPONSE_OK) {
#line 800 "gitg-credentials-manager.c"
		GError* _tmp4_;
#line 133 "../libgitg/gitg-credentials-manager.vala"
		_tmp4_ = g_error_new_literal (GITG_CREDENTIALS_ERROR, GITG_CREDENTIALS_ERROR_CANCELLED, "cancelled by user");
#line 133 "../libgitg/gitg-credentials-manager.vala"
		_inner_error0_ = _tmp4_;
#line 133 "../libgitg/gitg-credentials-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 133 "../libgitg/gitg-credentials-manager.vala"
		block5_data_unref (_data5_);
#line 133 "../libgitg/gitg-credentials-manager.vala"
		_data5_ = NULL;
#line 133 "../libgitg/gitg-credentials-manager.vala"
		return NULL;
#line 814 "gitg-credentials-manager.c"
	}
#line 136 "../libgitg/gitg-credentials-manager.vala"
	_tmp5_ = _data5_->newusername;
#line 136 "../libgitg/gitg-credentials-manager.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 136 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (self->priv->d_last_user);
#line 136 "../libgitg/gitg-credentials-manager.vala"
	self->priv->d_last_user = _tmp6_;
#line 139 "../libgitg/gitg-credentials-manager.vala"
	if (_data5_->username == NULL) {
#line 139 "../libgitg/gitg-credentials-manager.vala"
		_tmp7_ = TRUE;
#line 828 "gitg-credentials-manager.c"
	} else {
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		const gchar* _tmp10_;
#line 139 "../libgitg/gitg-credentials-manager.vala"
		_tmp10_ = _data5_->newusername;
#line 139 "../libgitg/gitg-credentials-manager.vala"
		if (g_strcmp0 (_tmp10_, _data5_->username) != 0) {
#line 837 "gitg-credentials-manager.c"
			GgitConfig* _tmp11_;
#line 139 "../libgitg/gitg-credentials-manager.vala"
			_tmp11_ = self->priv->d_config;
#line 139 "../libgitg/gitg-credentials-manager.vala"
			_tmp9_ = _tmp11_ != NULL;
#line 843 "gitg-credentials-manager.c"
		} else {
#line 139 "../libgitg/gitg-credentials-manager.vala"
			_tmp9_ = FALSE;
#line 847 "gitg-credentials-manager.c"
		}
#line 139 "../libgitg/gitg-credentials-manager.vala"
		if (_tmp9_) {
#line 139 "../libgitg/gitg-credentials-manager.vala"
			_tmp8_ = self->priv->d_save_user_in_config;
#line 853 "gitg-credentials-manager.c"
		} else {
#line 139 "../libgitg/gitg-credentials-manager.vala"
			_tmp8_ = FALSE;
#line 857 "gitg-credentials-manager.c"
		}
#line 139 "../libgitg/gitg-credentials-manager.vala"
		_tmp7_ = _tmp8_;
#line 861 "gitg-credentials-manager.c"
	}
#line 139 "../libgitg/gitg-credentials-manager.vala"
	if (_tmp7_) {
#line 865 "gitg-credentials-manager.c"
		GeeHashMap* _tmp12_;
#line 141 "../libgitg/gitg-credentials-manager.vala"
		_tmp12_ = self->priv->d_usermap;
#line 141 "../libgitg/gitg-credentials-manager.vala"
		if (_tmp12_ == NULL) {
#line 871 "gitg-credentials-manager.c"
			GeeHashMap* _tmp13_;
#line 143 "../libgitg/gitg-credentials-manager.vala"
			_tmp13_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 143 "../libgitg/gitg-credentials-manager.vala"
			_g_object_unref0 (self->priv->d_usermap);
#line 143 "../libgitg/gitg-credentials-manager.vala"
			self->priv->d_usermap = _tmp13_;
#line 879 "gitg-credentials-manager.c"
		}
		{
			gchar* hid = NULL;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			GgitConfig* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			const gchar* _tmp22_;
			GeeHashMap* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
#line 148 "../libgitg/gitg-credentials-manager.vala"
			_tmp14_ = string_to_string (scheme);
#line 148 "../libgitg/gitg-credentials-manager.vala"
			_tmp15_ = string_to_string (host);
#line 148 "../libgitg/gitg-credentials-manager.vala"
			_tmp16_ = g_strconcat (_tmp14_, "://", _tmp15_, NULL);
#line 148 "../libgitg/gitg-credentials-manager.vala"
			hid = _tmp16_;
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp17_ = self->priv->d_config;
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp18_ = hid;
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp19_ = string_to_string (_tmp18_);
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp20_ = g_strconcat ("credential.", _tmp19_, ".username", NULL);
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp21_ = _tmp20_;
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_tmp22_ = _data5_->newusername;
#line 150 "../libgitg/gitg-credentials-manager.vala"
			ggit_config_set_string (_tmp17_, _tmp21_, _tmp22_, &_inner_error0_);
#line 150 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (_tmp21_);
#line 150 "../libgitg/gitg-credentials-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (hid);
#line 923 "gitg-credentials-manager.c"
				goto __catch0_g_error;
			}
#line 151 "../libgitg/gitg-credentials-manager.vala"
			_tmp23_ = self->priv->d_usermap;
#line 151 "../libgitg/gitg-credentials-manager.vala"
			_tmp24_ = hid;
#line 151 "../libgitg/gitg-credentials-manager.vala"
			_tmp25_ = _data5_->newusername;
#line 151 "../libgitg/gitg-credentials-manager.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, _tmp24_, _tmp25_);
#line 146 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (hid);
#line 936 "gitg-credentials-manager.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			FILE* _tmp26_;
			GError* _tmp27_;
			const gchar* _tmp28_;
#line 146 "../libgitg/gitg-credentials-manager.vala"
			e = _inner_error0_;
#line 146 "../libgitg/gitg-credentials-manager.vala"
			_inner_error0_ = NULL;
#line 155 "../libgitg/gitg-credentials-manager.vala"
			_tmp26_ = stderr;
#line 155 "../libgitg/gitg-credentials-manager.vala"
			_tmp27_ = e;
#line 155 "../libgitg/gitg-credentials-manager.vala"
			_tmp28_ = _tmp27_->message;
#line 155 "../libgitg/gitg-credentials-manager.vala"
			fprintf (_tmp26_, "Failed to store username in config: %s\n", _tmp28_);
#line 146 "../libgitg/gitg-credentials-manager.vala"
			_g_error_free0 (e);
#line 959 "gitg-credentials-manager.c"
		}
		__finally0:
#line 146 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 146 "../libgitg/gitg-credentials-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 146 "../libgitg/gitg-credentials-manager.vala"
			block5_data_unref (_data5_);
#line 146 "../libgitg/gitg-credentials-manager.vala"
			_data5_ = NULL;
#line 146 "../libgitg/gitg-credentials-manager.vala"
			return NULL;
#line 972 "gitg-credentials-manager.c"
		}
	}
#line 159 "../libgitg/gitg-credentials-manager.vala"
	_tmp29_ = g_str_hash;
#line 159 "../libgitg/gitg-credentials-manager.vala"
	_tmp30_ = g_str_equal;
#line 159 "../libgitg/gitg-credentials-manager.vala"
	_tmp31_ = g_hash_table_new_full (_tmp29_, _tmp30_, _g_free0_, _g_free0_);
#line 159 "../libgitg/gitg-credentials-manager.vala"
	attributes = _tmp31_;
#line 160 "../libgitg/gitg-credentials-manager.vala"
	_tmp32_ = attributes;
#line 160 "../libgitg/gitg-credentials-manager.vala"
	_tmp33_ = g_strdup ("scheme");
#line 160 "../libgitg/gitg-credentials-manager.vala"
	_tmp34_ = g_strdup (scheme);
#line 160 "../libgitg/gitg-credentials-manager.vala"
	g_hash_table_insert (_tmp32_, _tmp33_, _tmp34_);
#line 161 "../libgitg/gitg-credentials-manager.vala"
	_tmp35_ = attributes;
#line 161 "../libgitg/gitg-credentials-manager.vala"
	_tmp36_ = g_strdup ("host");
#line 161 "../libgitg/gitg-credentials-manager.vala"
	_tmp37_ = g_strdup (host);
#line 161 "../libgitg/gitg-credentials-manager.vala"
	g_hash_table_insert (_tmp35_, _tmp36_, _tmp37_);
#line 162 "../libgitg/gitg-credentials-manager.vala"
	_tmp38_ = attributes;
#line 162 "../libgitg/gitg-credentials-manager.vala"
	_tmp39_ = g_strdup ("user");
#line 162 "../libgitg/gitg-credentials-manager.vala"
	_tmp40_ = _data5_->newusername;
#line 162 "../libgitg/gitg-credentials-manager.vala"
	_tmp41_ = g_strdup (_tmp40_);
#line 162 "../libgitg/gitg-credentials-manager.vala"
	g_hash_table_insert (_tmp38_, _tmp39_, _tmp41_);
#line 165 "../libgitg/gitg-credentials-manager.vala"
	if (_data5_->lifetime != GITG_AUTHENTICATION_LIFE_TIME_FORGET) {
#line 1011 "gitg-credentials-manager.c"
		gchar* collection = NULL;
		SecretSchema* _tmp43_;
		GHashTable* _tmp44_;
		GHashTable* _tmp45_;
		const gchar* _tmp46_;
		const gchar* _tmp47_;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		const gchar* _tmp51_;
#line 167 "../libgitg/gitg-credentials-manager.vala"
		collection = NULL;
#line 169 "../libgitg/gitg-credentials-manager.vala"
		if (_data5_->lifetime == GITG_AUTHENTICATION_LIFE_TIME_SESSION) {
#line 1026 "gitg-credentials-manager.c"
			gchar* _tmp42_;
#line 171 "../libgitg/gitg-credentials-manager.vala"
			_tmp42_ = g_strdup (SECRET_COLLECTION_SESSION);
#line 171 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (collection);
#line 171 "../libgitg/gitg-credentials-manager.vala"
			collection = _tmp42_;
#line 1034 "gitg-credentials-manager.c"
		}
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp43_ = gitg_credentials_manager_s_secret_schema;
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp44_ = attributes;
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp45_ = _g_hash_table_ref0 (_tmp44_);
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp46_ = collection;
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp47_ = string_to_string (scheme);
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp48_ = string_to_string (host);
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp49_ = g_strconcat (_tmp47_, "://", _tmp48_, NULL);
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp50_ = _tmp49_;
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_tmp51_ = _data5_->password;
#line 174 "../libgitg/gitg-credentials-manager.vala"
		secret_password_storev (_tmp43_, _tmp45_, _tmp46_, _tmp50_, _tmp51_, NULL, ____lambda42__gasync_ready_callback, gitg_credentials_manager_ref (self));
#line 174 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_tmp50_);
#line 165 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (collection);
#line 1060 "gitg-credentials-manager.c"
	} else {
		SecretSchema* _tmp52_;
		GHashTable* _tmp53_;
		GHashTable* _tmp54_;
#line 193 "../libgitg/gitg-credentials-manager.vala"
		_tmp52_ = gitg_credentials_manager_s_secret_schema;
#line 193 "../libgitg/gitg-credentials-manager.vala"
		_tmp53_ = attributes;
#line 193 "../libgitg/gitg-credentials-manager.vala"
		_tmp54_ = _g_hash_table_ref0 (_tmp53_);
#line 193 "../libgitg/gitg-credentials-manager.vala"
		secret_password_clearv (_tmp52_, _tmp54_, NULL, ____lambda43__gasync_ready_callback, gitg_credentials_manager_ref (self));
#line 1073 "gitg-credentials-manager.c"
	}
#line 205 "../libgitg/gitg-credentials-manager.vala"
	_tmp55_ = self->priv->d_auth_tried;
#line 205 "../libgitg/gitg-credentials-manager.vala"
	_tmp56_ = _data5_->newusername;
#line 205 "../libgitg/gitg-credentials-manager.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp55_, _tmp56_, (gpointer) ((gintptr) GGIT_CREDTYPE_USERPASS_PLAINTEXT));
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp58_ = _data5_->newusername;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp59_ = _data5_->password;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp60_ = ggit_cred_plaintext_new (_tmp58_, _tmp59_, &_inner_error0_);
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp57_ = _tmp60_;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../libgitg/gitg-credentials-manager.vala"
		g_propagate_error (error, _inner_error0_);
#line 206 "../libgitg/gitg-credentials-manager.vala"
		_g_hash_table_unref0 (attributes);
#line 206 "../libgitg/gitg-credentials-manager.vala"
		block5_data_unref (_data5_);
#line 206 "../libgitg/gitg-credentials-manager.vala"
		_data5_ = NULL;
#line 206 "../libgitg/gitg-credentials-manager.vala"
		return NULL;
#line 1101 "gitg-credentials-manager.c"
	}
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp61_ = _tmp57_;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_tmp57_ = NULL;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	result = (GgitCred*) _tmp61_;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (_tmp57_);
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_g_hash_table_unref0 (attributes);
#line 206 "../libgitg/gitg-credentials-manager.vala"
	block5_data_unref (_data5_);
#line 206 "../libgitg/gitg-credentials-manager.vala"
	_data5_ = NULL;
#line 206 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 1119 "gitg-credentials-manager.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1138 "gitg-credentials-manager.c"
}

static GgitCred*
gitg_credentials_manager_query_user_pass (GitgCredentialsManager* self,
                                          const gchar* url,
                                          const gchar* username,
                                          GError** error)
{
	gchar* user = NULL;
	gchar* host = NULL;
	gchar* _tmp0_;
	gchar* scheme = NULL;
	gchar* _tmp1_;
	const gchar* _tmp31_;
	GError* _inner_error0_ = NULL;
	GgitCred* result;
#line 209 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 209 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 213 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = g_strdup ("local");
#line 213 "../libgitg/gitg-credentials-manager.vala"
	host = _tmp0_;
#line 214 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = g_strdup ("file");
#line 214 "../libgitg/gitg-credentials-manager.vala"
	scheme = _tmp1_;
#line 216 "../libgitg/gitg-credentials-manager.vala"
	if (!string_contains (url, "://")) {
#line 1169 "gitg-credentials-manager.c"
		GMatchInfo* minfo = NULL;
		GRegex* _tmp2_;
		GMatchInfo* _tmp3_ = NULL;
		gboolean _tmp4_;
#line 220 "../libgitg/gitg-credentials-manager.vala"
		_tmp2_ = gitg_credentials_manager_s_ssh_short_form;
#line 220 "../libgitg/gitg-credentials-manager.vala"
		_tmp4_ = g_regex_match (_tmp2_, url, 0, &_tmp3_);
#line 220 "../libgitg/gitg-credentials-manager.vala"
		_g_match_info_unref0 (minfo);
#line 220 "../libgitg/gitg-credentials-manager.vala"
		minfo = _tmp3_;
#line 220 "../libgitg/gitg-credentials-manager.vala"
		if (_tmp4_) {
#line 1184 "gitg-credentials-manager.c"
			gchar* _tmp5_;
			GMatchInfo* _tmp6_;
			gchar* _tmp7_;
#line 222 "../libgitg/gitg-credentials-manager.vala"
			_tmp5_ = g_strdup ("ssh");
#line 222 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (scheme);
#line 222 "../libgitg/gitg-credentials-manager.vala"
			scheme = _tmp5_;
#line 223 "../libgitg/gitg-credentials-manager.vala"
			_tmp6_ = minfo;
#line 223 "../libgitg/gitg-credentials-manager.vala"
			_tmp7_ = g_match_info_fetch_named (_tmp6_, "host");
#line 223 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (host);
#line 223 "../libgitg/gitg-credentials-manager.vala"
			host = _tmp7_;
#line 1202 "gitg-credentials-manager.c"
		}
#line 216 "../libgitg/gitg-credentials-manager.vala"
		_g_match_info_unref0 (minfo);
#line 1206 "gitg-credentials-manager.c"
	} else {
		GUri* uri = NULL;
		GUri* _tmp8_;
		GUri* _tmp9_;
#line 228 "../libgitg/gitg-credentials-manager.vala"
		_tmp8_ = g_uri_parse (url, G_URI_FLAGS_NONE, &_inner_error0_);
#line 228 "../libgitg/gitg-credentials-manager.vala"
		uri = _tmp8_;
#line 228 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 228 "../libgitg/gitg-credentials-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 228 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (scheme);
#line 228 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (host);
#line 228 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (user);
#line 228 "../libgitg/gitg-credentials-manager.vala"
			return NULL;
#line 1227 "gitg-credentials-manager.c"
		}
#line 230 "../libgitg/gitg-credentials-manager.vala"
		_tmp9_ = uri;
#line 230 "../libgitg/gitg-credentials-manager.vala"
		if (_tmp9_ != NULL) {
#line 1233 "gitg-credentials-manager.c"
			GUri* _tmp10_;
			const gchar* _tmp11_;
			gchar* _tmp12_;
			GUri* _tmp13_;
			GUri* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
#line 232 "../libgitg/gitg-credentials-manager.vala"
			_tmp10_ = uri;
#line 232 "../libgitg/gitg-credentials-manager.vala"
			_tmp11_ = g_uri_get_host (_tmp10_);
#line 232 "../libgitg/gitg-credentials-manager.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 232 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (host);
#line 232 "../libgitg/gitg-credentials-manager.vala"
			host = _tmp12_;
#line 234 "../libgitg/gitg-credentials-manager.vala"
			_tmp13_ = uri;
#line 234 "../libgitg/gitg-credentials-manager.vala"
			if (g_uri_get_port (_tmp13_) != -1) {
#line 1255 "gitg-credentials-manager.c"
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				GUri* _tmp16_;
				gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp14_ = host;
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp15_ = string_to_string (_tmp14_);
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp16_ = uri;
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp17_ = g_strdup_printf ("%i", g_uri_get_port (_tmp16_));
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp18_ = _tmp17_;
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_tmp19_ = g_strconcat (_tmp15_, ":", _tmp18_, NULL);
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 236 "../libgitg/gitg-credentials-manager.vala"
				host = _tmp19_;
#line 236 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (_tmp18_);
#line 1280 "gitg-credentials-manager.c"
			}
#line 239 "../libgitg/gitg-credentials-manager.vala"
			_tmp20_ = uri;
#line 239 "../libgitg/gitg-credentials-manager.vala"
			_tmp21_ = g_uri_get_scheme (_tmp20_);
#line 239 "../libgitg/gitg-credentials-manager.vala"
			_tmp22_ = g_strdup (_tmp21_);
#line 239 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (scheme);
#line 239 "../libgitg/gitg-credentials-manager.vala"
			scheme = _tmp22_;
#line 1292 "gitg-credentials-manager.c"
		}
#line 216 "../libgitg/gitg-credentials-manager.vala"
		_g_uri_unref0 (uri);
#line 1296 "gitg-credentials-manager.c"
	}
#line 243 "../libgitg/gitg-credentials-manager.vala"
	if (username == NULL) {
#line 1300 "gitg-credentials-manager.c"
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp23_ = scheme;
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp24_ = string_to_string (_tmp23_);
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp25_ = host;
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp26_ = string_to_string (_tmp25_);
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp27_ = g_strconcat (_tmp24_, "://", _tmp26_, NULL);
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp28_ = _tmp27_;
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_tmp29_ = gitg_credentials_manager_lookup_user (self, _tmp28_);
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (user);
#line 246 "../libgitg/gitg-credentials-manager.vala"
		user = _tmp29_;
#line 246 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (_tmp28_);
#line 1328 "gitg-credentials-manager.c"
	} else {
		gchar* _tmp30_;
#line 250 "../libgitg/gitg-credentials-manager.vala"
		_tmp30_ = g_strdup (username);
#line 250 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (user);
#line 250 "../libgitg/gitg-credentials-manager.vala"
		user = _tmp30_;
#line 1337 "gitg-credentials-manager.c"
	}
#line 253 "../libgitg/gitg-credentials-manager.vala"
	_tmp31_ = user;
#line 253 "../libgitg/gitg-credentials-manager.vala"
	if (_tmp31_ != NULL) {
#line 1343 "gitg-credentials-manager.c"
		GgitCredtype tried = 0U;
		GeeHashMap* _tmp32_;
		const gchar* _tmp33_;
		gpointer _tmp34_;
#line 255 "../libgitg/gitg-credentials-manager.vala"
		_tmp32_ = self->priv->d_auth_tried;
#line 255 "../libgitg/gitg-credentials-manager.vala"
		_tmp33_ = user;
#line 255 "../libgitg/gitg-credentials-manager.vala"
		_tmp34_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp32_, _tmp33_);
#line 255 "../libgitg/gitg-credentials-manager.vala"
		tried = (GgitCredtype) ((gintptr) _tmp34_);
#line 257 "../libgitg/gitg-credentials-manager.vala"
		if ((tried & GGIT_CREDTYPE_USERPASS_PLAINTEXT) == 0) {
#line 1358 "gitg-credentials-manager.c"
			gchar* secret = NULL;
			const gchar* _tmp42_;
			GeeHashMap* _tmp49_;
			const gchar* _tmp50_;
#line 259 "../libgitg/gitg-credentials-manager.vala"
			secret = NULL;
#line 1365 "gitg-credentials-manager.c"
			{
				gchar* _tmp35_ = NULL;
				SecretSchema* _tmp36_;
				const gchar* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp36_ = gitg_credentials_manager_s_secret_schema;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp37_ = scheme;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp38_ = host;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp39_ = user;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp40_ = secret_password_lookup_sync (_tmp36_, NULL, &_inner_error0_, "scheme", _tmp37_, "host", _tmp38_, "user", _tmp39_, NULL);
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp35_ = _tmp40_;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1388 "gitg-credentials-manager.c"
					goto __catch0_g_error;
				}
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp41_ = _tmp35_;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_tmp35_ = NULL;
#line 263 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (secret);
#line 263 "../libgitg/gitg-credentials-manager.vala"
				secret = _tmp41_;
#line 261 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (_tmp35_);
#line 1401 "gitg-credentials-manager.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 261 "../libgitg/gitg-credentials-manager.vala"
				g_clear_error (&_inner_error0_);
#line 1408 "gitg-credentials-manager.c"
			}
			__finally0:
#line 261 "../libgitg/gitg-credentials-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "../libgitg/gitg-credentials-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 261 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (secret);
#line 261 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (scheme);
#line 261 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 261 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (user);
#line 261 "../libgitg/gitg-credentials-manager.vala"
				return NULL;
#line 1425 "gitg-credentials-manager.c"
			}
#line 270 "../libgitg/gitg-credentials-manager.vala"
			_tmp42_ = secret;
#line 270 "../libgitg/gitg-credentials-manager.vala"
			if (_tmp42_ == NULL) {
#line 1431 "gitg-credentials-manager.c"
				GgitCred* _tmp43_ = NULL;
				const gchar* _tmp44_;
				const gchar* _tmp45_;
				const gchar* _tmp46_;
				GgitCred* _tmp47_;
				GgitCred* _tmp48_;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp44_ = scheme;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp45_ = host;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp46_ = user;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp47_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp44_, _tmp45_, _tmp46_, &_inner_error0_);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp43_ = _tmp47_;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 272 "../libgitg/gitg-credentials-manager.vala"
					g_propagate_error (error, _inner_error0_);
#line 272 "../libgitg/gitg-credentials-manager.vala"
					_g_free0 (secret);
#line 272 "../libgitg/gitg-credentials-manager.vala"
					_g_free0 (scheme);
#line 272 "../libgitg/gitg-credentials-manager.vala"
					_g_free0 (host);
#line 272 "../libgitg/gitg-credentials-manager.vala"
					_g_free0 (user);
#line 272 "../libgitg/gitg-credentials-manager.vala"
					return NULL;
#line 1462 "gitg-credentials-manager.c"
				}
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp48_ = _tmp43_;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_tmp43_ = NULL;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				result = _tmp48_;
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_g_object_unref0 (_tmp43_);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (secret);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (scheme);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (user);
#line 272 "../libgitg/gitg-credentials-manager.vala"
				return result;
#line 1482 "gitg-credentials-manager.c"
			}
#line 275 "../libgitg/gitg-credentials-manager.vala"
			_tmp49_ = self->priv->d_auth_tried;
#line 275 "../libgitg/gitg-credentials-manager.vala"
			_tmp50_ = user;
#line 275 "../libgitg/gitg-credentials-manager.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp49_, _tmp50_, (gpointer) ((gintptr) GGIT_CREDTYPE_USERPASS_PLAINTEXT));
#line 1490 "gitg-credentials-manager.c"
			{
				GgitCredPlaintext* _tmp51_ = NULL;
				const gchar* _tmp52_;
				const gchar* _tmp53_;
				GgitCredPlaintext* _tmp54_;
				GgitCredPlaintext* _tmp55_;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp52_ = user;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp53_ = secret;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp54_ = ggit_cred_plaintext_new (_tmp52_, _tmp53_, &_inner_error0_);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp51_ = _tmp54_;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1507 "gitg-credentials-manager.c"
					goto __catch1_g_error;
				}
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp55_ = _tmp51_;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_tmp51_ = NULL;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				result = (GgitCred*) _tmp55_;
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_g_object_unref0 (_tmp51_);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (secret);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (scheme);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (user);
#line 279 "../libgitg/gitg-credentials-manager.vala"
				return result;
#line 1528 "gitg-credentials-manager.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GgitCred* _tmp56_ = NULL;
				const gchar* _tmp57_;
				const gchar* _tmp58_;
				const gchar* _tmp59_;
				GgitCred* _tmp60_;
				GgitCred* _tmp61_;
#line 277 "../libgitg/gitg-credentials-manager.vala"
				g_clear_error (&_inner_error0_);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp57_ = scheme;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp58_ = host;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp59_ = user;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp60_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp57_, _tmp58_, _tmp59_, &_inner_error0_);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp56_ = _tmp60_;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1553 "gitg-credentials-manager.c"
					goto __finally1;
				}
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp61_ = _tmp56_;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_tmp56_ = NULL;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				result = _tmp61_;
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_g_object_unref0 (_tmp56_);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (secret);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (scheme);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (user);
#line 283 "../libgitg/gitg-credentials-manager.vala"
				return result;
#line 1574 "gitg-credentials-manager.c"
			}
			__finally1:
#line 277 "../libgitg/gitg-credentials-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 277 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (secret);
#line 277 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (scheme);
#line 277 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (host);
#line 277 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (user);
#line 277 "../libgitg/gitg-credentials-manager.vala"
			return NULL;
#line 1589 "gitg-credentials-manager.c"
		} else {
			GgitCred* _tmp62_ = NULL;
			const gchar* _tmp63_;
			const gchar* _tmp64_;
			const gchar* _tmp65_;
			GgitCred* _tmp66_;
			GgitCred* _tmp67_;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp63_ = scheme;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp64_ = host;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp65_ = user;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp66_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp63_, _tmp64_, _tmp65_, &_inner_error0_);
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp62_ = _tmp66_;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 288 "../libgitg/gitg-credentials-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 288 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (scheme);
#line 288 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (host);
#line 288 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (user);
#line 288 "../libgitg/gitg-credentials-manager.vala"
				return NULL;
#line 1619 "gitg-credentials-manager.c"
			}
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp67_ = _tmp62_;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_tmp62_ = NULL;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			result = _tmp67_;
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_g_object_unref0 (_tmp62_);
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (scheme);
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (host);
#line 288 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (user);
#line 288 "../libgitg/gitg-credentials-manager.vala"
			return result;
#line 1637 "gitg-credentials-manager.c"
		}
	} else {
		GgitCred* _tmp68_ = NULL;
		const gchar* _tmp69_;
		const gchar* _tmp70_;
		const gchar* _tmp71_;
		GgitCred* _tmp72_;
		GgitCred* _tmp73_;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp69_ = scheme;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp70_ = host;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp71_ = user;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp72_ = gitg_credentials_manager_user_pass_dialog (self, url, _tmp69_, _tmp70_, _tmp71_, &_inner_error0_);
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp68_ = _tmp72_;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 293 "../libgitg/gitg-credentials-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 293 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (scheme);
#line 293 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (host);
#line 293 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (user);
#line 293 "../libgitg/gitg-credentials-manager.vala"
			return NULL;
#line 1668 "gitg-credentials-manager.c"
		}
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp73_ = _tmp68_;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_tmp68_ = NULL;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		result = _tmp73_;
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_g_object_unref0 (_tmp68_);
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (scheme);
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (host);
#line 293 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (user);
#line 293 "../libgitg/gitg-credentials-manager.vala"
		return result;
#line 1686 "gitg-credentials-manager.c"
	}
}

GgitCred*
gitg_credentials_manager_credentials (GitgCredentialsManager* self,
                                      const gchar* url,
                                      const gchar* username,
                                      GgitCredtype allowed_types,
                                      GError** error)
{
	const gchar* _tmp0_ = NULL;
	gchar* uslookup = NULL;
	gchar* _tmp1_;
	GgitCredtype tried = 0U;
	GeeHashMap* _tmp2_;
	const gchar* _tmp3_;
	gpointer _tmp4_;
	GgitCredtype untried_allowed_types = 0U;
	GError* _inner_error0_ = NULL;
	GgitCred* result;
#line 297 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 297 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 301 "../libgitg/gitg-credentials-manager.vala"
	if (username != NULL) {
#line 301 "../libgitg/gitg-credentials-manager.vala"
		_tmp0_ = username;
#line 1715 "gitg-credentials-manager.c"
	} else {
#line 301 "../libgitg/gitg-credentials-manager.vala"
		_tmp0_ = "";
#line 1719 "gitg-credentials-manager.c"
	}
#line 301 "../libgitg/gitg-credentials-manager.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 301 "../libgitg/gitg-credentials-manager.vala"
	uslookup = _tmp1_;
#line 302 "../libgitg/gitg-credentials-manager.vala"
	_tmp2_ = self->priv->d_auth_tried;
#line 302 "../libgitg/gitg-credentials-manager.vala"
	_tmp3_ = uslookup;
#line 302 "../libgitg/gitg-credentials-manager.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, _tmp3_);
#line 302 "../libgitg/gitg-credentials-manager.vala"
	tried = (GgitCredtype) ((gintptr) _tmp4_);
#line 304 "../libgitg/gitg-credentials-manager.vala"
	untried_allowed_types = allowed_types & (~tried);
#line 306 "../libgitg/gitg-credentials-manager.vala"
	if ((untried_allowed_types & GGIT_CREDTYPE_SSH_KEY) != 0) {
#line 1737 "gitg-credentials-manager.c"
		GeeHashMap* _tmp5_;
		const gchar* _tmp6_;
		GgitCredSshKeyFromAgent* _tmp7_ = NULL;
		GgitCredSshKeyFromAgent* _tmp8_;
		GgitCredSshKeyFromAgent* _tmp9_;
#line 308 "../libgitg/gitg-credentials-manager.vala"
		_tmp5_ = self->priv->d_auth_tried;
#line 308 "../libgitg/gitg-credentials-manager.vala"
		_tmp6_ = uslookup;
#line 308 "../libgitg/gitg-credentials-manager.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, _tmp6_, (gpointer) ((gintptr) (tried | GGIT_CREDTYPE_SSH_KEY)));
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_tmp8_ = ggit_cred_ssh_key_from_agent_new (username, &_inner_error0_);
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_tmp7_ = _tmp8_;
#line 309 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 309 "../libgitg/gitg-credentials-manager.vala"
			g_propagate_error (error, _inner_error0_);
#line 309 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (uslookup);
#line 309 "../libgitg/gitg-credentials-manager.vala"
			return NULL;
#line 1761 "gitg-credentials-manager.c"
		}
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_tmp9_ = _tmp7_;
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_tmp7_ = NULL;
#line 309 "../libgitg/gitg-credentials-manager.vala"
		result = (GgitCred*) _tmp9_;
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_g_object_unref0 (_tmp7_);
#line 309 "../libgitg/gitg-credentials-manager.vala"
		_g_free0 (uslookup);
#line 309 "../libgitg/gitg-credentials-manager.vala"
		return result;
#line 1775 "gitg-credentials-manager.c"
	} else {
#line 311 "../libgitg/gitg-credentials-manager.vala"
		if ((allowed_types & GGIT_CREDTYPE_USERPASS_PLAINTEXT) != 0) {
#line 1779 "gitg-credentials-manager.c"
			GgitCred* _tmp10_ = NULL;
			GgitCred* _tmp11_;
			GgitCred* _tmp12_;
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_tmp11_ = gitg_credentials_manager_query_user_pass (self, url, username, &_inner_error0_);
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_tmp10_ = _tmp11_;
#line 313 "../libgitg/gitg-credentials-manager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 313 "../libgitg/gitg-credentials-manager.vala"
				g_propagate_error (error, _inner_error0_);
#line 313 "../libgitg/gitg-credentials-manager.vala"
				_g_free0 (uslookup);
#line 313 "../libgitg/gitg-credentials-manager.vala"
				return NULL;
#line 1795 "gitg-credentials-manager.c"
			}
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_tmp12_ = _tmp10_;
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_tmp10_ = NULL;
#line 313 "../libgitg/gitg-credentials-manager.vala"
			result = _tmp12_;
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_g_object_unref0 (_tmp10_);
#line 313 "../libgitg/gitg-credentials-manager.vala"
			_g_free0 (uslookup);
#line 313 "../libgitg/gitg-credentials-manager.vala"
			return result;
#line 1809 "gitg-credentials-manager.c"
		}
	}
#line 316 "../libgitg/gitg-credentials-manager.vala"
	result = NULL;
#line 316 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (uslookup);
#line 316 "../libgitg/gitg-credentials-manager.vala"
	return result;
#line 1818 "gitg-credentials-manager.c"
}

static void
gitg_value_credentials_manager_init (GValue* value)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	value->data[0].v_pointer = NULL;
#line 1826 "gitg-credentials-manager.c"
}

static void
gitg_value_credentials_manager_free_value (GValue* value)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (value->data[0].v_pointer) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		gitg_credentials_manager_unref (value->data[0].v_pointer);
#line 1836 "gitg-credentials-manager.c"
	}
}

static void
gitg_value_credentials_manager_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (src_value->data[0].v_pointer) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		dest_value->data[0].v_pointer = gitg_credentials_manager_ref (src_value->data[0].v_pointer);
#line 1848 "gitg-credentials-manager.c"
	} else {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1852 "gitg-credentials-manager.c"
	}
}

static gpointer
gitg_value_credentials_manager_peek_pointer (const GValue* value)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return value->data[0].v_pointer;
#line 1861 "gitg-credentials-manager.c"
}

static gchar*
gitg_value_credentials_manager_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (collect_values[0].v_pointer) {
#line 1872 "gitg-credentials-manager.c"
		GitgCredentialsManager * object;
		object = collect_values[0].v_pointer;
#line 28 "../libgitg/gitg-credentials-manager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1879 "gitg-credentials-manager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1883 "gitg-credentials-manager.c"
		}
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = gitg_credentials_manager_ref (object);
#line 1887 "gitg-credentials-manager.c"
	} else {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = NULL;
#line 1891 "gitg-credentials-manager.c"
	}
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return NULL;
#line 1895 "gitg-credentials-manager.c"
}

static gchar*
gitg_value_credentials_manager_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	GitgCredentialsManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (!object_p) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1910 "gitg-credentials-manager.c"
	}
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (!value->data[0].v_pointer) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		*object_p = NULL;
#line 1916 "gitg-credentials-manager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		*object_p = value->data[0].v_pointer;
#line 1920 "gitg-credentials-manager.c"
	} else {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		*object_p = gitg_credentials_manager_ref (value->data[0].v_pointer);
#line 1924 "gitg-credentials-manager.c"
	}
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return NULL;
#line 1928 "gitg-credentials-manager.c"
}

GParamSpec*
gitg_param_spec_credentials_manager (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	GitgParamSpecCredentialsManager* spec;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GITG_TYPE_CREDENTIALS_MANAGER), NULL);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return G_PARAM_SPEC (spec);
#line 1947 "gitg-credentials-manager.c"
}

gpointer
gitg_value_get_credentials_manager (const GValue* value)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_CREDENTIALS_MANAGER), NULL);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return value->data[0].v_pointer;
#line 1957 "gitg-credentials-manager.c"
}

void
gitg_value_set_credentials_manager (GValue* value,
                                    gpointer v_object)
{
	GitgCredentialsManager * old;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_CREDENTIALS_MANAGER));
#line 28 "../libgitg/gitg-credentials-manager.vala"
	old = value->data[0].v_pointer;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (v_object) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_CREDENTIALS_MANAGER));
#line 28 "../libgitg/gitg-credentials-manager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = v_object;
#line 28 "../libgitg/gitg-credentials-manager.vala"
		gitg_credentials_manager_ref (value->data[0].v_pointer);
#line 1979 "gitg-credentials-manager.c"
	} else {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = NULL;
#line 1983 "gitg-credentials-manager.c"
	}
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (old) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		gitg_credentials_manager_unref (old);
#line 1989 "gitg-credentials-manager.c"
	}
}

void
gitg_value_take_credentials_manager (GValue* value,
                                     gpointer v_object)
{
	GitgCredentialsManager * old;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_CREDENTIALS_MANAGER));
#line 28 "../libgitg/gitg-credentials-manager.vala"
	old = value->data[0].v_pointer;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (v_object) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_CREDENTIALS_MANAGER));
#line 28 "../libgitg/gitg-credentials-manager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = v_object;
#line 2010 "gitg-credentials-manager.c"
	} else {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		value->data[0].v_pointer = NULL;
#line 2014 "gitg-credentials-manager.c"
	}
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (old) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		gitg_credentials_manager_unref (old);
#line 2020 "gitg-credentials-manager.c"
	}
}

static void
gitg_credentials_manager_class_init (GitgCredentialsManagerClass * klass,
                                     gpointer klass_data)
{
	SecretSchema* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	gitg_credentials_manager_parent_class = g_type_class_peek_parent (klass);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	((GitgCredentialsManagerClass *) klass)->finalize = gitg_credentials_manager_finalize;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_type_class_adjust_private_offset (klass, &GitgCredentialsManager_private_offset);
#line 42 "../libgitg/gitg-credentials-manager.vala"
	_tmp0_ = secret_schema_new (APPLICATION_ID ".Credentials", SECRET_SCHEMA_NONE, "scheme", SECRET_SCHEMA_ATTRIBUTE_STRING, "host", SECRET_SCHEMA_ATTRIBUTE_STRING, "user", SECRET_SCHEMA_ATTRIBUTE_STRING, NULL);
#line 42 "../libgitg/gitg-credentials-manager.vala"
	_secret_schema_unref0 (gitg_credentials_manager_s_secret_schema);
#line 42 "../libgitg/gitg-credentials-manager.vala"
	gitg_credentials_manager_s_secret_schema = _tmp0_;
#line 2042 "gitg-credentials-manager.c"
	{
		GRegex* _tmp1_ = NULL;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
#line 50 "../libgitg/gitg-credentials-manager.vala"
		_tmp2_ = g_regex_new ("^(?:[^: /@]+)@(?P<host>[^:]+)", 0, 0, &_inner_error0_);
#line 50 "../libgitg/gitg-credentials-manager.vala"
		_tmp1_ = _tmp2_;
#line 50 "../libgitg/gitg-credentials-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2053 "gitg-credentials-manager.c"
			goto __catch0_g_error;
		}
#line 50 "../libgitg/gitg-credentials-manager.vala"
		_tmp3_ = _tmp1_;
#line 50 "../libgitg/gitg-credentials-manager.vala"
		_tmp1_ = NULL;
#line 50 "../libgitg/gitg-credentials-manager.vala"
		_g_regex_unref0 (gitg_credentials_manager_s_ssh_short_form);
#line 50 "../libgitg/gitg-credentials-manager.vala"
		gitg_credentials_manager_s_ssh_short_form = _tmp3_;
#line 48 "../libgitg/gitg-credentials-manager.vala"
		_g_regex_unref0 (_tmp1_);
#line 2066 "gitg-credentials-manager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 48 "../libgitg/gitg-credentials-manager.vala"
		e = _inner_error0_;
#line 48 "../libgitg/gitg-credentials-manager.vala"
		_inner_error0_ = NULL;
#line 51 "../libgitg/gitg-credentials-manager.vala"
		_tmp4_ = stderr;
#line 51 "../libgitg/gitg-credentials-manager.vala"
		_tmp5_ = e;
#line 51 "../libgitg/gitg-credentials-manager.vala"
		_tmp6_ = _tmp5_->message;
#line 51 "../libgitg/gitg-credentials-manager.vala"
		fprintf (_tmp4_, "regex err: %s\n", _tmp6_);
#line 48 "../libgitg/gitg-credentials-manager.vala"
		_g_error_free0 (e);
#line 2089 "gitg-credentials-manager.c"
	}
	__finally0:
#line 48 "../libgitg/gitg-credentials-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "../libgitg/gitg-credentials-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "../libgitg/gitg-credentials-manager.vala"
		g_clear_error (&_inner_error0_);
#line 2098 "gitg-credentials-manager.c"
	}
}

static void
gitg_credentials_manager_instance_init (GitgCredentialsManager * self,
                                        gpointer klass)
{
#line 28 "../libgitg/gitg-credentials-manager.vala"
	self->priv = gitg_credentials_manager_get_instance_private (self);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	self->ref_count = 1;
#line 2110 "gitg-credentials-manager.c"
}

static void
gitg_credentials_manager_finalize (GitgCredentialsManager * obj)
{
	GitgCredentialsManager * self;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_CREDENTIALS_MANAGER, GitgCredentialsManager);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_signal_handlers_destroy (self);
#line 30 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_config);
#line 31 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_window);
#line 32 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_usermap);
#line 34 "../libgitg/gitg-credentials-manager.vala"
	_g_free0 (self->priv->d_last_user);
#line 35 "../libgitg/gitg-credentials-manager.vala"
	_g_object_unref0 (self->priv->d_auth_tried);
#line 2131 "gitg-credentials-manager.c"
}

 G_GNUC_NO_INLINE static GType
gitg_credentials_manager_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { gitg_value_credentials_manager_init, gitg_value_credentials_manager_free_value, gitg_value_credentials_manager_copy_value, gitg_value_credentials_manager_peek_pointer, "p", gitg_value_credentials_manager_collect_value, "p", gitg_value_credentials_manager_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GitgCredentialsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_credentials_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgCredentialsManager), 0, (GInstanceInitFunc) gitg_credentials_manager_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType gitg_credentials_manager_type_id;
	gitg_credentials_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GitgCredentialsManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
	GitgCredentialsManager_private_offset = g_type_add_instance_private (gitg_credentials_manager_type_id, sizeof (GitgCredentialsManagerPrivate));
	return gitg_credentials_manager_type_id;
}

GType
gitg_credentials_manager_get_type (void)
{
	static gsize gitg_credentials_manager_type_id__once = 0;
	if (g_once_init_enter (&gitg_credentials_manager_type_id__once)) {
		GType gitg_credentials_manager_type_id;
		gitg_credentials_manager_type_id = gitg_credentials_manager_get_type_once ();
		g_once_init_leave (&gitg_credentials_manager_type_id__once, gitg_credentials_manager_type_id);
	}
	return gitg_credentials_manager_type_id__once;
}

gpointer
gitg_credentials_manager_ref (gpointer instance)
{
	GitgCredentialsManager * self;
	self = instance;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 28 "../libgitg/gitg-credentials-manager.vala"
	return instance;
#line 2167 "gitg-credentials-manager.c"
}

void
gitg_credentials_manager_unref (gpointer instance)
{
	GitgCredentialsManager * self;
	self = instance;
#line 28 "../libgitg/gitg-credentials-manager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 28 "../libgitg/gitg-credentials-manager.vala"
		GITG_CREDENTIALS_MANAGER_GET_CLASS (self)->finalize (self);
#line 28 "../libgitg/gitg-credentials-manager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2181 "gitg-credentials-manager.c"
	}
}

static void
_vala_clear_GMutex (GMutex * mutex)
{
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}

static void
_vala_clear_GRecMutex (GRecMutex * mutex)
{
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}

static void
_vala_clear_GRWLock (GRWLock * mutex)
{
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}

static void
_vala_clear_GCond (GCond * mutex)
{
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}

