/* gitg-label-renderer.c generated by valac 0.56.18, the Vala compiler
 * generated from gitg-label-renderer.vala, do not modify */

/*
 * This file is part of gitg
 *
 * Copyright (C) 2012 - Jesse van den Kieboom
 *
 * gitg is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * gitg is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gitg. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libgitg.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#define GITG_LABEL_RENDERER_margin 2
#define GITG_LABEL_RENDERER_padding 6
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef struct _GitgParamSpecLabelRenderer GitgParamSpecLabelRenderer;

struct _GitgParamSpecLabelRenderer {
	GParamSpec parent_instance;
};

static gpointer gitg_label_renderer_parent_class = NULL;

static gchar* gitg_label_renderer_label_text (GitgRef* r);
static gint gitg_label_renderer_get_label_width (PangoLayout* layout,
                                          GitgRef* r);
static gchar* gitg_label_renderer_class_from_ref (GitgRefType type);
static gint gitg_label_renderer_render_label (GtkWidget* widget,
                                       cairo_t* cr,
                                       PangoLayout* layout,
                                       GitgRef* r,
                                       gdouble x,
                                       gdouble y,
                                       gint height,
                                       gboolean use_state);
static guchar gitg_label_renderer_convert_color_channel (guchar color,
                                                  guchar alpha);
static void gitg_label_renderer_convert_bgra_to_rgba (guchar* src,
                                               gint src_length1,
                                               guchar* dst,
                                               gint dst_length1,
                                               gint width,
                                               gint height);
static guchar* _vala_array_dup17 (guchar* self,
                           gssize length);
static guint8* _vala_array_dup18 (guint8* self,
                           gssize length);
static void gitg_label_renderer_finalize (GitgLabelRenderer * obj);
static GType gitg_label_renderer_get_type_once (void);

static gchar*
gitg_label_renderer_label_text (GitgRef* r)
{
	gchar* escaped = NULL;
	GitgParsedRefName* _tmp0_;
	GitgParsedRefName* _tmp1_;
	GitgParsedRefName* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 27 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 29 "../libgitg/gitg-label-renderer.vala"
	_tmp0_ = gitg_ref_get_parsed_name (r);
#line 29 "../libgitg/gitg-label-renderer.vala"
	_tmp1_ = _tmp0_;
#line 29 "../libgitg/gitg-label-renderer.vala"
	_tmp2_ = _tmp1_;
#line 29 "../libgitg/gitg-label-renderer.vala"
	_tmp3_ = gitg_parsed_ref_name_get_shortname (_tmp2_);
#line 29 "../libgitg/gitg-label-renderer.vala"
	_tmp4_ = _tmp3_;
#line 29 "../libgitg/gitg-label-renderer.vala"
	_tmp5_ = _tmp4_;
#line 29 "../libgitg/gitg-label-renderer.vala"
	_tmp6_ = g_markup_escape_text (_tmp5_, (gssize) -1);
#line 29 "../libgitg/gitg-label-renderer.vala"
	_tmp7_ = _tmp6_;
#line 29 "../libgitg/gitg-label-renderer.vala"
	_g_free0 (_tmp5_);
#line 29 "../libgitg/gitg-label-renderer.vala"
	_g_object_unref0 (_tmp2_);
#line 29 "../libgitg/gitg-label-renderer.vala"
	escaped = _tmp7_;
#line 30 "../libgitg/gitg-label-renderer.vala"
	_tmp8_ = g_strdup_printf ("<span size='smaller'>%s</span>", escaped);
#line 30 "../libgitg/gitg-label-renderer.vala"
	result = _tmp8_;
#line 30 "../libgitg/gitg-label-renderer.vala"
	_g_free0 (escaped);
#line 30 "../libgitg/gitg-label-renderer.vala"
	return result;
#line 134 "gitg-label-renderer.c"
}

static gint
gitg_label_renderer_get_label_width (PangoLayout* layout,
                                     GitgRef* r)
{
	gchar* smaller = NULL;
	gchar* _tmp0_;
	gint w = 0;
	gint _tmp1_ = 0;
	gint result;
#line 33 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (layout != NULL, 0);
#line 33 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (r != NULL, 0);
#line 36 "../libgitg/gitg-label-renderer.vala"
	_tmp0_ = gitg_label_renderer_label_text (r);
#line 36 "../libgitg/gitg-label-renderer.vala"
	smaller = _tmp0_;
#line 40 "../libgitg/gitg-label-renderer.vala"
	pango_layout_set_markup (layout, smaller, -1);
#line 41 "../libgitg/gitg-label-renderer.vala"
	pango_layout_get_pixel_size (layout, &_tmp1_, NULL);
#line 41 "../libgitg/gitg-label-renderer.vala"
	w = _tmp1_;
#line 43 "../libgitg/gitg-label-renderer.vala"
	result = w + (GITG_LABEL_RENDERER_padding * 2);
#line 43 "../libgitg/gitg-label-renderer.vala"
	_g_free0 (smaller);
#line 43 "../libgitg/gitg-label-renderer.vala"
	return result;
#line 166 "gitg-label-renderer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 57 "../libgitg/gitg-label-renderer.vala"
	return self ? g_object_ref (self) : NULL;
#line 174 "gitg-label-renderer.c"
}

gint
gitg_label_renderer_width (GtkWidget* widget,
                           PangoFontDescription* font,
                           GSList* labels)
{
	gint ret = 0;
	PangoContext* ctx = NULL;
	PangoContext* _tmp0_;
	PangoContext* _tmp1_;
	PangoLayout* layout = NULL;
	PangoContext* _tmp2_;
	PangoLayout* _tmp3_;
	PangoLayout* _tmp4_;
	gint result;
#line 46 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (widget != NULL, 0);
#line 50 "../libgitg/gitg-label-renderer.vala"
	if (labels == NULL) {
#line 52 "../libgitg/gitg-label-renderer.vala"
		result = 0;
#line 52 "../libgitg/gitg-label-renderer.vala"
		return result;
#line 199 "gitg-label-renderer.c"
	}
#line 55 "../libgitg/gitg-label-renderer.vala"
	ret = 0;
#line 57 "../libgitg/gitg-label-renderer.vala"
	_tmp0_ = gtk_widget_get_pango_context (widget);
#line 57 "../libgitg/gitg-label-renderer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 57 "../libgitg/gitg-label-renderer.vala"
	ctx = _tmp1_;
#line 58 "../libgitg/gitg-label-renderer.vala"
	_tmp2_ = ctx;
#line 58 "../libgitg/gitg-label-renderer.vala"
	_tmp3_ = pango_layout_new (_tmp2_);
#line 58 "../libgitg/gitg-label-renderer.vala"
	layout = _tmp3_;
#line 60 "../libgitg/gitg-label-renderer.vala"
	_tmp4_ = layout;
#line 60 "../libgitg/gitg-label-renderer.vala"
	pango_layout_set_font_description (_tmp4_, font);
#line 219 "gitg-label-renderer.c"
	{
		GSList* r_collection = NULL;
		GSList* r_it = NULL;
#line 62 "../libgitg/gitg-label-renderer.vala"
		r_collection = labels;
#line 62 "../libgitg/gitg-label-renderer.vala"
		for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
#line 227 "gitg-label-renderer.c"
			GitgRef* _tmp5_;
			GitgRef* r = NULL;
#line 62 "../libgitg/gitg-label-renderer.vala"
			_tmp5_ = _g_object_ref0 ((GitgRef*) r_it->data);
#line 62 "../libgitg/gitg-label-renderer.vala"
			r = _tmp5_;
#line 234 "gitg-label-renderer.c"
			{
				PangoLayout* _tmp6_;
				GitgRef* _tmp7_;
#line 64 "../libgitg/gitg-label-renderer.vala"
				_tmp6_ = layout;
#line 64 "../libgitg/gitg-label-renderer.vala"
				_tmp7_ = r;
#line 64 "../libgitg/gitg-label-renderer.vala"
				ret += gitg_label_renderer_get_label_width (_tmp6_, _tmp7_) + GITG_LABEL_RENDERER_margin;
#line 62 "../libgitg/gitg-label-renderer.vala"
				_g_object_unref0 (r);
#line 246 "gitg-label-renderer.c"
			}
		}
	}
#line 67 "../libgitg/gitg-label-renderer.vala"
	result = ret + GITG_LABEL_RENDERER_margin;
#line 67 "../libgitg/gitg-label-renderer.vala"
	_g_object_unref0 (layout);
#line 67 "../libgitg/gitg-label-renderer.vala"
	_g_object_unref0 (ctx);
#line 67 "../libgitg/gitg-label-renderer.vala"
	return result;
#line 258 "gitg-label-renderer.c"
}

static gchar*
gitg_label_renderer_class_from_ref (GitgRefType type)
{
	gchar* style_class = NULL;
	gchar* result;
#line 74 "../libgitg/gitg-label-renderer.vala"
	switch (type) {
#line 74 "../libgitg/gitg-label-renderer.vala"
		case GITG_REF_TYPE_BRANCH:
#line 270 "gitg-label-renderer.c"
		{
			gchar* _tmp0_;
#line 77 "../libgitg/gitg-label-renderer.vala"
			_tmp0_ = g_strdup ("branch");
#line 77 "../libgitg/gitg-label-renderer.vala"
			_g_free0 (style_class);
#line 77 "../libgitg/gitg-label-renderer.vala"
			style_class = _tmp0_;
#line 78 "../libgitg/gitg-label-renderer.vala"
			break;
#line 281 "gitg-label-renderer.c"
		}
#line 74 "../libgitg/gitg-label-renderer.vala"
		case GITG_REF_TYPE_REMOTE:
#line 285 "gitg-label-renderer.c"
		{
			gchar* _tmp1_;
#line 80 "../libgitg/gitg-label-renderer.vala"
			_tmp1_ = g_strdup ("remote");
#line 80 "../libgitg/gitg-label-renderer.vala"
			_g_free0 (style_class);
#line 80 "../libgitg/gitg-label-renderer.vala"
			style_class = _tmp1_;
#line 81 "../libgitg/gitg-label-renderer.vala"
			break;
#line 296 "gitg-label-renderer.c"
		}
#line 74 "../libgitg/gitg-label-renderer.vala"
		case GITG_REF_TYPE_TAG:
#line 300 "gitg-label-renderer.c"
		{
			gchar* _tmp2_;
#line 83 "../libgitg/gitg-label-renderer.vala"
			_tmp2_ = g_strdup ("tag");
#line 83 "../libgitg/gitg-label-renderer.vala"
			_g_free0 (style_class);
#line 83 "../libgitg/gitg-label-renderer.vala"
			style_class = _tmp2_;
#line 84 "../libgitg/gitg-label-renderer.vala"
			break;
#line 311 "gitg-label-renderer.c"
		}
#line 74 "../libgitg/gitg-label-renderer.vala"
		case GITG_REF_TYPE_STASH:
#line 315 "gitg-label-renderer.c"
		{
			gchar* _tmp3_;
#line 86 "../libgitg/gitg-label-renderer.vala"
			_tmp3_ = g_strdup ("stash");
#line 86 "../libgitg/gitg-label-renderer.vala"
			_g_free0 (style_class);
#line 86 "../libgitg/gitg-label-renderer.vala"
			style_class = _tmp3_;
#line 87 "../libgitg/gitg-label-renderer.vala"
			break;
#line 326 "gitg-label-renderer.c"
		}
		default:
		{
#line 89 "../libgitg/gitg-label-renderer.vala"
			_g_free0 (style_class);
#line 89 "../libgitg/gitg-label-renderer.vala"
			style_class = NULL;
#line 90 "../libgitg/gitg-label-renderer.vala"
			break;
#line 336 "gitg-label-renderer.c"
		}
	}
#line 93 "../libgitg/gitg-label-renderer.vala"
	result = style_class;
#line 93 "../libgitg/gitg-label-renderer.vala"
	return result;
#line 343 "gitg-label-renderer.c"
}

static gint
gitg_label_renderer_render_label (GtkWidget* widget,
                                  cairo_t* cr,
                                  PangoLayout* layout,
                                  GitgRef* r,
                                  gdouble x,
                                  gdouble y,
                                  gint height,
                                  gboolean use_state)
{
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	gchar* smaller = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint w = 0;
	gint h = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GtkStyleContext* _tmp6_;
	gchar* style_class = NULL;
	GitgParsedRefName* _tmp7_;
	GitgParsedRefName* _tmp8_;
	GitgParsedRefName* _tmp9_;
	GitgRefType _tmp10_;
	GitgRefType _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gboolean rtl = FALSE;
	GtkStyleContext* _tmp17_;
	GtkStyleContext* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkStyleContext* _tmp20_;
	GtkStyleContext* _tmp21_;
	gint result;
#line 96 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (widget != NULL, 0);
#line 96 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (cr != NULL, 0);
#line 96 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (layout != NULL, 0);
#line 96 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (r != NULL, 0);
#line 105 "../libgitg/gitg-label-renderer.vala"
	_tmp0_ = gtk_widget_get_style_context (widget);
#line 105 "../libgitg/gitg-label-renderer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 105 "../libgitg/gitg-label-renderer.vala"
	context = _tmp1_;
#line 106 "../libgitg/gitg-label-renderer.vala"
	_tmp2_ = gitg_label_renderer_label_text (r);
#line 106 "../libgitg/gitg-label-renderer.vala"
	smaller = _tmp2_;
#line 108 "../libgitg/gitg-label-renderer.vala"
	_tmp3_ = smaller;
#line 108 "../libgitg/gitg-label-renderer.vala"
	pango_layout_set_markup (layout, _tmp3_, -1);
#line 113 "../libgitg/gitg-label-renderer.vala"
	pango_layout_get_pixel_size (layout, &_tmp4_, &_tmp5_);
#line 113 "../libgitg/gitg-label-renderer.vala"
	w = _tmp4_;
#line 113 "../libgitg/gitg-label-renderer.vala"
	h = _tmp5_;
#line 115 "../libgitg/gitg-label-renderer.vala"
	_tmp6_ = context;
#line 115 "../libgitg/gitg-label-renderer.vala"
	gtk_style_context_save (_tmp6_);
#line 117 "../libgitg/gitg-label-renderer.vala"
	_tmp7_ = gitg_ref_get_parsed_name (r);
#line 117 "../libgitg/gitg-label-renderer.vala"
	_tmp8_ = _tmp7_;
#line 117 "../libgitg/gitg-label-renderer.vala"
	_tmp9_ = _tmp8_;
#line 117 "../libgitg/gitg-label-renderer.vala"
	_tmp10_ = gitg_parsed_ref_name_get_rtype (_tmp9_);
#line 117 "../libgitg/gitg-label-renderer.vala"
	_tmp11_ = _tmp10_;
#line 117 "../libgitg/gitg-label-renderer.vala"
	_tmp12_ = gitg_label_renderer_class_from_ref (_tmp11_);
#line 117 "../libgitg/gitg-label-renderer.vala"
	_tmp13_ = _tmp12_;
#line 117 "../libgitg/gitg-label-renderer.vala"
	_g_object_unref0 (_tmp9_);
#line 117 "../libgitg/gitg-label-renderer.vala"
	style_class = _tmp13_;
#line 119 "../libgitg/gitg-label-renderer.vala"
	_tmp14_ = style_class;
#line 119 "../libgitg/gitg-label-renderer.vala"
	if (_tmp14_ != NULL) {
#line 437 "gitg-label-renderer.c"
		GtkStyleContext* _tmp15_;
		const gchar* _tmp16_;
#line 121 "../libgitg/gitg-label-renderer.vala"
		_tmp15_ = context;
#line 121 "../libgitg/gitg-label-renderer.vala"
		_tmp16_ = style_class;
#line 121 "../libgitg/gitg-label-renderer.vala"
		gtk_style_context_add_class (_tmp15_, _tmp16_);
#line 446 "gitg-label-renderer.c"
	}
#line 124 "../libgitg/gitg-label-renderer.vala"
	_tmp17_ = gtk_widget_get_style_context (widget);
#line 124 "../libgitg/gitg-label-renderer.vala"
	rtl = (gtk_style_context_get_state (_tmp17_) & GTK_STATE_FLAG_DIR_RTL) != 0;
#line 126 "../libgitg/gitg-label-renderer.vala"
	if (rtl) {
#line 128 "../libgitg/gitg-label-renderer.vala"
		x = x - (w + (GITG_LABEL_RENDERER_padding * 2));
#line 456 "gitg-label-renderer.c"
	}
#line 131 "../libgitg/gitg-label-renderer.vala"
	_tmp18_ = context;
#line 131 "../libgitg/gitg-label-renderer.vala"
	gtk_render_background (_tmp18_, cr, x, y + GITG_LABEL_RENDERER_margin, (gdouble) (w + (GITG_LABEL_RENDERER_padding * 2)), (gdouble) (height - (GITG_LABEL_RENDERER_margin * 2)));
#line 137 "../libgitg/gitg-label-renderer.vala"
	_tmp19_ = context;
#line 137 "../libgitg/gitg-label-renderer.vala"
	gtk_render_frame (_tmp19_, cr, x, y + GITG_LABEL_RENDERER_margin, (gdouble) (w + (GITG_LABEL_RENDERER_padding * 2)), (gdouble) (height - (GITG_LABEL_RENDERER_margin * 2)));
#line 143 "../libgitg/gitg-label-renderer.vala"
	_tmp20_ = context;
#line 143 "../libgitg/gitg-label-renderer.vala"
	gtk_render_layout (_tmp20_, cr, x + GITG_LABEL_RENDERER_padding, (y + ((height - h) / 2.0)) - 1, layout);
#line 148 "../libgitg/gitg-label-renderer.vala"
	_tmp21_ = context;
#line 148 "../libgitg/gitg-label-renderer.vala"
	gtk_style_context_restore (_tmp21_);
#line 149 "../libgitg/gitg-label-renderer.vala"
	result = w;
#line 149 "../libgitg/gitg-label-renderer.vala"
	_g_free0 (style_class);
#line 149 "../libgitg/gitg-label-renderer.vala"
	_g_free0 (smaller);
#line 149 "../libgitg/gitg-label-renderer.vala"
	_g_object_unref0 (context);
#line 149 "../libgitg/gitg-label-renderer.vala"
	return result;
#line 484 "gitg-label-renderer.c"
}

void
gitg_label_renderer_draw (GtkWidget* widget,
                          PangoFontDescription* font,
                          cairo_t* context,
                          GSList* labels,
                          GdkRectangle* area)
{
	gdouble pos = 0.0;
	gboolean rtl = FALSE;
	GtkStyleContext* _tmp0_;
	PangoContext* ctx = NULL;
	PangoContext* _tmp4_;
	PangoContext* _tmp5_;
	PangoLayout* layout = NULL;
	PangoContext* _tmp6_;
	PangoLayout* _tmp7_;
	PangoLayout* _tmp8_;
#line 152 "../libgitg/gitg-label-renderer.vala"
	g_return_if_fail (widget != NULL);
#line 152 "../libgitg/gitg-label-renderer.vala"
	g_return_if_fail (font != NULL);
#line 152 "../libgitg/gitg-label-renderer.vala"
	g_return_if_fail (context != NULL);
#line 152 "../libgitg/gitg-label-renderer.vala"
	g_return_if_fail (area != NULL);
#line 160 "../libgitg/gitg-label-renderer.vala"
	_tmp0_ = gtk_widget_get_style_context (widget);
#line 160 "../libgitg/gitg-label-renderer.vala"
	rtl = (gtk_style_context_get_state (_tmp0_) & GTK_STATE_FLAG_DIR_RTL) != 0;
#line 162 "../libgitg/gitg-label-renderer.vala"
	if (!rtl) {
#line 518 "gitg-label-renderer.c"
		GdkRectangle _tmp1_;
#line 164 "../libgitg/gitg-label-renderer.vala"
		_tmp1_ = *area;
#line 164 "../libgitg/gitg-label-renderer.vala"
		pos = (_tmp1_.x + GITG_LABEL_RENDERER_margin) + 0.5;
#line 524 "gitg-label-renderer.c"
	} else {
		GdkRectangle _tmp2_;
		GdkRectangle _tmp3_;
#line 168 "../libgitg/gitg-label-renderer.vala"
		_tmp2_ = *area;
#line 168 "../libgitg/gitg-label-renderer.vala"
		_tmp3_ = *area;
#line 168 "../libgitg/gitg-label-renderer.vala"
		pos = ((_tmp2_.x + _tmp3_.width) - GITG_LABEL_RENDERER_margin) - 0.5;
#line 534 "gitg-label-renderer.c"
	}
#line 171 "../libgitg/gitg-label-renderer.vala"
	cairo_save (context);
#line 172 "../libgitg/gitg-label-renderer.vala"
	cairo_set_line_width (context, 1.0);
#line 174 "../libgitg/gitg-label-renderer.vala"
	_tmp4_ = gtk_widget_get_pango_context (widget);
#line 174 "../libgitg/gitg-label-renderer.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 174 "../libgitg/gitg-label-renderer.vala"
	ctx = _tmp5_;
#line 175 "../libgitg/gitg-label-renderer.vala"
	_tmp6_ = ctx;
#line 175 "../libgitg/gitg-label-renderer.vala"
	_tmp7_ = pango_layout_new (_tmp6_);
#line 175 "../libgitg/gitg-label-renderer.vala"
	layout = _tmp7_;
#line 177 "../libgitg/gitg-label-renderer.vala"
	_tmp8_ = layout;
#line 177 "../libgitg/gitg-label-renderer.vala"
	pango_layout_set_font_description (_tmp8_, font);
#line 556 "gitg-label-renderer.c"
	{
		GSList* r_collection = NULL;
		GSList* r_it = NULL;
#line 179 "../libgitg/gitg-label-renderer.vala"
		r_collection = labels;
#line 179 "../libgitg/gitg-label-renderer.vala"
		for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
#line 564 "gitg-label-renderer.c"
			GitgRef* _tmp9_;
			GitgRef* r = NULL;
#line 179 "../libgitg/gitg-label-renderer.vala"
			_tmp9_ = _g_object_ref0 ((GitgRef*) r_it->data);
#line 179 "../libgitg/gitg-label-renderer.vala"
			r = _tmp9_;
#line 571 "gitg-label-renderer.c"
			{
				gint w = 0;
				PangoLayout* _tmp10_;
				GitgRef* _tmp11_;
				GdkRectangle _tmp12_;
				GdkRectangle _tmp13_;
				gint o = 0;
				gint _tmp14_ = 0;
#line 181 "../libgitg/gitg-label-renderer.vala"
				_tmp10_ = layout;
#line 181 "../libgitg/gitg-label-renderer.vala"
				_tmp11_ = r;
#line 181 "../libgitg/gitg-label-renderer.vala"
				_tmp12_ = *area;
#line 181 "../libgitg/gitg-label-renderer.vala"
				_tmp13_ = *area;
#line 181 "../libgitg/gitg-label-renderer.vala"
				w = gitg_label_renderer_render_label (widget, context, _tmp10_, _tmp11_, (gdouble) ((gint) pos), (gdouble) _tmp12_.y, _tmp13_.height, TRUE);
#line 190 "../libgitg/gitg-label-renderer.vala"
				o = (w + (GITG_LABEL_RENDERER_padding * 2)) + GITG_LABEL_RENDERER_margin;
#line 191 "../libgitg/gitg-label-renderer.vala"
				if (rtl) {
#line 191 "../libgitg/gitg-label-renderer.vala"
					_tmp14_ = -o;
#line 596 "gitg-label-renderer.c"
				} else {
#line 191 "../libgitg/gitg-label-renderer.vala"
					_tmp14_ = o;
#line 600 "gitg-label-renderer.c"
				}
#line 191 "../libgitg/gitg-label-renderer.vala"
				pos += (gdouble) _tmp14_;
#line 179 "../libgitg/gitg-label-renderer.vala"
				_g_object_unref0 (r);
#line 606 "gitg-label-renderer.c"
			}
		}
	}
#line 194 "../libgitg/gitg-label-renderer.vala"
	cairo_restore (context);
#line 152 "../libgitg/gitg-label-renderer.vala"
	_g_object_unref0 (layout);
#line 152 "../libgitg/gitg-label-renderer.vala"
	_g_object_unref0 (ctx);
#line 616 "gitg-label-renderer.c"
}

GitgRef*
gitg_label_renderer_get_ref_at_pos (GtkWidget* widget,
                                    PangoFontDescription* font,
                                    GSList* labels,
                                    gint x,
                                    gint* hot_x)
{
	gint _vala_hot_x = 0;
	PangoContext* ctx = NULL;
	PangoContext* _tmp0_;
	PangoContext* _tmp1_;
	PangoLayout* layout = NULL;
	PangoContext* _tmp2_;
	PangoLayout* _tmp3_;
	PangoLayout* _tmp4_;
	gint start = 0;
	GitgRef* ret = NULL;
	GitgRef* result;
#line 197 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 197 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (font != NULL, NULL);
#line 203 "../libgitg/gitg-label-renderer.vala"
	_vala_hot_x = 0;
#line 205 "../libgitg/gitg-label-renderer.vala"
	if (labels == NULL) {
#line 207 "../libgitg/gitg-label-renderer.vala"
		result = NULL;
#line 207 "../libgitg/gitg-label-renderer.vala"
		if (hot_x) {
#line 207 "../libgitg/gitg-label-renderer.vala"
			*hot_x = _vala_hot_x;
#line 651 "gitg-label-renderer.c"
		}
#line 207 "../libgitg/gitg-label-renderer.vala"
		return result;
#line 655 "gitg-label-renderer.c"
	}
#line 210 "../libgitg/gitg-label-renderer.vala"
	_tmp0_ = gtk_widget_get_pango_context (widget);
#line 210 "../libgitg/gitg-label-renderer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 210 "../libgitg/gitg-label-renderer.vala"
	ctx = _tmp1_;
#line 211 "../libgitg/gitg-label-renderer.vala"
	_tmp2_ = ctx;
#line 211 "../libgitg/gitg-label-renderer.vala"
	_tmp3_ = pango_layout_new (_tmp2_);
#line 211 "../libgitg/gitg-label-renderer.vala"
	layout = _tmp3_;
#line 213 "../libgitg/gitg-label-renderer.vala"
	_tmp4_ = layout;
#line 213 "../libgitg/gitg-label-renderer.vala"
	pango_layout_set_font_description (_tmp4_, font);
#line 215 "../libgitg/gitg-label-renderer.vala"
	start = GITG_LABEL_RENDERER_margin;
#line 216 "../libgitg/gitg-label-renderer.vala"
	ret = NULL;
#line 677 "gitg-label-renderer.c"
	{
		GSList* r_collection = NULL;
		GSList* r_it = NULL;
#line 218 "../libgitg/gitg-label-renderer.vala"
		r_collection = labels;
#line 218 "../libgitg/gitg-label-renderer.vala"
		for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
#line 685 "gitg-label-renderer.c"
			GitgRef* _tmp5_;
			GitgRef* r = NULL;
#line 218 "../libgitg/gitg-label-renderer.vala"
			_tmp5_ = _g_object_ref0 ((GitgRef*) r_it->data);
#line 218 "../libgitg/gitg-label-renderer.vala"
			r = _tmp5_;
#line 692 "gitg-label-renderer.c"
			{
				gint width = 0;
				PangoLayout* _tmp6_;
				GitgRef* _tmp7_;
				gboolean _tmp8_ = FALSE;
#line 220 "../libgitg/gitg-label-renderer.vala"
				_tmp6_ = layout;
#line 220 "../libgitg/gitg-label-renderer.vala"
				_tmp7_ = r;
#line 220 "../libgitg/gitg-label-renderer.vala"
				width = gitg_label_renderer_get_label_width (_tmp6_, _tmp7_);
#line 222 "../libgitg/gitg-label-renderer.vala"
				if (x >= start) {
#line 222 "../libgitg/gitg-label-renderer.vala"
					_tmp8_ = x <= (start + width);
#line 708 "gitg-label-renderer.c"
				} else {
#line 222 "../libgitg/gitg-label-renderer.vala"
					_tmp8_ = FALSE;
#line 712 "gitg-label-renderer.c"
				}
#line 222 "../libgitg/gitg-label-renderer.vala"
				if (_tmp8_) {
#line 716 "gitg-label-renderer.c"
					GitgRef* _tmp9_;
					GitgRef* _tmp10_;
#line 224 "../libgitg/gitg-label-renderer.vala"
					_tmp9_ = r;
#line 224 "../libgitg/gitg-label-renderer.vala"
					_tmp10_ = _g_object_ref0 (_tmp9_);
#line 224 "../libgitg/gitg-label-renderer.vala"
					_g_object_unref0 (ret);
#line 224 "../libgitg/gitg-label-renderer.vala"
					ret = _tmp10_;
#line 225 "../libgitg/gitg-label-renderer.vala"
					_vala_hot_x = x - start;
#line 227 "../libgitg/gitg-label-renderer.vala"
					_g_object_unref0 (r);
#line 227 "../libgitg/gitg-label-renderer.vala"
					break;
#line 733 "gitg-label-renderer.c"
				}
#line 230 "../libgitg/gitg-label-renderer.vala"
				start += width + GITG_LABEL_RENDERER_margin;
#line 218 "../libgitg/gitg-label-renderer.vala"
				_g_object_unref0 (r);
#line 739 "gitg-label-renderer.c"
			}
		}
	}
#line 233 "../libgitg/gitg-label-renderer.vala"
	result = ret;
#line 233 "../libgitg/gitg-label-renderer.vala"
	_g_object_unref0 (layout);
#line 233 "../libgitg/gitg-label-renderer.vala"
	_g_object_unref0 (ctx);
#line 233 "../libgitg/gitg-label-renderer.vala"
	if (hot_x) {
#line 233 "../libgitg/gitg-label-renderer.vala"
		*hot_x = _vala_hot_x;
#line 753 "gitg-label-renderer.c"
	}
#line 233 "../libgitg/gitg-label-renderer.vala"
	return result;
#line 757 "gitg-label-renderer.c"
}

static guchar
gitg_label_renderer_convert_color_channel (guchar color,
                                           guchar alpha)
{
	gdouble _tmp0_ = 0.0;
	guchar result;
#line 239 "../libgitg/gitg-label-renderer.vala"
	if (((gint) alpha) != 0) {
#line 239 "../libgitg/gitg-label-renderer.vala"
		_tmp0_ = color / (alpha / 255.0);
#line 770 "gitg-label-renderer.c"
	} else {
#line 239 "../libgitg/gitg-label-renderer.vala"
		_tmp0_ = (gdouble) 0;
#line 774 "gitg-label-renderer.c"
	}
#line 239 "../libgitg/gitg-label-renderer.vala"
	result = (guchar) _tmp0_;
#line 239 "../libgitg/gitg-label-renderer.vala"
	return result;
#line 780 "gitg-label-renderer.c"
}

static void
gitg_label_renderer_convert_bgra_to_rgba (guchar* src,
                                          gint src_length1,
                                          guchar* dst,
                                          gint dst_length1,
                                          gint width,
                                          gint height)
{
	gint i = 0;
#line 247 "../libgitg/gitg-label-renderer.vala"
	i = 0;
#line 794 "gitg-label-renderer.c"
	{
		gint y = 0;
#line 249 "../libgitg/gitg-label-renderer.vala"
		y = 0;
#line 799 "gitg-label-renderer.c"
		{
			gboolean _tmp0_ = FALSE;
#line 249 "../libgitg/gitg-label-renderer.vala"
			_tmp0_ = TRUE;
#line 249 "../libgitg/gitg-label-renderer.vala"
			while (TRUE) {
#line 249 "../libgitg/gitg-label-renderer.vala"
				if (!_tmp0_) {
#line 808 "gitg-label-renderer.c"
					gint _tmp1_;
#line 249 "../libgitg/gitg-label-renderer.vala"
					y = y + 1;
#line 249 "../libgitg/gitg-label-renderer.vala"
					_tmp1_ = y;
#line 814 "gitg-label-renderer.c"
				}
#line 249 "../libgitg/gitg-label-renderer.vala"
				_tmp0_ = FALSE;
#line 249 "../libgitg/gitg-label-renderer.vala"
				if (!(y < height)) {
#line 249 "../libgitg/gitg-label-renderer.vala"
					break;
#line 822 "gitg-label-renderer.c"
				}
				{
					gint x = 0;
#line 251 "../libgitg/gitg-label-renderer.vala"
					x = 0;
#line 828 "gitg-label-renderer.c"
					{
						gboolean _tmp2_ = FALSE;
#line 251 "../libgitg/gitg-label-renderer.vala"
						_tmp2_ = TRUE;
#line 251 "../libgitg/gitg-label-renderer.vala"
						while (TRUE) {
#line 835 "gitg-label-renderer.c"
							guchar _tmp4_;
							guchar _tmp5_;
							guchar _tmp6_;
							guchar _tmp7_;
							guchar _tmp8_;
							guchar _tmp9_;
							guchar _tmp10_;
#line 251 "../libgitg/gitg-label-renderer.vala"
							if (!_tmp2_) {
#line 845 "gitg-label-renderer.c"
								gint _tmp3_;
#line 251 "../libgitg/gitg-label-renderer.vala"
								x = x + 1;
#line 251 "../libgitg/gitg-label-renderer.vala"
								_tmp3_ = x;
#line 851 "gitg-label-renderer.c"
							}
#line 251 "../libgitg/gitg-label-renderer.vala"
							_tmp2_ = FALSE;
#line 251 "../libgitg/gitg-label-renderer.vala"
							if (!(x < width)) {
#line 251 "../libgitg/gitg-label-renderer.vala"
								break;
#line 859 "gitg-label-renderer.c"
							}
#line 253 "../libgitg/gitg-label-renderer.vala"
							_tmp4_ = src[i + 2];
#line 253 "../libgitg/gitg-label-renderer.vala"
							_tmp5_ = src[i + 3];
#line 253 "../libgitg/gitg-label-renderer.vala"
							dst[i] = gitg_label_renderer_convert_color_channel (_tmp4_, _tmp5_);
#line 254 "../libgitg/gitg-label-renderer.vala"
							_tmp6_ = src[i + 1];
#line 254 "../libgitg/gitg-label-renderer.vala"
							_tmp7_ = src[i + 3];
#line 254 "../libgitg/gitg-label-renderer.vala"
							dst[i + 1] = gitg_label_renderer_convert_color_channel (_tmp6_, _tmp7_);
#line 255 "../libgitg/gitg-label-renderer.vala"
							_tmp8_ = src[i];
#line 255 "../libgitg/gitg-label-renderer.vala"
							_tmp9_ = src[i + 3];
#line 255 "../libgitg/gitg-label-renderer.vala"
							dst[i + 2] = gitg_label_renderer_convert_color_channel (_tmp8_, _tmp9_);
#line 256 "../libgitg/gitg-label-renderer.vala"
							_tmp10_ = src[i + 3];
#line 256 "../libgitg/gitg-label-renderer.vala"
							dst[i + 3] = _tmp10_;
#line 258 "../libgitg/gitg-label-renderer.vala"
							i += 4;
#line 885 "gitg-label-renderer.c"
						}
					}
				}
			}
		}
	}
}

static guchar*
_vala_array_dup17 (guchar* self,
                   gssize length)
{
#line 284 "../libgitg/gitg-label-renderer.vala"
	if (length > 0) {
#line 284 "../libgitg/gitg-label-renderer.vala"
		return g_memdup2 (self, length * sizeof (guchar));
#line 902 "gitg-label-renderer.c"
	}
#line 284 "../libgitg/gitg-label-renderer.vala"
	return NULL;
#line 906 "gitg-label-renderer.c"
}

static guint8*
_vala_array_dup18 (guint8* self,
                   gssize length)
{
#line 292 "../libgitg/gitg-label-renderer.vala"
	if (length > 0) {
#line 292 "../libgitg/gitg-label-renderer.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 917 "gitg-label-renderer.c"
	}
#line 292 "../libgitg/gitg-label-renderer.vala"
	return NULL;
#line 921 "gitg-label-renderer.c"
}

GdkPixbuf*
gitg_label_renderer_render_ref (GtkWidget* widget,
                                PangoFontDescription* font,
                                GitgRef* r,
                                gint height,
                                gint minwidth)
{
	PangoContext* ctx = NULL;
	PangoContext* _tmp0_;
	PangoContext* _tmp1_;
	PangoLayout* layout = NULL;
	PangoLayout* _tmp2_;
	gint width = 0;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp3_;
	cairo_t* context = NULL;
	cairo_t* _tmp4_;
	guchar* data = NULL;
	guchar* _tmp5_;
	guchar* _tmp6_;
	gint _tmp6__length1;
	gint data_length1;
	gint _data_size_;
	GdkPixbuf* ret = NULL;
	GdkPixbuf* _tmp7_;
	guint8* pixdata = NULL;
	guint8* _tmp8_;
	guint8* _tmp9_;
	gint _tmp9__length1;
	gint pixdata_length1;
	gint _pixdata_size_;
	GdkPixbuf* result;
#line 263 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 263 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (font != NULL, NULL);
#line 263 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 269 "../libgitg/gitg-label-renderer.vala"
	_tmp0_ = gtk_widget_get_pango_context (widget);
#line 269 "../libgitg/gitg-label-renderer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 269 "../libgitg/gitg-label-renderer.vala"
	ctx = _tmp1_;
#line 270 "../libgitg/gitg-label-renderer.vala"
	_tmp2_ = pango_layout_new (ctx);
#line 270 "../libgitg/gitg-label-renderer.vala"
	layout = _tmp2_;
#line 272 "../libgitg/gitg-label-renderer.vala"
	pango_layout_set_font_description (layout, font);
#line 274 "../libgitg/gitg-label-renderer.vala"
	width = MAX (gitg_label_renderer_get_label_width (layout, r), minwidth);
#line 276 "../libgitg/gitg-label-renderer.vala"
	_tmp3_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, width + 2, height + 2);
#line 276 "../libgitg/gitg-label-renderer.vala"
	surface = _tmp3_;
#line 280 "../libgitg/gitg-label-renderer.vala"
	_tmp4_ = cairo_create (surface);
#line 280 "../libgitg/gitg-label-renderer.vala"
	context = _tmp4_;
#line 281 "../libgitg/gitg-label-renderer.vala"
	cairo_set_line_width (context, (gdouble) 1);
#line 283 "../libgitg/gitg-label-renderer.vala"
	gitg_label_renderer_render_label (widget, context, layout, r, (gdouble) 1, (gdouble) 1, height, FALSE);
#line 284 "../libgitg/gitg-label-renderer.vala"
	_tmp5_ = cairo_image_surface_get_data (surface);
#line 284 "../libgitg/gitg-label-renderer.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup17 (_tmp5_, -1) : _tmp5_;
#line 284 "../libgitg/gitg-label-renderer.vala"
	_tmp6__length1 = -1;
#line 284 "../libgitg/gitg-label-renderer.vala"
	data = _tmp6_;
#line 284 "../libgitg/gitg-label-renderer.vala"
	data_length1 = _tmp6__length1;
#line 284 "../libgitg/gitg-label-renderer.vala"
	_data_size_ = data_length1;
#line 286 "../libgitg/gitg-label-renderer.vala"
	_tmp7_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, width + 2, height + 2);
#line 286 "../libgitg/gitg-label-renderer.vala"
	ret = _tmp7_;
#line 292 "../libgitg/gitg-label-renderer.vala"
	_tmp8_ = gdk_pixbuf_get_pixels (ret);
#line 292 "../libgitg/gitg-label-renderer.vala"
	_tmp9_ = (_tmp8_ != NULL) ? _vala_array_dup18 (_tmp8_, -1) : _tmp8_;
#line 292 "../libgitg/gitg-label-renderer.vala"
	_tmp9__length1 = -1;
#line 292 "../libgitg/gitg-label-renderer.vala"
	pixdata = _tmp9_;
#line 292 "../libgitg/gitg-label-renderer.vala"
	pixdata_length1 = _tmp9__length1;
#line 292 "../libgitg/gitg-label-renderer.vala"
	_pixdata_size_ = pixdata_length1;
#line 293 "../libgitg/gitg-label-renderer.vala"
	gitg_label_renderer_convert_bgra_to_rgba (data, (gint) data_length1, pixdata, (gint) pixdata_length1, width + 2, height + 2);
#line 295 "../libgitg/gitg-label-renderer.vala"
	result = ret;
#line 295 "../libgitg/gitg-label-renderer.vala"
	pixdata = (g_free (pixdata), NULL);
#line 295 "../libgitg/gitg-label-renderer.vala"
	data = (g_free (data), NULL);
#line 295 "../libgitg/gitg-label-renderer.vala"
	_cairo_destroy0 (context);
#line 295 "../libgitg/gitg-label-renderer.vala"
	_cairo_surface_destroy0 (surface);
#line 295 "../libgitg/gitg-label-renderer.vala"
	_g_object_unref0 (layout);
#line 295 "../libgitg/gitg-label-renderer.vala"
	_g_object_unref0 (ctx);
#line 295 "../libgitg/gitg-label-renderer.vala"
	return result;
#line 1034 "gitg-label-renderer.c"
}

GitgLabelRenderer*
gitg_label_renderer_construct (GType object_type)
{
	GitgLabelRenderer* self = NULL;
#line 22 "../libgitg/gitg-label-renderer.vala"
	self = (GitgLabelRenderer*) g_type_create_instance (object_type);
#line 22 "../libgitg/gitg-label-renderer.vala"
	return self;
#line 1045 "gitg-label-renderer.c"
}

GitgLabelRenderer*
gitg_label_renderer_new (void)
{
#line 22 "../libgitg/gitg-label-renderer.vala"
	return gitg_label_renderer_construct (GITG_TYPE_LABEL_RENDERER);
#line 1053 "gitg-label-renderer.c"
}

static void
gitg_value_label_renderer_init (GValue* value)
{
#line 22 "../libgitg/gitg-label-renderer.vala"
	value->data[0].v_pointer = NULL;
#line 1061 "gitg-label-renderer.c"
}

static void
gitg_value_label_renderer_free_value (GValue* value)
{
#line 22 "../libgitg/gitg-label-renderer.vala"
	if (value->data[0].v_pointer) {
#line 22 "../libgitg/gitg-label-renderer.vala"
		gitg_label_renderer_unref (value->data[0].v_pointer);
#line 1071 "gitg-label-renderer.c"
	}
}

static void
gitg_value_label_renderer_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 22 "../libgitg/gitg-label-renderer.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "../libgitg/gitg-label-renderer.vala"
		dest_value->data[0].v_pointer = gitg_label_renderer_ref (src_value->data[0].v_pointer);
#line 1083 "gitg-label-renderer.c"
	} else {
#line 22 "../libgitg/gitg-label-renderer.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1087 "gitg-label-renderer.c"
	}
}

static gpointer
gitg_value_label_renderer_peek_pointer (const GValue* value)
{
#line 22 "../libgitg/gitg-label-renderer.vala"
	return value->data[0].v_pointer;
#line 1096 "gitg-label-renderer.c"
}

static gchar*
gitg_value_label_renderer_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 22 "../libgitg/gitg-label-renderer.vala"
	if (collect_values[0].v_pointer) {
#line 1107 "gitg-label-renderer.c"
		GitgLabelRenderer * object;
		object = collect_values[0].v_pointer;
#line 22 "../libgitg/gitg-label-renderer.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "../libgitg/gitg-label-renderer.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1114 "gitg-label-renderer.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "../libgitg/gitg-label-renderer.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1118 "gitg-label-renderer.c"
		}
#line 22 "../libgitg/gitg-label-renderer.vala"
		value->data[0].v_pointer = gitg_label_renderer_ref (object);
#line 1122 "gitg-label-renderer.c"
	} else {
#line 22 "../libgitg/gitg-label-renderer.vala"
		value->data[0].v_pointer = NULL;
#line 1126 "gitg-label-renderer.c"
	}
#line 22 "../libgitg/gitg-label-renderer.vala"
	return NULL;
#line 1130 "gitg-label-renderer.c"
}

static gchar*
gitg_value_label_renderer_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	GitgLabelRenderer ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "../libgitg/gitg-label-renderer.vala"
	if (!object_p) {
#line 22 "../libgitg/gitg-label-renderer.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1145 "gitg-label-renderer.c"
	}
#line 22 "../libgitg/gitg-label-renderer.vala"
	if (!value->data[0].v_pointer) {
#line 22 "../libgitg/gitg-label-renderer.vala"
		*object_p = NULL;
#line 1151 "gitg-label-renderer.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "../libgitg/gitg-label-renderer.vala"
		*object_p = value->data[0].v_pointer;
#line 1155 "gitg-label-renderer.c"
	} else {
#line 22 "../libgitg/gitg-label-renderer.vala"
		*object_p = gitg_label_renderer_ref (value->data[0].v_pointer);
#line 1159 "gitg-label-renderer.c"
	}
#line 22 "../libgitg/gitg-label-renderer.vala"
	return NULL;
#line 1163 "gitg-label-renderer.c"
}

GParamSpec*
gitg_param_spec_label_renderer (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	GitgParamSpecLabelRenderer* spec;
#line 22 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GITG_TYPE_LABEL_RENDERER), NULL);
#line 22 "../libgitg/gitg-label-renderer.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "../libgitg/gitg-label-renderer.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "../libgitg/gitg-label-renderer.vala"
	return G_PARAM_SPEC (spec);
#line 1182 "gitg-label-renderer.c"
}

gpointer
gitg_value_get_label_renderer (const GValue* value)
{
#line 22 "../libgitg/gitg-label-renderer.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_LABEL_RENDERER), NULL);
#line 22 "../libgitg/gitg-label-renderer.vala"
	return value->data[0].v_pointer;
#line 1192 "gitg-label-renderer.c"
}

void
gitg_value_set_label_renderer (GValue* value,
                               gpointer v_object)
{
	GitgLabelRenderer * old;
#line 22 "../libgitg/gitg-label-renderer.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_LABEL_RENDERER));
#line 22 "../libgitg/gitg-label-renderer.vala"
	old = value->data[0].v_pointer;
#line 22 "../libgitg/gitg-label-renderer.vala"
	if (v_object) {
#line 22 "../libgitg/gitg-label-renderer.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_LABEL_RENDERER));
#line 22 "../libgitg/gitg-label-renderer.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../libgitg/gitg-label-renderer.vala"
		value->data[0].v_pointer = v_object;
#line 22 "../libgitg/gitg-label-renderer.vala"
		gitg_label_renderer_ref (value->data[0].v_pointer);
#line 1214 "gitg-label-renderer.c"
	} else {
#line 22 "../libgitg/gitg-label-renderer.vala"
		value->data[0].v_pointer = NULL;
#line 1218 "gitg-label-renderer.c"
	}
#line 22 "../libgitg/gitg-label-renderer.vala"
	if (old) {
#line 22 "../libgitg/gitg-label-renderer.vala"
		gitg_label_renderer_unref (old);
#line 1224 "gitg-label-renderer.c"
	}
}

void
gitg_value_take_label_renderer (GValue* value,
                                gpointer v_object)
{
	GitgLabelRenderer * old;
#line 22 "../libgitg/gitg-label-renderer.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GITG_TYPE_LABEL_RENDERER));
#line 22 "../libgitg/gitg-label-renderer.vala"
	old = value->data[0].v_pointer;
#line 22 "../libgitg/gitg-label-renderer.vala"
	if (v_object) {
#line 22 "../libgitg/gitg-label-renderer.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GITG_TYPE_LABEL_RENDERER));
#line 22 "../libgitg/gitg-label-renderer.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../libgitg/gitg-label-renderer.vala"
		value->data[0].v_pointer = v_object;
#line 1245 "gitg-label-renderer.c"
	} else {
#line 22 "../libgitg/gitg-label-renderer.vala"
		value->data[0].v_pointer = NULL;
#line 1249 "gitg-label-renderer.c"
	}
#line 22 "../libgitg/gitg-label-renderer.vala"
	if (old) {
#line 22 "../libgitg/gitg-label-renderer.vala"
		gitg_label_renderer_unref (old);
#line 1255 "gitg-label-renderer.c"
	}
}

static void
gitg_label_renderer_class_init (GitgLabelRendererClass * klass,
                                gpointer klass_data)
{
#line 22 "../libgitg/gitg-label-renderer.vala"
	gitg_label_renderer_parent_class = g_type_class_peek_parent (klass);
#line 22 "../libgitg/gitg-label-renderer.vala"
	((GitgLabelRendererClass *) klass)->finalize = gitg_label_renderer_finalize;
#line 1267 "gitg-label-renderer.c"
}

static void
gitg_label_renderer_instance_init (GitgLabelRenderer * self,
                                   gpointer klass)
{
#line 22 "../libgitg/gitg-label-renderer.vala"
	self->ref_count = 1;
#line 1276 "gitg-label-renderer.c"
}

static void
gitg_label_renderer_finalize (GitgLabelRenderer * obj)
{
	GitgLabelRenderer * self;
#line 22 "../libgitg/gitg-label-renderer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GITG_TYPE_LABEL_RENDERER, GitgLabelRenderer);
#line 22 "../libgitg/gitg-label-renderer.vala"
	g_signal_handlers_destroy (self);
#line 1287 "gitg-label-renderer.c"
}

 G_GNUC_NO_INLINE static GType
gitg_label_renderer_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { gitg_value_label_renderer_init, gitg_value_label_renderer_free_value, gitg_value_label_renderer_copy_value, gitg_value_label_renderer_peek_pointer, "p", gitg_value_label_renderer_collect_value, "p", gitg_value_label_renderer_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (GitgLabelRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gitg_label_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GitgLabelRenderer), 0, (GInstanceInitFunc) gitg_label_renderer_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType gitg_label_renderer_type_id;
	gitg_label_renderer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GitgLabelRenderer", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return gitg_label_renderer_type_id;
}

GType
gitg_label_renderer_get_type (void)
{
	static gsize gitg_label_renderer_type_id__once = 0;
	if (g_once_init_enter (&gitg_label_renderer_type_id__once)) {
		GType gitg_label_renderer_type_id;
		gitg_label_renderer_type_id = gitg_label_renderer_get_type_once ();
		g_once_init_leave (&gitg_label_renderer_type_id__once, gitg_label_renderer_type_id);
	}
	return gitg_label_renderer_type_id__once;
}

gpointer
gitg_label_renderer_ref (gpointer instance)
{
	GitgLabelRenderer * self;
	self = instance;
#line 22 "../libgitg/gitg-label-renderer.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "../libgitg/gitg-label-renderer.vala"
	return instance;
#line 1322 "gitg-label-renderer.c"
}

void
gitg_label_renderer_unref (gpointer instance)
{
	GitgLabelRenderer * self;
	self = instance;
#line 22 "../libgitg/gitg-label-renderer.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "../libgitg/gitg-label-renderer.vala"
		GITG_LABEL_RENDERER_GET_CLASS (self)->finalize (self);
#line 22 "../libgitg/gitg-label-renderer.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1336 "gitg-label-renderer.c"
	}
}

